2003-12-19  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	Adfd m32r-linux and PIC support.  Add new ABI that uses RELA.
	* config.bfd (m32r*-*-linux*, m32r*le-*-linux*, m32r*le-*-*): Added.
	* configure.in (bfd_elf32_m32rlin_vec, bfd_elf32_m32rlelin_vec,
	bfd_elf32_m32rle_vec): Added
	* configure: Regenerated.
	* elf32-m32r.c (m32r_info_to_howto, m32r_elf_adjust_dynamic_symbol,
	m32r_elf_size_dynamic_sections, m32r_elf_create_dynamic_sections,
	m32r_elf_finish_dynamic_sections, m32r_elf_finish_dynamic_symbol,
	allocate_dynrelocs, readonly_dynrelocs, m32r_elf_reloc_type_class,
	m32r_elf_fake_sections): Added.
	(m32r_elf_howto_table): Added
	R_M32R_16_RELA, R_M32R_32_RELA, R_M32R_24_RELA,
	R_M32R_10_PCREL_RELA, R_M32R_18_PCREL_RELA,
	R_M32R_26_PCREL_RELA, R_M32R_HI16_ULO_RELA,
	R_M32R_HI16_SLO_RELA, R_M32R_LO16_RELA,
	R_M32R_SDA16_RELA, R_M32R_RELA_GNU_VTINHERIT,
	R_M32R_RELA_GNU_VTENTRY, R_M32R_GOT24,
	R_M32R_26_PLTREL, R_M32R_COPY, R_M32R_GLOB_DAT,
	R_M32R_JMP_SLOT, R_M32R_RELATIVE, R_M32R_GOTOFF,
	R_M32R_GOTPC24, R_M32R_GOT16_HI_ULO,
	R_M32R_GOT16_HI_SLO, R_M32R_GOT16_LO,
	R_M32R_GOTPC_HI_ULO, R_M32R_GOTPC_HI_SLO,
	R_M32R_GOTPC_LO.
	(m32r_elf_relocate_section, m32r_elf_check_relocs): Changed for
	New ABI.
	* reloc.c: Add BFD_RELOC_M32R_GOT24, BFD_RELOC_M32R_26_PLTREL,
	BFD_RELOC_M32R_COPY, BFD_RELOC_M32R_GLOB_DAT,
	BFD_RELOC_M32R_JMP_SLOT, BFD_RELOC_M32R_RELATIVE,
	BFD_RELOC_M32R_GOTOFF, BFD_RELOC_M32R_GOTPC24,
	BFD_RELOC_M32R_GOT16_HI_ULO, BFD_RELOC_M32R_GOT16_HI_SLO,
	BFD_RELOC_M32R_GOT16_LO, BFD_RELOC_M32R_GOTPC_HI_ULO,
	BFD_RELOC_M32R_GOTPC_HI_SLO, BFD_RELOC_M32R_GOTPC_LO.
	* targets.c (bfd_elf32_m32rlin_vec, bfd_elf32_m32rlelin_vec,
	bfd_elf32_m32rle_vec): Added.
	* bfd-in2.h: Regenerated.
	* libbfd.h: Regenerated.

2003-12-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* coffcode.h (styp_to_sec_flags): Don't treat .reloc section
	as SEC_DEBUGGING.

2003-12-18  Richard Sandiford  <rsandifo@redhat.com>

	* elf32-mips.c (elf_mips_howto_table_rel): Replace all uses of
	mips_elf_generic_reloc with _bfd_mips_elf_generic_reloc.  Use
	_bfd_mips_elf_hi16_reloc for R_MIPS_HI16 and R_MIPS_GNU_REL_HI16,
	_bfd_mips_elf_lo16_reloc for R_MIPS_LO16 and R_MIPS_GNU_REL_LO16,
	and _bfd_mips_elf_got16_reloc for R_MIPS_GOT16.  Change rightshift
	to 16 for R_MIPS_HI16 and R_MIPS_GNU_REL_HI16.
	(mips_elf_generic_reloc, struct mips_hi16, mips_elf_hi16_reloc)
	(mips_elf_lo16_reloc, mips_elf_got16_reloc): Delete.
	(_bfd_mips_elf32_gprel16_reloc): Remove special case.
	(mips_elf_gprel32_reloc, mips32_64bit_reloc): Likewise.

	* elf64-mips.c (mips_elf64_howto_table_rel): Replace all uses of
	mips_elf_generic_reloc with _bfd_mips_elf_generic_reloc.  Use
	_bfd_mips_elf_hi16_reloc for R_MIPS_HI16, _bfd_mips_elf_lo16_reloc
	for R_MIPS_LO16 and _bfd_mips_elf_got16_reloc for R_MIPS_GOT16.
	Change R_MIPS_HI16's rightshift to 16.
	(mips_elf64_howto_table_rela): Replace all uses of
	mips_elf_generic_reloc with _bfd_mips_elf_generic_reloc.
	Use _bfd_mips_elf_generic_reloc for R_MIPS_GOT16 as well.
	(mips_elf64_hi16_reloc, mips_elf64_got16_reloc): Delete.
	(mips_elf64_shift6_reloc): Remove special case.  Use
	_bfd_mips_elf_generic_reloc instead of returning bfd_reloc_continue.

	* elfn32-mips.c (prev_reloc_section): Delete.
	(prev_reloc_address, prev_reloc_addend): Delete.
	(elf_mips_howto_table_rel, elf_mips_howto_table_rela): As for
	elf64-mips.c
	(GET_RELOC_ADDEND, SET_RELOC_ADDEND): Delete.
	(mips_elf_generic_reloc, struct mips_hi16, mips_elf_hi16_reloc)
	(mips_elf_lo16_reloc, mips_elf_got16_reloc): Delete.
	(mips_elf_gprel16_reloc): Delete use of GET_RELOC_ADDEND.
	(mips_elf_literal_reloc, mips_elf_gprel32_reloc): Likewise.
	(mips16_jump_reloc, mips16_gprel_reloc): Likewise.
	(mips_elf_shift6_reloc): Likewise.  Delete use of SET_RELOC_ADDEND.

	* elfxx-mips.c (_bfd_mips_elf_gprel16_with_gp): Use
	_bfd_relocate_contents to install an in-place addend.
	(mips_hi16): New structure.
	(mips_hi16_list): Moved from elf32-mips.c.
	(_bfd_mips_elf_hi16_reloc, _bfd_mips_elf_got16_reloc): New functions.
	(_bfd_mips_elf_lo16_reloc, _bfd_mips_elf_generic_reloc): New functions.
	(mips_elf_calculate_relocation): Assume addend is unshifted.
	(_bfd_mips_elf_relocate_section): Don't apply the howto rightshift
	on top of the usual high-part shift.  Don't shift the addend right
	before calling mips_elf_calculate_relocation.

	* elfxx-mips.h (_bfd_mips_elf_hi16_reloc): Declare.
	(_bfd_mips_elf_got16_reloc, _bfd_mips_elf_lo16_reloc): Declare.
	(_bfd_mips_elf_generic_reloc): Declare.

2003-12-16  Eric Youngdale  <eric@mkssoftware.com>
	    Nick Clifton  <nickc@redhat.com>

	* peicode.h (pe_ILF_build_a_bfd): Only skip one instance of each
	prefix character, if they are present.

2003-12-15  Dmitry Semyonov  <Dmitry.Semyonov@oktet.ru>
	    Nick Clifton  <nickc@redhat.com>

	* peXXigen.c (_bfd_XXi_swap_scnhdr_out): Ensure that correct flags
	are set on known section types.

2003-12-12  Nick Clifton  <nickc@redhat.com>

	* po/ro.po: Updated translation.

2003-12-12  Alan Modra  <amodra@bigpond.net.au>

	* elf64-hppa.c (elf64_hppa_link_output_symbol_hook): Check for
	NULL dyn_h.

2003-12-11  Nick Clifton  <nickc@redhat.com>

	* elf.c (INCLUDE_SECTION_IN_SEGMENT): Skip PT_GNU_STACK segments.

2003-12-08  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.h, elfxx-mips.c, cpu-mips.c: Convert prototypes.
	Remove casts that were only needed for K&R compatibility.

2003-12-08  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct elf_backend_data): Remove "bfd *" and add
	"elflink_hash_entry *" param to elf_backend_link_output_symbol_hook.
	Add "elflink_hash_entry *" param to elf_backend_output_arch_syms.
	* elflink.h (elf_link_output_sym): Add "elflink_hash_entry *" param,
	and pass to output_symbol_hook.
	(elf_bfd_final_link): Adjust elf_link_output_sym calls.
	(elf_link_output_extsym): Likewise.
	(elf_link_input_bfd): Likewise.
	* elf32-sh64.c (sh64_elf_link_output_symbol_hook): Adjust.
	* elf32-v850.c (v850_elf_link_output_symbol_hook): Likewise.
	* elf64-mmix.c (mmix_elf_link_output_symbol_hook): Likewise.
	* elf64-sh64.c (sh64_elf64_link_output_symbol_hook): Likewise.
	* elfxx-mips.c (_bfd_mips_elf_link_output_symbol_hook): Likewise.
	* elfxx-mips.h (_bfd_mips_elf_link_output_symbol_hook): Likewise.
	* elf64-sparc.c (sparc64_elf_output_arch_syms): Likewise.
	* elf64-hppa.c (elf64_hppa_link_output_symbol_hook): Likewise.
	Validate dynh->h against h.
	* elf64-ppc.c (struct ppc_link_hash_entry): Add adjust_done bitfield.
	(link_hash_newfunc): Init it.
	(adjust_opd_syms): New function.
	(ppc64_elf_edit_opd): Set adjust_done when global .opd sym adjusted.
	Set opd.adjust for all .opd relocs.  Call adjust_opd_syms.
	(ppc64_elf_tls_optimize): Adjust possible .opd sym values here.
	(ppc64_elf_relocate_section): Also adjust syms not a multiple of 24.
	(ppc64_elf_output_symbol_hook): New function.
	(elf_backend_link_output_symbol_hook): Define.

2003-12-07  Richard Sandiford  <rsandifo@redhat.com>

	* elf32-mips.c, elfn32-mips.c, elf64-mips.c: Convert prototypes.
	Remove casts that were only needed for K&R compatibility.

2003-12-05  Dmitry Semyonov  <Dmitry.Semyonov@oktet.ru>

	* coff-arm.c (aoutarm_std_reloc_howto [ARM_WINCE]): Set
	partial_inplace for these relocs to FALSE for comptability with
	the MS linker.
	Remap ARM_26D relocation from 5 to 0. This fixes "bad fixup" error
	generated by MS linker, and brings the relocation in line the MS
	PE documentation.

2003-12-04  H.J. Lu  <hongjiu.lu@intel.com>

	* elf32-ppc.c (ppc_elf_relax_section): Don't check relax_finalizing.

2003-12-04  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Use the
	need_relax_finalize field in link_info instead of
	relax_finalizing to check if the relax finalize pass is being
	done.

2003-12-04  Dmitry Semyonov  <Dmitry.Semyonov@oktet.ru>

	* coff-arm.c (coff_arm_relocate_section, bfd_arm_process_before_allocation):
	Change ARM26* to ARM_26* in comments to match definitions.
	(coff_arm_adjust_symndx): Replace hard-coded constants with
	appropriate definitions (ARM_26*).

2003-12-04  Alan Modra  <amodra@bigpond.net.au>

	* coff-i860.c (coff_i860_reloc_nyi): Return bfd_reloc_not_supported.
	* elf-m10300.c (elf32_mn10300_finish_hash_table_entry): Warning fixes.
	(mn10300_elf_relax_section): Likewise.
	* nlm32-alpha.c (ONES): Define.
	(nlm32_alpha_howto_table): Use it to avoid warnings.

2003-12-04  Alan Modra  <amodra@bigpond.net.au>

	* elf32-i386.c (elf_i386_object_p): Delete.
	(elf_backend_object_p): Don't define.
	* elf32-s390.c (elf_s390_object_p): No need to alloc tdata here.
	* elf32-sh.c (sh_elf_object_p): Likewise.
	* elf32-sparc.c (elf32_sparc_object_p): Likewise.
	* elf64-alpha.c (elf64_alpha_object_p): Likewise.
	* elf64-s390.c (elf_s390_object_p): Likewise.
	* elf64-x86-64.c (elf64_x86_64_elf_object_p): Likewise.

2003-12-03  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* archures.c (bfd_mach_m32r2): Add new machine type.
	* bfd-in2.h: Regenerate.
	* cpu-m32r.c : Add new machine type.
	* elf32-m32r.c (m32r_elf_object_p, m32r_elf_final_write_processing,
	m32r_elf_merge_private_bfd_data): Add support for new machine
	type.

2003-12-03  Dave Airlie  <airlied@linux.ie>

	* config.bfd: Add vax-linux-gnu target.
	* configure.in: Likewise.
	* configure: Regenerate.

2003-12-03  Alan Modra  <amodra@bigpond.net.au>

	* ecoff.c (ecoff_link_add_archive_symbols): Update for renamed
	bfd_link_hash_entry field "next" -> "und_next".
	* linker.c (_bfd_link_hash_newfunc): Likewise.
	(bfd_link_add_undef): Likewise.
	(_bfd_generic_link_add_archive_symbols): Likewise.
	(_bfd_generic_link_add_one_symbol): Likewise.
	* xcofflink.c (xcoff_link_add_symbols): Likewise.

2003-12-02  Nick Clifton  <nickc@redhat.com>

	* configure.in (ALL_LINGUAS): Add ro.
	* po/ro.po: New Romanian translation.

2003-12-02  Alan Modra  <amodra@bigpond.net.au>

	* Makefile.am: Run "make dep-am".
	* Makefile.in: Regenerate.

2003-12-01  Dmitry Semyonov  <Dmitry.Semyonov@oktet.ru>

	* coffcode.h (coff_compute_section_file_positions): Set page_size
	to 1 instead of 0 in the case file alignment value is zero.

2003-12-01  Kazu Hirata  <kazu@cs.umass.edu>

	* coff-rs6000.c: Remove ARGSUSED and VARARGS.
	* coff64-rs6000.c: Likewise.
	* coffcode.h: Likewise.
	* elf32-vax.c: Likewise.
	* hash.c: Likewise.
	* hppabsd-core.c: Likewise.
	* hpux-core.c: Likewise.
	* ihex.c: Likewise.
	* netbsd-core.c: Likewise.
	* osf-core.c: Likewise.
	* pdp11.c: Likewise.
	* ptrace-core.c: Likewise.
	* sco5-core.c: Likewise.
	* section.c: Likewise.
	* sunos.c: Likewise.
	* trad-core.c: Likewise.

2003-12-01  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (is_elf_hash_table): Take hash tab rather than info arg.
	* elf.c (_bfd_elf_merge_sections): Adjust to suit.
	(_bfd_elf_link_just_syms): Likewise.
	(bfd_elf_get_needed_list): Likewise.
	(bfd_elf_get_runpath_list): Likewise.
	(_bfd_elf_link_hash_copy_indirect): Remove unneeded parens.
	* elf32-hppa.c (elf32_hppa_setup_section_lists): Don't check hash tab
	creator flavour.
	(elf32_hppa_set_gp): Look up output sections rather than using htab.
	* elf32-i960.c: Comment fix.  Formatting.
	* elf32-m32r.c (m32r_elf_add_symbol_hook): Use is_elf_hash_table
	rather than testing creator flavour.
	* elf32-sh64.c (sh64_elf_add_symbol_hook): Likewise.
	* elf64-sh64.c (sh64_elf64_add_symbol_hook): Likewise.
	* elflink.c (_bfd_elf_link_create_dynamic_sections): Adjust for
	is_elf_hash_table change.  Remove redundant test.
	(bfd_elf_record_link_assignment): Use is_elf_hash_table rather than
	testing creator flavour.
	(elf_link_record_local_dynamic_symbol): Adjust for is_elf_hash_table.
	(_bfd_elf_fix_symbol_flags): Likewise.
	(_bfd_elf_adjust_dynamic_symbol): Likewise.
	* elflink.h (elf_link_add_object_symbols): Likewise.  Remove redundant
	checks.  Use is_elf_hash_table rather than testing creator flavour.
	Use hash_table throughout in place of info->hash.
	(elf_add_dynamic_entry): Adjust for is_elf_hash_table change.
	(NAME(bfd_elf,size_dynamic_sections)): Likewise.  Remove redundant
	check.
	(elf_bfd_final_link): Adjust for is_elf_hash_table change.
	(elf_link_check_versioned_symbol): Use is_elf_hash_table rather than
	testing creator flavour.
	(elf_gc_sections): Add is_elf_hash_table check.
	(elf_gc_common_finalize_got_offsets): Likewise.
	(elf_bfd_discard_info): Adjust for is_elf_hash_table change.  Remove
	redundant check.
	* elfxx-ia64.c (elfNN_ia64_relax_section): Use is_elf_hash_table
	rather than testing creator flavour.

2003-11-28  Christian Groessler  <chris@groessler.org>

	* cpu-z8k.c: Convert to ISO C90.
	* coff-z8k.c: Likewise.

2003-11-27  Alexandre Oliva  <aoliva@redhat.com>

	* elf-bfd.h (elf_backend_data::elf_backend_modify_segment_map):
	Add link info argument.
	* elf32-i370.c (elf_backend_modify_segment_map): Likewise.
	* elf32-ppc.c (ppc_elf_modify_segment_map): Likewise.
	* elf32-xtensa.c (elf_xtensa_modify_segment_map): Likewise.
	* elf64-hppa.c (elf64_hppa_modify_segment_map): Likewise.
	* elfxx-ia64.c (elfNN_ia64_modify_segment_map): Likewise.
	* elfxx-mips.c (_bfd_mips_elf_modify_segment_map): Likewise.
	* elfxx-mips.h (_bfd_mips_elf_modify_segment_map): Likewise.
	* elf.c (assign_file_positions_except_relocs,
	assign_file_positions_for_segments): Likewise.  Adjust calls.

2003-11-27  Mark Kettenis  <kettenis@gnu.org>

	* elf.c (elfcore_grok_netbsd_procinfo): Make a pseudosection out
	of the note.

2003-11-26  Daniel Jacobowitz  <drow@mvista.com>
	    Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_set_global_got_offset): Don't set no_fn_stub.
	(mips_elf_set_no_stub): New function.
	(mips_elf_multi_got): Call it.
	(_bfd_mips_elf_finish_dynamic_symbol): If a relocation is needed for
	a secondary GOT entry, create an R_MIPS_32 or R_MIPS_64 relocation and
	use mips_elf_create_dynamic_relocation to deal with any compatibility
	issues.  Store the adjusted addend in the GOT slot.

2003-11-25  Mattias Engdegård  <mattias@virtutech.se>

	* stabs.c (_bfd_link_section_stabs): Skip N_EXCL stabs when
	procesing N_BINCL stabs.

2003-11-25  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc_type_of_stub): Disallow stubs other than
	ppc_stub_plt_call to symbols defined in shared libs.

2003-11-22  Jakub Jelinek  <jakub@redhat.com>

	* elf-bfd.h (ELF_LINK_POINTER_EQUALITY_NEEDED): Define new flag.
	* elf.c (_bfd_elf_link_hash_copy_indirect): Copy it.
	* elf32-i386.c (elf_i386_copy_indirect_symbol): Likewise.
	(elf_i386_check_relocs): Set it.
	(elf_i386_finish_dynamic_symbol): If it is not set,
	clear st_value of SHN_UNDEF symbol.

2003-11-20  Jim Blandy  <jimb@redhat.com>

	* cpu-powerpc.c (powerpc_compatible): Any ISA in the PowerPC
	family is a superset of <bfd_arch_rs6000,bfd_mach_rs6k>.

2003-11-20  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (elf_s390_relocate_section): Don't recalculate symbol
	section for reloc output and subtract the output section's address
	from the addend when converting a relocation into one against a
	section symbol.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.

2003-11-18  James E Wilson  <wilson@specifixinc.com>

	* elfxx-ia64.c (get_fptr): For fptr_rel, use dynobj not abfd.
	(elfNN_ia64_size_dynamic_sections): When stripping sections, check
	for ia64_info->rel_fptr_sec.

2003-11-18  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (toc_adjusting_stub_needed): Exit early if section
	size is zero.

2003-11-17  Daniel Jacobowitz  <drow@mvista.com>

	* elf.c (_bfd_elf_link_hash_copy_indirect): Copy
	ELF_LINK_HASH_NEEDS_PLT.  Fix formatting.
	* elf32-hppa.c (elf32_hppa_copy_indirect_symbol): Likewise.
	* elf32-i386.c (elf_i386_copy_indirect_symbol): Likewise.
	* elf32-ppc.c (ppc_elf_copy_indirect_symbol): Likewise.
	* elf32-s390.c (elf_s390_copy_indirect_symbol): Likewise.
	* elf32-sh.c (sh_elf_copy_indirect_symbol): Likewise.
	* elf64-ppc.c (ppc64_elf_copy_indirect_symbol): Likewise.
	* elf64-s390.c (elf_s390_copy_indirect_symbol): Likewise.
	* elf64-x86-64.c (elf64_x86_64_copy_indirect_symbol): Likewise.
	* elfxx-ia64.c (elfNN_ia64_hash_copy_indirect): Likewise.
	* elf32-xtensa.c (elf_xtensa_copy_indirect_symbol): Remove.
	(elf_backend_copy_indirect_symbol): Don't define.

2003-11-14  Daniel Jacobowitz  <drow@mvista.com>

	* elfxx-mips.c (mips_elf_merge_gots): Weaken assert for local
	GOT entries.

2003-11-13  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (elf_s390_relocate_section): Only convert R_390_32
	to R_390_RELATIVE. Convert the other relocations against local
	symbols to relocations against the start of the section.
	* elf64-s390.c (elf_s390_relocate_section): Only convert R_390_64
	to R_390_RELATIVE. Convert the other relocations against local
	symbols to relocations against the start of the section.

2003-11-11  Nick Clifton  <nickc@redhat.com>

	* elf-m10300.c (bfd_mn10300_elf_size_dynamic_sections): Use
	info->executable not info->shared to decide if a .interp section
	should be present.
	* elf32-arm.h (elf32_arm_size_dynamic_sections): Likewise.
	* elf32-cris.c (elf_cris_size_dynamic_sections): Likewise.
	* elf32-hppa.c (elf32_hppa_size_dynamic_sections): Likewise.
	* elf32-i370.c (i370_elf_size_dynamic_sections): Likewise.
	* elf32-m68k.c (elf_m68k_size_dynamic_sections): Likewise.
	* elf32-vax.c (elf_vax_size_dynamic_sections): Likewise.
	* elf32-xtensa.c (elf_xtensa_size_dynamic_sections): Likewise.
	* elf64-hppa.c (elf64_hppa_size_dynamic_sections): Likewise.
	* elfxx-mips.c (_bfd_mips_size_dynamic_sections): Likewise.
	* elflink.h (size_dynamic_sections): Likewise.

2003-11-10  Jonathan Wilson <jonwil@tpgi.com.au>

	* peXXigen.c (_bfd_XXi_swap_aouthdr_out): Swap out tls pointer.
	(_bfd_XXi_final_link_postscript): Look for __tks_used symbol.  If
	found initialise the tls data directory entry.

2003-11-07  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_install_value): Delete.
	(shared_stub_entry, stub_entry): Make them arrays of ints.
	Remove initial branch.
	(ppc_elf_relax_section): Write one branch around all trampolines
	instead.  Correct bogus R_PPC_PLTREL24 handling.  Correct
	branch range check.  Only use shared_stub_entry when shared.
	Test that branches can reach stubs.  Write trampolines out at
	end so that just one realloc is used.  Handle little-endian
	mode.  Move relevant code from ppc_elf_install_value to here.
	(ppc_elf_relocate_section): Move code handling RELAX32 from
	ppc_elf_install_value to here.

2003-11-06  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_howto_raw); Add entry for R_PPC_RELAX32PC.
	(ppc_elf_install_value): Handle R_PPC_RELAX32PC.  Merge duplicate
	cases.
	(shared_stub_entry): Correct opcode.
	(ppc_elf_relax_section): Generate R_PPC_RELAX32PC relocs.
	(ppc_elf_relocate_section): Handle them.

2003-11-05  Alan Modra  <amodra@bigpond.net.au>

	* elf.c (_bfd_elf_rela_local_sym): Accept asection **, and return
	updated section in case of merged section.
	* elf-bfd.h (_bfd_elf_rela_local_sym): Update declaration.
	* elf-hppa.h (elf_hppa_relocate_section): Adjust call.
	* elf-m10200.c (mn10200_elf_relocate_section): Likewise.
	* elf-m10300.c (mn10300_elf_relocate_section): Likewise.
	* elf32-arm.h (elf32_arm_relocate_section): Likewise.
	* elf32-avr.c (elf32_avr_relocate_section): Likewise.
	* elf32-cris.c (cris_elf_relocate_section): Likewise.
	* elf32-fr30.c (fr30_elf_relocate_section): Likewise.
	* elf32-frv.c (elf32_frv_relocate_section): Likewise.
	* elf32-h8300.c (elf32_h8_relocate_section): Likewise.
	* elf32-hppa.c (elf32_hppa_relocate_section): Likewise.
	* elf32-i370.c (i370_elf_relocate_section): Likewise.
	* elf32-i860.c (elf32_i860_relocate_section): Likewise.
	* elf32-m32r.c (m32r_elf_relocate_section): Likewise.
	* elf32-m68k.c (elf_m68k_relocate_section): Likewise.
	* elf32-mcore.c (mcore_elf_relocate_section): Likewise.
	* elf32-msp430.c (elf32_msp430_relocate_section): Likewise.
	* elf32-openrisc.c (openrisc_elf_relocate_section): Likewise.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.
	* elf32-s390.c (elf_s390_relocate_section): Likewise.
	* elf32-sh.c (sh_elf_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf32-v850.c (v850_elf_relocate_section) Likewise.
	* elf32-vax.c (elf_vax_relocate_section): Likewise.
	* elf32-xstormy16.c (xstormy16_elf_relocate_section): Likewise.
	* elf32-xtensa.c (elf_xtensa_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_relocate_section): Likewise.
	* elf64-mmix.c (mmix_elf_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.
	* elf64-sh64.c (sh_elf64_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.
	* elfxx-ia64.c (elfNN_ia64_relocate_section): Likewise.

	* elf32-cris.c (cris_elf_relocate_section): Don't recalculate symbol
	section for reloc output.
	* elf32-i370.c (i370_elf_relocate_section): Likewise.
	* elf32-m68k.c (elf_m68k_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf32-vax.c (elf_vax_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.

	* elf32-ppc.c (ppc_elf_relocate_section): Don't recalculate everything
	for R_PPC_RELAX32 reloc.  Don't bother checking ppc_elf_install_value
	return value.
	* elf64-ppc.c (ppc64_elf_relocate_section <R_PPC64_TOC>): Sanity check
	sec->id.

2003-11-05  Alan Modra  <amodra@bigpond.net.au>

	* elf32-d10v.c (extract_rel_addend, insert_rel_addend): New functions.
	(elf32_d10v_relocate_section): Use them to handle -r reloc
	adjustments, and in place of _bfd_elf_rela_local_sym.

	* cpu-iq2000.c (arch_info_struct): Warning fix.

2003-11-05  Alan Modra  <amodra@bigpond.net.au>

	* elf32-hppa.c (ELIMINATE_COPY_RELOCS): Define.
	(elf32_hppa_copy_indirect_symbol): Don't copy NON_GOT_REF on
	weakdefs.
	(elf32_hppa_check_relocs): Use ELIMINATE_COPY_RELOCS.
	(elf32_hppa_adjust_dynamic_symbol): Likewise.  Copy weakdef
	NON_GOT_REF.
	(allocate_dynrelocs): Use ELIMINATE_COPY_RELOCS and
	SYMBOL_CALLS_LOCAL.  Discard relocs for undef weak syms with
	non-default visibility.
	(elf32_hppa_relocate_section): Use ELIMINATE_COPY_RELOCS and
	SYMBOL_CALLS_LOCAL.

2003-11-04  Alan Modra  <amodra@bigpond.net.au>

	* aout-target.h, aoutf1.h, bfdio.c, bfdwin.c: Update copyright date.
	* coff-apollo.c, coff-sparc.c, coff-w65.c, coff-we32k.c: Ditto.
	* coff-z8k.c, coffgen.c, cpu-frv.c, cpu-h8500.c, cpu-hppa.c: Ditto.
	* cpu-ia64-opc.c, cpu-m10300.c, cpu-mips.c, cpu-msp430.c: Ditto.
	* cpu-rs6000.c, cpu-z8k.c, efi-app-ia32.c, elf32-am33lin.c: Ditto.
	* gen-aout.c, hash.c, hp300hpux.c, init.c, mach-o.c: Ditto.
	* nlm-target.h, nlm.c, som.h, stabs.c, sysdep.h, xsym.h: Ditto.

	* elf-m10300.c (_bfd_mn10300_elf_create_got_section): Fix
	"dereferencing type-punned pointer" warnings.

	* aout-adobe.c (aout_adobe_set_section_contents): Constify location.
	* aoutx.h (NAME(aout,set_section_contents)): Ditto.
	* bfd-in2.h: Regenerate.
	* binary.c (binary_set_section_contents): Ditto.
	* bout.c (b_out_set_section_contents): Ditto.
	* coff-tic54x.c (tic54x_set_section_contents): Ditto.
	* coffcode.h (coff_set_section_contents): Ditto.
	* ecoff.c (_bfd_ecoff_set_section_contents): Ditto.
	* elf-bfd.h (_bfd_elf_set_section_contents): Ditto.
	* elf.c (_bfd_elf_set_section_contents): Ditto.
	* elfxx-mips.c (_bfd_mips_elf_set_section_contents): Ditto.
	* elfxx-mips.h (_bfd_mips_elf_set_section_contents): Ditto.
	* i386msdos.c (msdos_set_section_contents): Ditto.
	* ieee.c (ieee_set_section_contents): Ditto.
	* ihex.c (ihex_set_section_contents): Ditto.
	* libaout.h (NAME(aout,set_section_contents)): Ditto.
	* libbfd-in.h (_bfd_nowrite_set_section_contents): Ditto.
	(_bfd_generic_set_section_contents): Ditto.
	* libbfd.h: Regenerate.
	* libbfd.c (_bfd_generic_set_section_contents): Ditto.
	* libecoff.h (_bfd_ecoff_set_section_contents): Ditto.
	* libnlm.h (nlmNAME(set_section_contents)): Ditto.
	(struct nlm_backend_data <nlm_mangle_relocs>): Ditto.
	* mmo.c (mmo_set_section_contents): Ditto.
	* nlm32-alpha.c (nlm_alpha_mangle_relocs): Ditto.
	* nlm32-i386.c (nlm_i386_mangle_relocs): Ditto.
	* nlm32-ppc.c (nlm_powerpc_mangle_relocs): Ditto.
	* nlm32-sparc.c (nlm_sparc_mangle_relocs): Ditto.
	* nlmcode.h (nlm_set_section_contents): Ditto.
	* oasys.c (oasys_set_section_contents): Ditto.
	* pdp11.c (NAME(aout,set_section_contents)): Ditto.
	* ppcboot.c (ppcboot_set_section_contents): Ditto.
	* srec.c (srec_set_section_contents): Ditto.
	* targets.c (BFD_JUMP_TABLE_WRITE <_bfd_set_section_contents>): Ditto.
	* tekhex.c (tekhex_set_section_contents): Ditto.
	(move_section_contents): Ditto.
	* versados.c (versados_set_section_contents): Ditto.
	* vms-misc.c (_bfd_save_vms_section): Ditto.
	* vms.c (vms_set_section_contents): Ditto.
	* vms.h (_bfd_save_vms_section): Ditto.

2003-11-04  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc_size_one_stub): Size relbrlt.  Accept info arg
	rather than htab.
	(ppc64_elf_size_stubs): Adjust ppc_size_one_stub traversal.  Zero
	relbrlt size.
	(ppc64_elf_build_stubs): Allocate space for relbrlt.

2003-11-04  Alan Modra  <amodra@bigpond.net.au>

	* bfd-in.h (_bfd_elf_tls_setup): Declare.
	* bfd-in2.h: Regenerate.
	* elf-bfd.h (struct elf_link_tls_segment): Delete.
	(struct elf_link_hash_table): Add tls_sec and tls_size.
	* elf.c (_bfd_elf_link_hash_table_init): Init tls_sec and tls_size.
	* elflink.c (_bfd_elf_tls_setup): New function.
	* elflink.h (struct elf_final_link_info): Remove first_tls_sec.
	(elf_bfd_final_link): Don't set first_tls_sec here.  Update code
	saving tls segment info, round segment size up.
	(elf_link_output_extsym): Adjust code using tls segment info.
	(elf_link_input_bfd): Likewise.
	* elf32-i386.c (dtpoff_base, tpoff): Likewise.
	* elf32-s390.c (dtpoff_base, tpoff): Likewise.
	* elf32-sh.c (dtpoff_base, tpoff): Likewise.
	* elf32-sparc.c (dtpoff_base, tpoff): Likewise.
	* elf64-s390.c (dtpoff_base, tpoff): Likewise.
	* elf64-x86-64.c (dtpoff_base, tpoff): Likewise.
	* elfxx-ia64.c (elfNN_ia64_tprel_base): Likewise.
	(elfNN_ia64_dtprel_base): Likewise.
	* elf64-alpha.c (alpha_get_dtprel_base): Likewise.
	(alpha_get_tprel_base): Likewise.
	(struct alpha_relax_info): Remove tls_segment.
	(elf64_alpha_relax_got_load): Adjust invocation of
	alpha_get_dtprel_base and alpha_get_tprel_base.
	(elf64_alpha_relax_tls_get_addr): Likewise.
	(elf64_alpha_relax_section): Likewise.
	(elf64_alpha_relocate_section): Likewise.
	(elf64_alpha_relax_find_tls_segment): Delete.
	* elf32-ppc.c (struct ppc_elf_link_hash_table): Remove tls_sec.
	(ppc_elf_tls_setup): Call _bfd_elf_tls_setup.  Return section.
	(ppc_elf_relocate_section): Adjust to use elf.tls_sec.
	* elf32-ppc.h (ppc_elf_tls_setup): Update.
	* elf64-ppc.c (struct ppc_link_hash_table): Remove tls_sec.
	(ppc64_elf_tls_setup): Call _bfd_elf_tls_setup.  Return section.
	(ppc64_elf_tls_optimize): Adjust to use elf.tls_sec.
	(ppc64_elf_relocate_section): Likewise.
	* elf64-ppc.h (ppc64_elf_tls_setup): Update.

2003-11-03  Daniel Jacobowitz  <drow@mvista.com>

	* elf-bfd.h (struct elf_backend_data): Remove plt_header_size.
	* elf-m10300.c (elf_backend_plt_header_size): Don't define.
	* elf32-arm.h (elf_backend_plt_header_size): Don't define.
	* elf32-cris.c (elf_backend_plt_header_size): Don't define.
	* elf32-i386.c (elf_backend_plt_header_size): Don't define.
	* elf32-mips.c (elf_backend_plt_header_size): Don't define.
	* elf32-ppc.c (elf_backend_plt_header_size): Don't define.
	* elf32-s390.c (elf_backend_plt_header_size): Don't define.
	* elf32-sh.c (elf_backend_plt_header_size): Don't define.
	* elf32-sparc.c (elf_backend_plt_header_size): Don't define.
	* elf64-alpha.c (elf_backend_plt_header_size): Don't define.
	* elf64-hppa.c (elf_backend_plt_header_size): Don't define.
	* elf64-mips.c (elf_backend_plt_header_size): Don't define.
	* elf64-ppc.c (elf_backend_plt_header_size): Don't define.
	* elf64-s390.c (elf_backend_plt_header_size): Don't define.
	* elf64-sh64.c (elf_backend_plt_header_size): Don't define.
	* elf64-sparc.c (elf_backend_plt_header_size): Don't define.
	* elf64-x86-64.c (elf_backend_plt_header_size): Don't define.
	* elfn32-mips.c (elf_backend_plt_header_size): Don't define.
	* elfxx-ia64.c (elf_backend_plt_header_size): Don't define.
	* elfxx-target.h (elf_backend_plt_header_size): Don't define
	or include in target initializer.

2003-11-03  Andrew Cagney  <cagney@redhat.com>

	* section.c (bfd_set_section_contents): Make the "location" buffer
	constant.
	* bfd-in2.h: Re-generate.

2003-10-30  Andrew Cagney  <cagney@redhat.com>

	* syms.c: Replace "struct symbol_cache_entry" with "struct
	bfd_symbol".
	* vms.h, targets.c, section.c, reloc.c, peicode.h: Ditto.
	* mipsbsd.c, elf.c, linker.c, elf-bfd.h, ecoff.c: Ditto.
	* cpu-z8k.c, cpu-ns32k.c, cpu-h8500.c, bfd.c, bfd-in.h: Ditto.
	* bfd-in2.h: Re-generate.

2003-10-30  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c: Include objalloc.h, hashtab.h.
	(struct elfNN_ia64_local_hash_entry): Remove root. Add id and r_sym
	fields.
	(struct elfNN_ia64_local_hash_table): Remove.
	(struct elfNN_ia64_link_hash_table): Change loc_hash_table's type
	to htab_t.  Add loc_hash_memory field.
	(elfNN_ia64_local_hash_table_init, elfNN_ia64_new_loc_hash_entry):
	Removed.
	(elfNN_ia64_local_htab_hash, elfNN_ia64_local_htab_eq): New
	functions.
	(elfNN_ia64_hash_table_create): Use hashtab.h hashtable for
	loc_hash_table.  Initialize loc_hash_memory.
	(elfNN_ia64_hash_table_free): New function.
	(elfNN_ia64_local_hash_lookup): Remove.
	(elfNN_ia64_local_dyn_sym_thunk): Change into htab_traverse
	callback.
	(elfNN_ia64_dyn_sym_traverse): Use htab_traverse.
	(get_local_sym_hash): Use hashtab.h hashtable for loc_hash_table.
	(bfd_elfNN_bfd_link_hash_table_free): Define.

2003-10-30  Alan Modra  <amodra@bigpond.net.au>

	* elflink.c (_bfd_elf_link_record_dynamic_symbol): Modify versioned
	symbol string in place.

2003-10-30  Jim Blandy  <jimb@redhat.com>

	* cpu-rs6000.c (rs6000_compatible): Check the correct arch_info
	object's mach field: all PowerPC machines are supersets of the
	original rs6000, but not later rs6000 machines.

2003-10-30  Alan Modra  <amodra@bigpond.net.au>

	* dwarf2.c (struct attribute): Delete "unsnd", "snd" and "addr".
	Add "val" and "sval" fields.
	(DW_STRING, DW_UNSND, DW_BLOCK, DW_SND, DW_ADDR): Delete.
	(read_attribute_value): Expand and adjust DW_* occurrences.
	(scan_unit_for_functions, parse_comp_unit): Likewise.

2003-10-30  Phil Edwards  <phil@codesourcery.com>

	* config.bfd (arm-*-vxworks):  Remove separate stanza; merge with
	other common ELF triples.
	(i[3-7]86-*-vxworks):  Change to ELF format.
	(mips*-*-windiss):  New triple, add to common MIPS/ELF stanza.
	(sh-*-vxworks):  New stanza.

2003-10-30  Lars Knoll  <lars@trolltech.com>
	    Michael Matz  <matz@suse.de>
	    Jakub Jelinek  <jakub@redhat.com>
	    Alan Modra  <amodra@bigpond.net.au>

	* merge.c (struct sec_merge_sec_info): Update comment.
	(struct sec_merge_hash_entry): Remove entsize.
	(sec_merge_hash_lookup): Only adjust alignment when creating.
	(sec_merge_emit): Remove register keyword.
	(cmplengthentry, last4_eq, last_eq): Delete.
	(strrevcmp, strrevcmp_align, is_suffix): New.
	(merge_strings): Use them to implement fast suffix merging.
	* elf-strtab.c (struct elf_strtab_hash_entry): Update comments.
	Make "len" signed.
	(_bfd_elf_strtab_add): Lose on >2G strings.
	(_bfd_elf_strtab_emit): Don't emit strings with len < 0.
	(cmplengthentry, last4_eq): Delete.
	(strrevcmp, is_suffix): New.
	(_bfd_elf_strtab_finalize): Rework to implement fast suffix merging.

2003-10-29  Daniel Jacobowitz  <drow@mvista.com>

	* elf32-arm.h (elf32_arm_final_link_relocate): Move check for
	SEC_ALLOC.

2003-10-29  Philip Blundell  <philb@gnu.org>

	* elf32-arm.h (elf32_arm_plt0_entry, elf32_arm_plt_entry): New
	code sequence.
	(PLT_HEADER_SIZE): New.
	(struct elf32_arm_pcrel_relocs_copied): Rename to ...
	(struct elf32_arm_relocs_copied): ... this.  Count both
	pcrel and non-pcrel relocs.  All uses updated.
	(struct elf32_arm_link_hash_table): Add pointers to dynamic linker
	sections and symbol/section mapping cache.
	(create_got_section): New.
	(elf32_arm_create_dynamic_sections): New.
	(elf_backend_create_dynamic_sections): Use it.
	(elf32_arm_final_link_relocate): Support garbage collection of relocs.
	(elf32_arm_check_relocs): Likewise.
	(elf32_arm_adjust_dynamic_symbol): Likewise.
	(elf32_arm_copy_indirect_symbol): New.
	(elf32_arm_link_hash_table_create): Initialise new fields.
	(elf32_arm_gc_sweep_hook): Implement.
	(elf32_arm_discard_copies): Delete.
	(elf32_arm_finish_dynamic_symbol): Use new PLT code.
	(elf32_arm_finish_dynamic_sections): Likewise.
	(elf_backend_can_refcount): Define.
	(elf_backend_copy_indirect_symbol): Likewise.
	(elf_backend_plt_header_size): Set to PLT_HEADER_SIZE.

2003-10-29  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (elf_backend_grok_prstatus): Define.
	(elf_backend_grok_psinfo): Define.
	(ppc64_elf_grok_prstatus, ppc64_elf_grok_psinfo): New functions.

	* elf.c (_bfd_elfcore_make_pseudosection): Allow multiple
	sections with the same name.
	(elfcore_grok_lwpstatus): Likewise.
	(elfcore_grok_win32pstatus): Likewise.
	(elfcore_grok_note): Likewise.
	(elfcore_grok_nto_status): Likewise.
	(elfcore_grok_nto_gregs): Likewise.

2003-10-27  Daniel Jacobowitz  <drow@mvista.com>

	* elf32-arm.h (elf32_arm_merge_private_bfd_data): Never skip dynamic
	objects.

2003-10-14  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_create_got_section): Initialize global_gotno.

2003-10-24  H.J. Lu  <hongjiu.lu@intel.com>

	* elflink.h (NAME(bfd_elf,size_dynamic_sections)): Look up
	hash table for real symbols.

2003-10-23  Michael Snyder  <msnyder@redhat.com>

	* section.c (asection): Fix typo in comment.

2003-10-23  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (get_tls_mask): Add toc_symndx param, save toc
	reloc symbol index to it.  Don't allow gd syms in shared libs
	to be optimized.
	(ppc64_elf_tls_optimize): Adjust get_tls_mask call.
	(ppc64_elf_size_stubs): Likewise.
	(ppc64_elf_relocate_section): Check that tls relocs are only used
	with tls syms, and similarly for non-tls.  Correct symbol used
	when optimizing toc tls code.

2003-10-22  Nick Clifton  <nickc@redhat.com>

	* peicode.h (coff_swap_scnhdr_in): Only remove padding when
	processing an executable.

2003-10-22  Jakub Jelinek  <jakub@redhat.com>

	* elflink.c (_bfd_elf_export_symbol): Adjust for globals and locals
	field changes.
	(_bfd_elf_link_assign_sym_version): Likewise.
	* elflink.h (size_dynamic_sections): Likewise.

2003-10-21  Alexandre Oliva  <aoliva@redhat.com>,
	    Michael Snyder  <msnyder@redhat.com>

	* archures.c (bfd_mach_sh4a, bfd_mach_sh4al_dsp, bfd_mach_sh4_nofpu,
	bfd_mach_sh4a_nofpu): New machine types.
	* bfd-in2.h: Rebuilt.
	* cpu-sh.c (compatible): Remove unused function.
	(SH4A_NEXT, SH4AL_DSP_NEXT, SH4_NOFPU_NEXT, SH4A_NOFPU_NEXT): New.
	(arch_info_struct): Add sh4a, sh4al_dsp, sh4-nofpu and sh4a-nofpu.
	* elf32-sh.c (sh_elf_set_mach_from_flags): Handle them.

2003-10-21  Wouter van Heyst <wouter@vidicode.nl>

	* elf32-arm.h (elf32_arm_merge_private_bfd_data): Correct text
	describing mismatched formats involving the Maverick FP type.

2003-10-21  Anil Paranjpe  <anilp1@KPITCummins.com>

	* binary.c (binary_object_p): Pass machine flag along with
	architecture.

2003-10-21  Thorsten Brehm  <brehm@gmx.net>

	* archures.c (bfd_default_scan): Add support for mcf528x.
	* ieee.c (ieee_write_processor): Likewise.

2003-10-21  Peter Barada  <pbarada@mail.wm.sps.mot.com>
	    Bernardo Innocenti  <bernie@develer.com>

	* archures.c: Add MCF528x (MCFv4) support.
	* cpu-m68k.c (arch_info_struct): Likewise.
	* bfd-in2.h: Regenerate.

2003-10-20  Andrew Cagney  <cagney@redhat.com>

	* targets.c: Replace "struct sec" with "struct bfd_section"
	* syms.c, sparclynx.c, section.c, opncls.c: Ditto.
	* libcoff-in.h, libbfd-in.h, elfxx-target.h: Ditto.
	* elf.c, coffgen.c, bfd.c, bfd-in.h, aoutf1.h: Ditto.
	* aout-tic30.c, aout-target.h:
	* bfd-in2.h, libcoff.h, libbfd.h: Regenerate.

2003-10-18  Hans-Peter Nilsson  <hp@bitrange.com>

	Support linker relaxation of new R_MMIX_PUSHJ_STUBBABLE relocs.
	* elf64-mmix.c (MAX_PUSHJ_STUB_SIZE): New macro.
	(struct _mmix_elf_section_data): New member pjs.
	(mmix_set_relaxable_size, mmix_elf_get_section_contents): New
	functions.
	(elf_mmix_howto_table): New entry for R_MMIX_PUSHJ_STUBBABLE.
	(mmix_reloc_map): Ditto.
	(mmix_elf_relocate_section): Handle R_MMIX_PUSHJ_STUBBABLE.
	(mmix_final_link_relocate, mmix_elf_check_common_relocs): Ditto.
	(mmix_elf_perform_relocation): Ditto.  Don't mark parameter addr
	unused.
	(mmix_elf_check_relocs): Move early return to after
	mmix_elf_check_common_relocs call.
	(mmix_elf_symbol_processing): Fix cut-and-pasto in head comment.
	(_bfd_mmix_before_linker_allocation): Rename from
	_bfd_mmix_prepare_linker_allocated_gregs.  All referers changed.
	Arrange to set the initial relaxable size of sections.
	(_bfd_mmix_after_linker_allocation): Rename from
	_bfd_mmix_finalize_linker_allocated_gregs.
	(mmix_elf_relax_section): Relax a R_MMIX_PUSHJ_STUBBABLE reloc.
	(bfd_elf64_get_section_contents): Define.
	* reloc.c: Add ENUMX for BFD_RELOC_MMIX_PUSHJ_STUBBABLE.
	* libbfd.h, bfd-in2.h: Regenerate.

	* reloc.c (bfd_generic_relax_section): Default-set
	section->_cooked_size here.
	(bfd_generic_get_relocated_section_contents): Don't set it here.
	Explain why.

2003-10-17  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* elf32-hppa.c (elf32_hppa_relocate_section): Skip relocation if
	output section has been discarded.

2003-10-17  Shrinivas Atre  <shrinivasa@KPITCummins.com>

	* coff-h8300.c (funcvec_hash_newfunc): Handle normal mode.
	(h8300_reloc16_extra_cases): Likewise.
	(h8300_bfd_link_add_symbols): Likewise.

2003-10-17 Dhananjay Deshpande <dhananjayd@kpitcummins.com>

	* cpu-h8300.c (h8300sxn_info_struct): Correct address size.
	(h8300sn_info_struct): Likewise.
	(h8300hn_info_struct): Likewise.

2003-10-16  Pavel Roskin  <proski@gnu.org>

	* peXXigen.c (_bfd_XXi_swap_aouthdr_out): Don't calculate image size
	for sections which lack size info.

2003-10-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* configure.host: Add __USE_MINGW_FSEEK to HDEFINES for
	 mingw32.

2003-10-16  H.J. Lu  <hongjiu.lu@intel.com>

	* elflink.h (NAME(bfd_elf,size_dynamic_sections)): Also warn
	undefined patterns with '*'.

2003-10-16  H.J. Lu  <hongjiu.lu@intel.com>

	* elf-eh-frame.c (_bfd_elf_discard_section_eh_frame): Don't
	use the last CIE from a different section.
	(_bfd_elf_write_section_eh_frame): Don't pad beyond the raw
	size of the output section.

2003-10-07  Roland McGrath  <roland@redhat.com>

	* elf.c (_bfd_elf_make_section_from_phdr): Set alignment_power of
	new section from p_align header field.

2003-10-16  H.J. Lu  <hongjiu.lu@intel.com>

	* elf32-xtensa.c (xtensa_read_table_entries): The external size
	of entry is 8 bytes.

2003-10-15  Andrew Cagney  <cagney@redhat.com>

	* targets.c (BFD_JUMP_TABLE_SYMBOLS): Replace NAME##_get_symtab
	with NAME##_canonicalize_symtab.
	* libcoff-in.h (coff_canonicalize_symtab): Update.
	* xsym.h (bfd_sym_canonicalize_symtab): Update.
	* elf-bfd.h (_bfd_elf_canonicalize_symtab): Update.
	* coffgen.c (coff_canonicalize_symtab): Update.
	* libbfd-in.h (_bfd_nosymbols_canonicalize_symtab): Update.
	* libnlm.h (nlmNAME(canonicalize_symtab)): Update.
	* ieee.c (ieee_vec): Update comment.
	* libecoff.h (_bfd_ecoff_canonicalize_symtab): Update.
	* mmo.c (mmo_canonicalize_symtab): Update.
	* nlm-target.h (nlm_canonicalize_symtab): Update.
	* nlmcode.h (nlm_canonicalize_symtab): Update.
	* i386msdos.c (msdos_canonicalize_symtab): Update.
	* hp300hpux.c (MY (canonicalize_symtab)): Update.
	* oasys.c (oasys_canonicalize_symtab): Update.
	* som.c (som_canonicalize_symtab): Update.
	* pef.c (bfd_pef_canonicalize_symtab): Update.
	* nlmcode.h (nlm_canonicalize_symtab): Update.
	* xsym.c (bfd_sym_canonicalize_symtab): Update.
	* vms.c (vms_canonicalize_symtab): Update.
	* versados.c (versados_canonicalize_symtab): Update.
	* mach-o.c (bfd_mach_o_canonicalize_symtab): Update.
	* ieee.c (ieee_canonicalize_symtab): Update.
	* pdp11.c (NAME(aout,canonicalize_symtab)): Update.
	* reloc.c: Update comment.
	* libaout.h (NAME(aout,canonicalize_symtab)): Update.
	* coff64-rs6000.c (aix5coff64_vec): Update.
	* coff64-rs6000.c (bfd_xcoff_aix5_backend_data): Update.
	* coff-rs6000.c (rs6000coff_vec, pmac_xcoff_vec): Update.
	* aoutx.h (NAME(aout,canonicalize_symtab)): Update.
	* elfxx-target.h (bfd_elfNN_canonicalize_symtab): Update.
	* hp300hpux.c (MY_canonicalize_symtab): Update.
	* ecoff.c (_bfd_ecoff_canonicalize_symtab): Update.
	* aout-tic30.c (MY_canonicalize_symtab): Update.
	* aout-target.h (MY_canonicalize_symtab): Update.
	* ppcboot.c (ppcboot_canonicalize_symtab): Update.
	* elf.c (_bfd_elf_canonicalize_symtab): Update.
	* elfcode.h (elf_canonicalize_symtab): Update.
	* ihex.c (ihex_canonicalize_symtab): Update.
	* tekhex.c (tekhex_canonicalize_symtab): Update.
	* binary.c (binary_canonicalize_symtab): Update.
	* srec.c (srec_canonicalize_symtab): Update.

2003-10-15  Kazu Hirata  <kazu@cs.umass.edu>

	* elf32-h8300.c (elf_reloc_map): Fix a comment typo.

2003-10-15  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_relocate_section): Handle R_SH_IMM_*_PCREL
	relocations.
	(sh_elf_check_relocs): Likewise.

	* elf32-sh64.c (elf_backend_merge_symbol_attribute): Define.
	(sh64_elf_merge_symbol_attribute): New.
	* elf64-sh64.c (elf_backend_merge_symbol_attribute): Define.
	(sh64_elf64_merge_symbol_attribute): New.

2003-10-14  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf-bfd.h (struct elf_backend_data): New function pointer member
	elf_backend_merge_symbol_attribute.
	* elflink.h (elf_link_add_object_symbols): Adjust call to
	elf_backend_merge_symbol_attribute if the backend defined it.
	* elfxx-target.h (elf_backend_merge_symbol_attribute): New macro.
	(elfNN_bed): Add that to the initializer.

2003-10-14  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (get_is_linkonce_section): Delete.
	(xtensa_is_property_section, xtensa_is_littable_section): Use
	XTENSA_INSN_SEC_NAME and XTENSA_LIT_SEC_NAME macros.  Do not recognize
	linkonce sections containing ".xt.insn" and ".xt.lit" substrings.
	(xtensa_get_property_section_name): Check section name instead of
	calling get_is_linkonce_section.  Remove unused bfd parameter.  Use
	XTENSA_INSN_SEC_NAME and XTENSA_LIT_SEC_NAME macros.  Never generate
	linkonce section names by appending ".xt.insn" or ".xt.lit".
	(xtensa_read_table_entries): Remove bfd argument in call to
	xtensa_get_property_section_name.  Free section name when done.
	(elf_xtensa_combine_prop_entries): Free leaking table.

2003-10-13  Richard Sandiford  <rsandifo@redht.com>

	* elfxx-mips.c (_bfd_mips_elf_size_dynamic_sections): Don't add
	DT_MIPS_LIBLIST or DT_MIPS_CONFLICT entries.
	(_bfd_mips_elf_finish_dynamic_symbol): Don't handle them.  Don't
	handle DT_MIPS_MSYM.  Set DT_RELSZ based on the number of relocations
	that were needed.
	(_bfd_mips_elf_modify_segment_map): Fix placement of PT_MIPS_OPTIONS.
	(_bfd_mips_elf_merge_private_bfd_data): Ignore EF_MIPS_UCODE.

2003-10-13  H.J. Lu  <hongjiu.lu@intel.com>

	* bfd-in.h (bfd_elf32_ia64_after_parse): New prototype.
	(bfd_elf64_ia64_after_parse): Likewise.
	* bfd-in2.h: Regenerated.

	* elfxx-ia64.c (oor_ip): New.
	(oor_branch_size): Likewise.
	(bfd_elfNN_ia64_after_parse): Likewise.
	(elfNN_ia64_relax_section): Use oor_ip if oor_branch_size
	equals sizeof (oor_ip).

2003-10-12  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf64-sh64.c (sh_elf64_relocate_section): Tidy up for the
	renumbering of some relocation numbers.

2003-10-11  Alan Modra  <amodra@bigpond.net.au>

	* coff-sh.c: Move definition of MAP and guard more code with
	COFF_IMAGE_WITH_PE.

	* section.c (bfd_get_section_size_before_reloc): Ignore reloc_done.
	* bfd-in2.h: Regenerate.

2003-10-10  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile.am: Run "make dep-am".
	* Makefile.in: Regenerate.
	* doc/Makefile.in: Likewise.

2003-10-09  H.J. Lu  <hongjiu.lu@intel.com>

	* cofflink.c: Include "safe-ctype.h".
	(coff_link_add_symbols): Use ISDIGIT instead of isdigit.

2003-10-08  Dave Brolley  <brolley@redhat.com>
	On behalf of Michael Snyder  <msnyder@redhat.com>

	* archures.c: Add FRV fr550 machine.
	* cpu-frv.c: Ditto.
	* elf32-frv.c: Ditto.
	* bfd-in2.h: Regenerate.

2003-10-08  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c (STUB_MOVE,STUB_LI16): Fix stub code
	for non-SGI N64 ABI. Improve code consitency.

2003-10-07  Alexandre Oliva  <aoliva@redhat.com>

	* elf32-frv.c (elf32_frv_howto_table): Set R_FRV_LABEL16's
	rightshift to 2.

2003-10-07  Nathan Sidwell  <nathan@codesourcery.com>

	* libbfd-in.h (_bfd_link_section_stabs): Add string offset
	parameter.
	* cofflink.c (coff_link_add_symbols): Deal with split stab
	sections.
	* elflink.h (elf_link_add_object_symbols): Deal with split stab
	sections.
	* stabs.c (_bfd_link_section_stabs): Add string offset parameter.
	* libbfd.h: Regenerated.

	* coffcode.h (coff_set_alignment_hook): With PE_COFF reloc
	overflow, set reloc start position to after the count
	reloc. Subtract one from num relocs. Give error on 0xffff relocs
	and no overflow.
	* cofflink.c (_bfd_coff_final_link): Deal with PE_COFF reloc
	overflow.
	* peXXigen.c (_bfd_XXi_swap_scnhdr_out): Do overflow if >=
	0xffff.

2003-10-06  H.J. Lu  <hongjiu.lu@intel.com>

	* elf-eh-frame.c (_bfd_elf_write_section_eh_frame): Pad the
	last CIE/FDE if needed.

2003-10-06  Nick Clifton  <nickc@redhat.com>

	* targets.c (_bfd_target_vector): Include bfd_elf64_sparc_vec if
	BFD64 is enabled.

2003-10-06  Matt Thomas <matt@3am-software.com>

	* config.bfd: Move the hppa*-*-netbsd* case to the hppa*-*-linux* case.

2003-10-06  Robert Millan  <robertmh@gnu.org>

	* configure.in: Match GNU/KNetBSD with new knetbsd*-gnu triplet.
	* config.bfd: Likewise.
	* configure: Regenerate.

2003-10-04  Christian Groessler  <chris@groessler.org>

	* coff-z8k.c (extra_case): Fix displacement length check for R_JR
	and R_CALLR.

2003-10-04  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.c: Update to ISO C90; replace PTR with void*.
	* elf32-m68hc11.c: Likewise.
	* elf32-m68hc12.c: Likewise.
	* elf32-m68hc1x.h: Likewise.

2003-10-04  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.c (_bfd_m68hc11_elf_merge_private_bfd_data): Fix merge
	of flags between HC12 and HCS12.

2003-10-04  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* merge.c (_bfd_merge_sections): Set SEC_EXCLUDE flag on sections
	which become empty after merging.

2003-09-30  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (ia64_howto_table): Fix size of R_IA64_TPREL64[LM]SB,
	R_IA64_DTPREL{32,64}[LM]SB and R_IA64_DTPMOD64[LM]SB.

2003-09-30  Chris Demetriou  <cgd@broadcom.com>

	* archures.c (bfd_mach_mipsisa64r2): New define.
	* bfd-in2.h: Regenerate.
	* aoutx.h (NAME(aout,machine_type)): Handle bfd_mach_mipsisa64r2.
	* cpu-mips.c (I_mipsisa64r2): New enum value.
	(arch_info_struct): Add entry for I_mipsisa64r2.
	* elfxx-mips.c (_bfd_elf_mips_mach)
	(_bfd_mips_elf_print_private_bfd_data): Handle E_MIPS_ARCH_64R2.
	(mips_set_isa_flags): Add bfd_mach_mipsisa64r2 case.
	(mips_mach_extensions): Add entry for bfd_mach_mipsisa64r2.

2003-09-29  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_hpux_backend_symbol_processing): New.
	Handle SHN_IA_64_ANSI_COMMON.
	(elf_backend_section_from_bfd_section): Defined.

2003-09-26  H.J. Lu  <hongjiu.lu@intel.com>

	* elflink.c (elf_link_read_relocs_from_section): Add an argument
	of a pointer to section. Check bad symbol index.
	(_bfd_elf_link_read_relocs): Modify calls to
	elf_link_read_relocs_from_section.

2003-09-23  DJ Delorie  <dj@redhat.com>

	* elf32-sh.c (sh_elf_howto_table): R_SH_SWITCH8,
	R_SH_GNU_VTINHERIT, R_SH_GNU_VTENTRY,
	R_SH_LOOP_START,R_SH_LOOP_END moved to "reserved" spaces,
	R_SH_DIR16, R_SH_DIR8, R_SH_DIR8UL, R_SH_DIR8UW, R_SH_DIR8U,
	R_SH_DIR8SW, R_SH_DIR8S, R_SH_DIR4UL, R_SH_DIR4UW, R_SH_DIR4U,
	R_SH_PSHA, R_SH_PSHL added.
	(sh_reloc_map): Add R_SH_DIR16 and R_SH_DIR8.
	(sh_elf_relocate_section): Support new relocs.

2003-09-23  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (elf_xtensa_relocate_section): Fix typo that clobbered
	dynamic relocation offsets.

2003-09-23  Alan Modra  <amodra@bigpond.net.au>

	* simple.c (bfd_simple_get_relocated_section_contents): Free the
	hash table using _bfd_generic_link_hash_table_free.

2003-09-23  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct bfd_elf_special_section): Remove "suffix".  Change
	type of prefix_length and suffix_length to int.  Rename "attributes"
	to "attr".  Comment.
	(_bfd_elf_get_sec_type_attr): Update prototype.
	* elf.c (get_special_section): Rewrite.
	(_bfd_elf_get_sec_type_attr): Return struct rather than passing in
	attr and type pointers.
	(_bfd_elf_new_section_hook): Adjust for above.
	(special_sections): Merge suffix with prefix.  Set
	prefix_length for all entries.  Set suffix_length appropriately.
	* elf32-m32r.c (m32r_elf_special_sections): Likewise.
	* elf32-m68hc11.c (elf32_m68hc11_special_sections): Likewise.
	* elf32-m68hc12.c (elf32_m68hc12_special_sections): Likewise.
	* elf32-mcore.c (mcore_elf_special_sections): Likewise.
	* elf32-sh64.c (sh64_elf_special_sections): Likewise.
	* elf32-v850.c (v850_elf_special_sections): Likewise.
	* elf32-xtensa.c (elf_xtensa_special_sections): Likewise.
	* elf64-alpha.c (elf64_alpha_special_sections): Likewise.
	* elf64-hppa.c (elf64_hppa_special_sections): Likewise.
	* elf64-ppc.c (ppc64_elf_special_sections): Likewise.
	* elf64-sh64.c (sh64_elf64_special_sections): Likewise.
	* elfxx-ia64.c (elfNN_ia64_special_sections): Likewise.
	* elfxx-mips.c (_bfd_mips_elf_special_sections): Likewise.
	* elf32-ppc.c (ppc_elf_special_sections): Likewise.  Fix .plt flags.

2003-09-21  Daniel Jacobowitz  <drow@mvista.com>

	* elf64-alpha.c (elf64_alpha_create_got_section): Initialize
	->got if the section already exists.

2003-09-19  Nathan Sidwell  <nathan@codesourcery.com>

	* dwarf2.c (decode_line_info): Cope with an initially empty
	filename table.

2003-09-18  H.J. Lu  <hongjiu.lu@intel.com>

	* acinclude.m4: Include ../config/accross.m4.
	* aclocal.m4: Regenerated.

	* configure.host (HOST_64BIT_TYPE): Remove if it is set to long
	or long long.
	(HOST_U_64BIT_TYPE): Remove if it is set to unsigned long long.
	(host64): Remove if HOST_64BIT_TYPE is set to long.

	* configure.in (HOST_64BIT_TYPE): Set according to the size of
	long and long long.
	(HOST_U_64BIT_TYPE): Likewise.
	(host64): Likewise.
	* configure: Regenerated.

2003-09-19  Alan Modra  <amodra@bigpond.net.au>

	* elf.c (elfcore_write_note): Don't use sizeof(Elf_External_note)
	since some ABIs round up the size of the struct.

2003-09-18  H.J. Lu  <hongjiu.lu@intel.com>

	* elflink.c (_bfd_elf_merge_symbol): Allow type change if
	the old symbol is undefined and the new symbol is defined.

2003-09-18  Andreas Schwab  <schwab@suse.de>

	* simple.c (bfd_simple_get_relocated_section_contents): Use
	_bfd_generic_link_hash_table_create instead of
	bfd_link_hash_table_create.

2003-09-10  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_ia64_special_sections): Mark all sections
	started with ".sbss" or "".sdata" as SHF_IA_64_SHORT.

2003-09-10  John David Anglin	<dave.anglin@nrc-cnrc.nrc.ca>
	    Randolph Chung	<randolph@tausq.org>

	* elf32-hppa.c (struct elf32_hppa_link_hash_entry,
	hppa_link_hash_newfunc, hppa_build_one_stub,
	elf32_hppa_adjust_dynamic_symbol, mark_PIC_calls, allocate_plt_static,
	allocate_dynrelocs, elf32_hppa_size_dynamic_sections,
	elf32_hppa_finish_dynamic_symbol): Remove pic_call field and all code
	for generating import stubs for calls to statically linked PIC
	functions.
	(hppa_type_of_stub): Don't generate an import stub for calls to
	statically linked pic functions.  Generate import stubs for calls
	in a shared object, to functions not in a regular file, and to
	defined weak functions.  Add new argument INFO.
	(hppa_build_one_stub): Don't undef ADDIL_DP.
	(elf32_hppa_check_relocs): Don't set SEC_HAS_GOT_REF flag.
	(elf32_hppa_size_stubs): Pass info to hppa_type_of_stub.
	(final_link_relocate): Change all DLTIND relocs to DPREL relocs in a
	non-shared link.  Convert instructions that use the linkage table
	pointer, or a facsimile thereof, to use the global data pointer when
	the reloc has been changed.

2003-09-08  Joel Brobecker  <brobecker@gnat.com>

	* archures.c: Add new machine names for hppa.
	* bfd-in2.h: Regenerate.
	* cpu-hppa.c: Use the new machine names.

2003-09-06  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.h (struct m68hc11_elf_link_hash_table): Remove
	all_local_syms member.
	* elf32-m68hc1x.c (elf32_m68hc11_size_stubs): Use bfd_elf_get_elf_syms
	to get the local symbols.

2003-09-06  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc12.c (elf32_m68hc12_special_sections): New for hc11.
	(elf_backend_special_sections): Define.a

	PR savannah/4950:
	* elf32-m68hc11.c (elf32_m68hc11_special_sections): The .vectors
	section is read-only.

2003-09-04  Nick Clifton  <nickc@redhat.com>

	* archures.c (bfd_mach_v850e1): Define.
	* bfd-in2.h: Regenerate.
	* cpu-v850.h (scan): Accept bfd_mach_v850e1.
	(arch_info_struct): Include an entry for bfd_mach_v850e1.
	* elf32-v850.c (v850_elf_object_p): Accept E_V850E1_ARCH flag.
	(v850_elf_final_write_processing): Accept bfd_mach_v850e1.
	(v850_elf_print_private_bfd_data): Interpret E_V850E1_ARCH flag.
	(v850_elf_merge_private_bfd_data): Allow v850e1 binaries to be
	linked with v850e binaries.  Mark the output as v850e.

2003-09-03  Nick Clifton  <nickc@redhat.com>

	* cofflink.c (_bfd_coff_link_input_bfd): Do not skip section
	symbols that are used in relocs.

2003-08-30  Robert Millan  <robertmh@gnu.org>

	* configure.in: Match GNU/KFreeBSD with new kfreebsd*-gnu triplet.
	* config.bfd: Likewise.
	* configure: Regenerate.

2003-08-31  Christian Groessler  <chris@groessler.org>

	* elf32-i860.c (i860_howto_pc26_reloc): Finish relocation here
	instead of returning bfd_reloc_continue.

2003-08-31  Andreas Jaeger  <aj@suse.de>

	* merge.c: Update to ISO C90.

2003-08-27  Ian Lance Taylor  <ian@airs.com>

	* configure.in: Check for strtoull.
	* bfd.c (bfd_scan_vma): Use strtoull when available.
	* configure, config.in: Regenerate.

	* configure.in: Define and substitute BFD_HOST_LONG_LONG.
	* bfd-in.h: Define BFD_HOST_LONG_LONG.  Test it rather than
	__GNUC__ when deciding whether to use long long for
	BFD_HOST_64_BIT.
	* configure, Makefile.in, doc/Makefile.in, bfd-in2.h: Regenerate.

2003-08-27  Christian Groessler  <chris@groessler.org>

	* elf32-i860.c (i860_howto_pc26_reloc, i860_howto_pc16_reloc,
	i860_howto_splitn_reloc, i860_howto_highadj_reloc): New
	functions.
	(elf32_i860_howto_table): Insert the new functions as
	'special_function's in the proper reloc type entries.

2003-08-27  Richard Sandiford  <rsandifo@redhat.com>

	* elf32-frv.c (elf32_frv_relocate_section): Use
	_bfd_elf_rela_local_sym.

2003-08-26  Michael Snyder  <msnyder@redhat.com>

	* cpu-frv.c: Remove unused enum.

2003-08-25  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* reloc.c: Fix documentation for MIPS ELF relocations.
	libbfd.h: Regenerate.
	bfd-in2.h: Regenerate.

2003-08-24  Jason Eckhardt  <jle@rice.edu>

	* coff-i860.c (CALC_ADDEND): Define to be a no-op.

2003-08-24  Jason Eckhardt  <jle@rice.edu>

	* elf32-i860.c (elf32_i860_relocate_pc16): Subtract 4 and
	shift by 2 before storing the relocated value.

2003-08-23  Jason Eckhardt  <jle@rice.edu>

	* coff-i860.c (coff_i860_reloc_nyi): New function.
	(howto_table): Add entries for relocations PAIR, HIGHADJ, HIGH,
	LOWn, SPLITn, and BRADDR.
	(RTYPE2HOWTO): Check that the r_type is within the howto_table
	before trying to access the entry.
	(coff_i860_rtype_to_howto): Likewise.
	(coff_i860_reloc_type_lookup): New function.
	(i860_reloc_processing): New function.
	(coff_bfd_reloc_type_lookup): Define macro.
	(RELOC_PROCESSING): Define macro.
	Minor formatting adjustments.

2003-08-23  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_link_add_object_symbols): Don't crash on NULL owner.

2003-08-22  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_ia64_create_dynamic_sections): Align the
	.got section at 8 bytes.

2003-08-21  Nick Clifton  <nickc@redhat.com>

	* cofflink.c: Update to ISO C90 and tidy up formatting.

2003-08-21  Randolph Chung  <tausq@debian.org>

	* elf32-hppa.c (elf32_hppa_object_p): For elf32-hppa-linux, objects
	can have OSABI=Linux or OSABI=SysV.  Check for both.
	* elf64-hppa.c (elf64_hppa_object_p): Likewise.

2003-08-21  Nick Clifton  <nickc@redhat.com>

	* po/sv.po: Updated Swedish translation.

2003-08-20  Richard Sandiford  <rsandifo@redhat.com>

	* elf64-mips.c (elf_backend_copy_indirect_symbol): Define.

2003-08-20  Nick Clifton  <nickc@redhat.com>

	* elf-bfd.h (RELOC_FOR_GLOBAL_SYMBOL): New macro used to
	replace some duplicated code in most elfxx-xxxx.c files.  This
	version uses the new fields in bfd_link_info.

	* elf-m10300.c (mn10300_elf_relocate_section): Use new macro.
	* elf32-arm.h (elf32_arm_relocate_section): Likewise.
	* elf32-cris.c (cris_elf_relocate_section): Likewise.
	* elf32-hppa.c (elf32_hppa_relocate_section): Likewise.
	* elf32-i386.c (elf_i386_relocate_section): Likewise.
	* elf32-ip2k.c (ip2k_elf_relocate_section): Likewise.
	* elf32-iq2000.c (iq2000_elf_relocate_section): Likewise.
	* elf32-m68k.c (elf_m68k_relocate_section): Likewise.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.
	* elf32-s390.c (elf_s390_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf32-vax.c (elf_vax_relocate_section): Likewise.
	* elf32-xtensa.c (elf_xtensa_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.
	* elfxx-ia64.c (elfNN_ia64_relocate_section): Likewise.

	* elf-hppa.h (elf_hppa_unmark_useless_dynamic_symbols,
	elf_hppa_remark_useless_dynamic_symbols,
	elf_hppa_relocate_section): Use the new fields in
	bfd_link_info structure.
	* elf32-sh.c (sh_elf_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_check_relocs): Likewise.
	* elf64-hppa.c (elf64_hppa_check_relocs): Likewise.
	* elf64-sh64.c (sh_elf64_relocate_section): Likewise.
	* elfxx-ia64.c (elfNN_ia64_check_relocs): Likewise.
	* elfxx-mips.c (mips_elf_calculate_relocation): Likewise.

	* elflink.h (elf_link_output_extsym): Fix test for reporting
	undefined symbols in shared libraries.  Remove redundant test
	of shlib_undefined when reporting references to forced local
	symbols.

2003-08-18  Andreas Schwab  <schwab@suse.de>

	* libpei.h (bfd_pe_executable_p): Also recognize efi-app
	executables.

2003-08-17  Hans-Peter Nilsson  <hp@bitrange.com>

	* simple.c (bfd_simple_get_relocated_section_contents): Move
	reloc_done hack to before first bfd_section_size call.  Change all
	returns to use new wrapper macro RETURN, restoring sec->reloc_done.

2003-08-16  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Don't include elf/ppc.h.

2003-08-14  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (_bfd_mips_elf_modify_segment_map): Fix PT_DYNAMIC
	code to work with 64-bit bfds.

2003-08-14  Alan Modra  <amodra@bigpond.net.au>

	* dep-in.sed: Remove libintl.h.
	* Makefile.am (SRC-POTFILES.in, BLD-POTFILES.in): Unset LC_COLLATE.
	(POTFILES.in): Remove target.
	* Makefile.in: Regenerate.

2003-08-12  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_next_input_section): Update comment.
	(ppc64_elf_relocate_section): For zero sym R_PPC64_TOC relocs,
	use the function sym from the previous reloc.

2003-08-11  Jakub Jelinek  <jakub@redhat.com>

	* elf32-i386.c (elf_i386_relocate_section): Make undefined symbols
	fatal if -pie.
	* elf32-s390.c (elf_s390_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.
	* elfxx-ia64.c (elfNN_ia64_relocate_section): Likewise.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.
	(ppc_elf_relocate_section) <case R_PPC_RELAX32>: Issue fatal error
	on undefined symbols if -pie.
	* elf32-sh.c (sh_elf_relocate_section): Likewise.

2003-08-11  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): Add special case for crt1.o
	branch to __libc_start_main.

2003-08-08 Dmitry Diky <diwil@mail.ru>

	* archures.c: Add xW42 and xE42 parts. Sort MPU list according to
	gcc order.
	* cpu-msp430.c: Likewise.
	* elf32-msp430.c: Likewise.
	* bfd-in2.h: Regenerate.

2003-08-07  Alan Modra  <amodra@bigpond.net.au>

	* elfxx-target.h: Remove PTR cast.
	* targets.c (bfd_target): Make backend_data const void *.
	* elf-bfd.h: Constify all occurrences of struct elf_backend_data.
	* elf-m10300.c: Likewise.
	* elf.c: Likewise.
	* elf32-hppa.c: Likewise.
	* elf32-i386.c: Likewise.
	* elf32-m68hc1x.c: Likewise.
	* elf32-ppc.c: Likewise.
	* elf32-s390.c: Likewise.
	* elf32-sh.c: Likewise.
	* elf32-sh64.c: Likewise.
	* elf32-sparc.c: Likewise.
	* elf32-xtensa.c: Likewise.
	* elf64-mips.c: Likewise.
	* elf64-ppc.c: Likewise.
	* elf64-s390.c: Likewise.
	* elf64-sh64.c: Likewise.
	* elf64-sparc.c: Likewise.
	* elf64-x86-64.c: Likewise.
	* elfcode.h: Likewise.
	* elfcore.h: Likewise.
	* elflink.c: Likewise.
	* elflink.h: Likewise.
	* elfxx-ia64.c: Likewise.
	* elfxx-mips.c: Likewise.
	* elfxx-mips.h: Likewise.
	* elf.c (prep_headers): Remove useless check for null backend_data.
	* bfd-in2.h: Regenerate.

	* elf-bfd.h: Remove PARAMS macro.  Replace PTR with void *.
	(NAME): Use ## rather than CONCAT4 macro.
	* elfcode.h: Remove one remaining PARAMS macro.
	* elf-eh-frame.c: Convert to C90, remove unneeded casts and prototypes.
	* elf-strtab.c: Likewise.
	* elf-hppa.h: Likewise.
	* elf32-hppa.h: Likewise.
	* elf32-hppa.c: Likewise.
	(elf32_hppa_add_symbol_hook): Delete.
	(elf_backend_add_symbol_hook): Don't define.
	* libhppa.h: Convert to C90.  Replace INLINE with inline.

2003-08-06  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc_stub_name): Tweak names for better readability.
	(ppc64_elf_adjust_dynamic_symbol): Allow copy relocs against
	function descriptors, but warn.
	(ppc_build_one_stub): Remove a couple of vars.  Move code creating
	stub syms so that we can avoid a stub sym if we already have a
	plt sym.  Do not redefine an existing symbol.
	(ppc64_elf_build_stubs): When --emit-stub-syms, print a symbol for
	glink.

2003-08-06  Nick Clifton  <nickc@redhat.com>

	* po/fr.po: Updated French translation.

2003-08-06  Alan Modra  <amodra@bigpond.net.au>

	* elflink.c (_bfd_elf_create_dynamic_sections): Mark .dynbss with
	SEC_LINKER_CREATED.

2003-08-05  Daniel Jacobowitz  <drow@mvista.com>

	* elf32-arm.h (WILL_CALL_FINISH_DYNAMIC_SYMBOL): Define.
	(elf32_arm_final_link_relocate, elf32_arm_relocate_section): Use it.

2003-08-03  Jeff Muizelaar  <muizelaar@rogers.com>

	* coffcode.h (coff_slurp_line_table): Return with a warning
	message if the line number table could not be read.

2003-08-04  Nick Clifton  <nickc@redhat.com>

	* elflink.h (elf_link_add_object_symbols): Prepend "warning: "
	to messages produced for .gnu.warning.SYMBOL sections.

2003-08-04  Alan Modra  <amodra@bigpond.net.au>

	* elfcode.h: Convert to C90, remove unneeded casts and prototypes.
	* elfcore.h: Likewise.
	* elflink.c: Likewise.
	* elflink.h: Likewise.
	* elf.c (sym_is_global): Remove INLINE.
	(align_file_position): Replace INLINE with inline.
	* elfcode.h (elf_swap_dyn_in, elf_swap_dyn_out): Remove INLINE.
	(elf_file_p): Replace INLINE with inline.

2003-08-02  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_check_relocs): Don't set DF_TEXTREL here.

2003-08-01  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (get_got): Align the .got section at 8 bytes.

2003-08-01  H.J. Lu  <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_ia64_finish_dynamic_symbol): Use
	ElfNN_External_Rela instead of Elf64_External_Rela.

2003-08-01  Nick Clifton  <nickc@redhat.com>

	* config.bfd: Add code to catch obsolete configurations and warn
	about them unless --enable-obsolete is used.  Use this to mark
	vax-vms port as obsolete.

2003-07-30  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_install_value): Tidy.
	(ppc_elf_relax_section): Remove dead code.  Remove unnecessary casts.
	Formatting.
	* elfxx-target.h: Remove PARAMS macro.  Formatting.

2003-07-30  Alan Modra  <amodra@bigpond.net.au>

	* elf.c (bfd_section_from_r_symndx): Test for SHN_UNDEF.
	* elf64-ppc.c (get_fdh): New function, split out from
	ppc64_elf_edit_opd.
	(ppc64_elf_check_relocs): Use get_fdh.
	(func_desc_adjust): Likewise.  Tidy.
	(ppc64_elf_edit_opd): Tighten reloc checks.  Free local_syms on error
	exit.  Use get_fdh.  Account for superfluous dynamic relocs.
	(ppc64_elf_relocate_section): Warning fix.

2003-07-30  Jason Eckhardt  <jle@rice.edu>

	* coff-i860.c: Convert to ISO C90.  Remove superflous prototypes.

2003-07-30  Jason Eckhardt  <jle@rice.edu>

	* elf32-i860.c: Convert to ISO C90.  Remove superflous prototypes.

2003-07-30  Randolph Chung  <tausq@debian.org>

	* elf-hppa.h (elf_hppa_relocate_section): Look up dyn_h for undefweak.
	* elf64-hppa.c (elf64_hppa_finalize_dlt): Check h->root.type.

2003-07-30  Alan Modra  <amodra@bigpond.net.au>

	* elf.c: Convert to C90, remove unnecessary prototypes and casts.
	Replace PTR with void *.  Formatting.
	(_bfd_elf_assign_file_position_for_section): Remove INLINE.
	(make_mapping): Likewise.

2003-07-29  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (func_desc_adjust): Give linker created function
	descriptor symbols a size and type.
	(ppc64_elf_relocate_section): Correct lq insn test.

2003-07-28  Eric Christopher  <echristo@redhat.com>

	* elf32-ppc.c (R_PPC_RELAX32): New relocation.
	(ppc_elf_install_value): New function.
	(ppc_elf_sort_rela): Remove.
	(ppc_elf_relax_section): Rewrite. Remove old relaxation
	and replace with out of range branch stubs.
	(ppc_elf_relocate_section): Handle R_PPC_RELAX32.

2003-07-29  Alexandre Oliva  <aoliva@redhat.com>

	* elf-m10300.c (mn10300_elf_relax_section): Take symbol hash table
	from input_bfd.

2003-07-28  Alan Modra  <amodra@bigpond.net.au>

	* elf.c (special_sections): Set attributes for .got and .plt.

2003-07-27  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_adjust_dynamic_symbol): Ensure no copy relocs
	on function descriptors.
	(ELIMINATE_COPY_RELOCS): Expand comment.
	(ppc64_elf_special_sections): Move.  Don't include non-ppc64 sections.
	Do include ".toc1".

2003-07-25  H.J. Lu  <hongjiu.lu@intel.com>

	* elf.c (_bfd_elf_new_section_hook): Set the default section
	type to SHT_NULL.
	(elf_fake_sections): Set the section type based on asect->flags
	if it is SHT_NULL. Don't abort on processor specific section
	types.

2003-07-25  H.J. Lu  <hongjiu.lu@intel.com>

	* bfd-in2.h: Regenerated.

2003-07-25  H.J. Lu  <hongjiu.lu@intel.com>

	* elf-bfd.h (bfd_elf_special_section): New.
	(elf_backend_data): Add special_sections, a pointer to
	bfd_elf_special_section.
	(elf_section_type). New.
	(elf_section_flags): New.
	(_bfd_elf_get_sec_type_attr): New.

	* elf.c (_bfd_elf_make_section_from_shdr): Always use the
	real section type/flags.
	(special_sections): New.
	(get_special_section): New.
	(_bfd_elf_get_sec_type_attr): New.
	(_bfd_elf_new_section_hook): Check special_section to set
	elf_section_type and elf_section_flags.
	(elf_fake_sections): Don't use section name to set ELF section
	data.

	* elf32-m32r.c (m32r_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-m68hc11.c (elf32_m68hc11_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-mcore.c (mcore_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-ppc.c (ppc_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-sh64.c (sh64_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-v850.c (v850_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf32-xtensa.c (elf_xtensa_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf64-alpha.c (elf64_alpha_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf64-hppa.c (elf64_hppa_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf64-ppc.c (ppc64_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elf64-sh64.c (sh64_elf64_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elfxx-ia64.c (elfNN_ia64_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elfxx-mips.c (_bfd_mips_elf_special_sections): New.

	* elfxx-mips.h (_bfd_mips_elf_special_sections): New.
	(elf_backend_special_sections): Defined.

	* elfxx-target.h (elf_backend_special_sections): New. Default
	to NULL.
	(elfNN_bed): Initialize special_sections.

	* section.c (bfd_abs_section): Remove const.
	(bfd_und_section): Likewise.
	(bfd_com_section): Likewise.
	(bfd_ind_section): Likewise.

2003-07-24  Nick Clifton  <nickc@redhat.com>

	* coff-arm.c (EXTRA_S_FLAGS): Include SEC_CODE so that code
	sections are assigned the LOAD attribute.

2003-07-25  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c: Convert to C90.  Replace PTR with void *.
	* elf32-sh64-com.c: Likewise.
	* elf32-sh64.c: Likewise.
	* elf32-sh64.h: Likewise.
	* elf64-sh64.c: Likewise.

2003-07-24  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_adjust_dynamic_symbol): Use SYMBOL_CALLS_LOCAL.
	(allocate_dynrelocs): Likewise.
	(sh_elf_relocate_section): Likewise. Use SYMBOL_REFERENCES_LOCAL.
	(sh_elf_finish_dynamic_symbol): Use SYMBOL_REFERENCES_LOCAL.

2003-07-24  Nick Clifton  <nickc@redhat.com>

	* po/fr.po: Updated French translation.

2003-07-23  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (xtensa_elf_dynamic_symbol_p): Make inline and move
	near the beginning of the file.  Swap order of arguments.  Call
	_bfd_elf_dynamic_symbol_p with "ignore_protected" set to 0.
	(elf_xtensa_fix_refcounts): Adjust xtensa_elf_dynamic_symbol_p call.
	(elf_xtensa_relocate_section): Likewise.
	(shrink_dynamic_reloc_sections): Likewise.

2003-07-23  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (plt_reloc_count): Fix typo in comment.
	(elf_xtensa_size_dynamic_sections): Use elf_discarded_section.
	(elf_xtensa_combine_prop_entries): Avoid returning non-zero without
	first printing an error message.
	(elf_xtensa_finish_dynamic_sections): Likewise.
	(elf_xtensa_discard_info_for_section): Adjust size of .got.loc when
	discarding literal table entries.
	(elf_xtensa_merge_private_bfd_data): Remove newline from error message.
	(elf_xtensa_do_asm_simplify): Likewise.

2003-07-23  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.c (elf32_m68hc11_size_stubs): Avoid crash when
	we have a local symbol in common section.

2003-07-22  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.c (_bfd_elf_dynamic_symbol_p): Don't return TRUE for
	weak symbols.

2003-07-22  Nick Clifton  <nickc@redhat.com>

	* coffcode.h (coff_slurp_symbol_table): Add C_TCSYM and C_ECOML to
	expected RS6000 storage classes.

2003-07-21  H.J. Lu <hongjiu.lu@intel.com>

	* elfxx-ia64.c (elfNN_ia64_size_dynamic_sections): Mark
	output_bfd unused to silence gcc.

2003-07-21  Nick Clifton  <nickc@redhat.com>

	* po/sv.po: Updated Swedish translation.

2003-07-21  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (SYMBOL_REFERENCES_LOCAL, SYMBOL_CALLS_LOCAL): Use..
	(_bfd_elf_symbol_refs_local_p): ..this.  Declare.
	* elflink.c (_bfd_elf_symbol_refs_local_p): New function.
	* elf32-i386.c (elf_i386_relocate_section): Remove h NULL test
	now done in _bfd_elf_symbol_refs_local_p.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.

2003-07-18  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.c (_bfd_elf_dynamic_symbol_p): Undo the last change.

2003-07-18  H.J. Lu <hongjiu.lu@intel.com>

	* elf-bfd.h (SYMBOL_REFERENCES_LOCAL): Fix a typo.
	(SYMBOL_CALLS_LOCAL): Likewise.

	* elflink.c (_bfd_elf_dynamic_symbol_p): Return TRUE
	immediately if symbol isn't defined locally.

2003-07-18  Richard Henderson  <rth@redhat.com>

	* elflink.c (_bfd_elf_dynamic_symbol_p): New.
	* elf-bfd.h (_bfd_elf_dynamic_symbol_p): Declare it.
	(SYMBOL_REFERENCES_LOCAL, SYMBOL_CALLS_LOCAL): Use it.
	* elf32-xtensa.c (xtensa_elf_dynamic_symbol_p): Likewise.
	* elf64-alpha.c (alpha_elf_dynamic_symbol_p): Likewise.
	* elf64-hppa.c (elf64_hppa_dynamic_symbol_p): Likewise.
	* elfxx-ia64.c (elfNN_ia64_dynamic_symbol_p): Likewise.
	Update all callers to provide the relocation being resolved.

2003-07-17  Shaun Jackman <sjackman@pathwayconnect.com>

	* config.bfd (arm-wince-pe): Add -DARM_COFF_BUGFIX to
	targ_cflags.

2003-07-17  Nick Clifton  <nickc@redhat.com>

	* po/es.po: New Spanish translation.
	* po/sv.po: New Swedish translation.
	* po/opcodes.pot: Regenerate.

2003-07-16  Richard Henderson  <rth@redhat.com>

	* config.bfd, configure.host, configure.in: Remove ia64-aix support.
	* elfxx-ia64.c, targets.c: Likewise.

2003-07-16  Richard Henderson  <rth@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_dynamic_symbol_p): Properly return false
	for symbols defined locally plus -Bsymbolic.  Tidy logic.

2003-07-15  Richard Sandiford  <rsandifo@redhat.com>

	* archures.c (bfd_mach_mips7000): New.
	* bfd-in2.h: Regenerated.
	* cpu-mips.c (arch_info_struct): Add an entry for mips:7000.
	* elfxx-mips.c (mips_set_isa_flags): Handle bfd_mach_mips7000.
	(mips_mach_extensions): Add an entry for it.

2003-07-14  Nick Clifton  <nickc@redhat.com>

	* po/tr.po: Update with latest version.
	* po/SRC-POTFILES.in: Regenerate.
	* po/bfd.pot: Regenerate.
	* Makfile.in: Regenerate.
	* configure: Regenerate.

2003-07-12  Jeff Baker  <jbaker@qnx.com>

	* config.bfd (__QNXTARGET__): Define for Neutrino architectures.
	* elf32-arm.h (ELF_MAXPAGESIZE): Set to 4k for Neutrino.
	* elf32-sh.c (ELF_MAXPAGESIZE): Set to 4k for Neutrino.
	* elf32-ppc.c (ELF_MAXPAGESIZE): Set to 4k for Neutrino.

2003-07-12  Jeff Muizelaar  <muizelaar@rogers.com>

	* coffcode.h (coff_set_section_contents): Set the
	IMAGE_FILE_32BIT_MACHINE flag for PE targets.

2003-07-11  Richard Sandiford  <rsandifo@redhat.com>

	* bfd-in.h (bfd_h8300_pad_address): Declare.
	* bfd-in2.h: Regenerate.
	* cpu-h8300.c (bfd_h8300_pad_address): New function.
	* coff-h8300.c (h8300_reloc16_estimate): Use it to canonicalize
	addresses before checking whether they can be relaxed.
	(h8300_reloc16_extra_cases): Likewise for the R_MOVL2 sanity check.
	Don't complain about overflows in general 8-bit relocations.
	* elf32-h8300.c (elf32_h8_relax_section): Use bfd_h8300_pad_address.
	Fix handling of R_H8_DIR24A8.

2003-07-11  Richard Sandiford  <rsandifo@redhat.com>

	* elf32-h8300.c: Convert function prototypes and definitions
	to C90 syntax.
	* coff-h8300.c: Likewise.
	* cpu-h8300.c: Likewise.

2003-07-11  Alan Modra  <amodra@bigpond.net.au>

	* po/SRC-POTFILES.in: Regenerate.
	* po/bfd.pot: Likewise.

2003-07-10  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (elf_xtensa_create_dynamic_sections): Create new
	.got.loc section.  Do not set SEC_ALLOC or SEC_LOAD flags for the
	.xt.lit.plt section.
	(elf_xtensa_size_dynamic_sections): Set size of the .got.loc section
	and allocate memory for it.
	(elf_xtensa_combine_prop_entries): Copy contents of .xt.lit output
	section to the .got.loc section.
	(elf_xtensa_finish_dynamic_sections): Fix up call to
	elf_xtensa_combine_prop_entries and set DT_XTENSA_GOT_LOC_OFF to
	the address of .got.loc.
	(relax_property_section): Shrink .got.loc to match changes in any
	literal table section.
	(xtensa_is_property_section): Change to match
	xtensa_get_property_section_name.
	(xtensa_is_littable_section): New.

2003-07-10  H.J. Lu <hongjiu.lu@intel.com>

	* elfxx-ia64.c (IA64_HOWTO): Set dst_mask to -1 instead of
	-1LL.

2003-07-10  Alan Modra  <amodra@bigpond.net.au>

	* Makefile.am (BFD32_BACKENDS): Add elf32-am33lin.lo.
	(BFD32_BACKENDS_CFILES): elf32-am33lin.c not elf32-am33lin.lo.
	Run "make dep-am".
	* Makefile.in: Regenerate.

2003-07-10  Alexandre Oliva  <aoliva@redhat.com>

	2001-09-12  Alexandre Oliva  <aoliva@redhat.com>
	* elf32-am33lin.c (ELF_MACHINE_CODE): Redefine to EM_MN10300.
	(ELF_MACHINE_ALT1): Define to EM_CYGNUS_MN10300.
	2001-06-02  Nick Clifton  <nickc@cambridge.redhat.com>
	* elf32-am33lin.c: Rename global functions.
	2001-05-09  Alexandre Oliva  <aoliva@redhat.com>
	* config.bfd (am33_2.0, am33_2.0-*-linux*): Added.
	* configure.in (bfd_elf32_am33lin_vec): Added.
	* Makefile.am (BFD32_BACKENDS): Added elf32-am33lin.lo.
	(elf32-am33lin.lo): List dependencies.
	* aclocal.m4, configure, Makefile.in: Rebuilt.
	* elf-m10300.c (TARGET_LITTLE_SYM, TARGET_LITTLE_NAME,
	ELF_ARCH, ELF_MACHINE_CODE, ELF_MAXPAGESIZE): Define only if
	ELF_ARCH was not defined before.
	(elf_symbol_leading_char): Define if not defined.
	* elf32-am33lin.c: Override the definitions above.
	* targets.c (bfd_elf32_am33lin_vec): New.

2003-07-09  Alexandre Oliva  <aoliva@redhat.com>

	2002-12-12  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c (elf32_mn10300_link_hash_newfunc): Initialize
	pcrel_relocs_copied.
	2001-12-13  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c (ELF_DYNAMIC_INTERPRETER): Renamed from
	ld-linux.so.2 to ld.so.1.
	2001-10-10  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c (elf_mn10300_sizeof_plt0): New macro.
	(_bfd_mn10300_elf_adjust_dynamic_symbol): Use it.
	(_bfd_mn10300_elf_finish_dynamic_symbol): Likewise.
	* elf-m10300.c (_bfd_mn10300_elf_size_dynamic_sections): Allocate
	.rela.* section contents with bfd_zalloc.
	2001-09-25  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c: Added declarations for functions missing them.
	Merge some shared-library changes from the i386 back-end.  Use
	R_MN10300_RELATIVE instead of R_MN10300_PCREL32 and
	R_MN10300_GLOB_DAT instead of R_MN10300_32 where appropriate.
	(struct elf32_mn10300_link_hash_entry): Remove duplicates of
	members of elf_link_hash_entry.  Adjusted references.
	(mn10300_elf_final_link_relocate): dynobj was already loaded
	into a local variable, use it.
	2001-09-21  Nick Clifton  <nickc@cambridge.redhat.com>
	* elf-m10300.c: Add missing function prototypes.
	2001-08-24  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c (mn10300_elf_relocate_section): Don't compute
	relocation for dynamic relocations.
	2001-05-16  Alexandre Oliva  <aoliva@redhat.com>
	* reloc.c (BFD_RELOC_MN10300_GOTOFF24): New.
	* elf-m10300.c: Introduce GOTPC16, GOTOFF24, GOTOFF16 and
	PLT16, and rename GOTPC to GOTPC32 and GOTOFF to GOTOFF32.
	(_bfd_mn10300_elf_create_dynamic_sections): Move creation ot PLT...
	(_bfd_mn10300_elf_create_got_section): ... here, so that its
	adress is already known at the time we compute relaxations.
	(mn10300_elf_relax_section): Relax GOTPC32, GOTOFF32, GOT32
	and PLT32 to narrower relocations.
	* libbfd.h, bfd-in2.h: Rebuilt.
	2001-04-12  Alexandre Oliva  <aoliva@redhat.com>
	* reloc.c (BFD_RELOC_MN10300_GOT32, BFD_RELOC_MN10300_GOT24,
	BFD_RELOC_MN10300_GOT16, BFD_RELOC_MN10300_COPY,
	BFD_RELOC_MN10300_GLOB_DAT, BFD_RELOC_MN10300_JMP_SLOT,
	BFD_RELOC_MN10300_RELATIVE): New relocs.
	* libbfd.h, bfd-in2.h: Rebuilt.
	* elf-m10300.c (struct elf_mn10300_pcrel_relocs_copied): New.
	(struct elf32_mn10300_link_hash_entry): Added DSO-related
	fields.
	(elf_mn10300_howto): Defined new relocation types.
	(mn10300_reloc_map): Map them.
	(_bfd_mn10300_elf_create_got_section): New fn.
	(mn10300_elf_check_relocs): Handle PIC relocs.
	(mn10300_elf_final_link_relocate): Likewise.
	(mn10300_elf_relocate_section): Handle DSOs.
	(PLT0_ENTRY_SIZE, PLT_ENTRY_SIZE, PIC_PLT_ENTRY_SIZE): New macros.
	(elf_mn10300_plt0_entry, elf_mn10300_plt_entry,
	elf_mn10300_pic_plt_entry): New.
	(elf_mn10300_sizeof_plt, elf_mn10300_plt_plt0_offset,
	elf_mn10300_plt0_linker_offset, elf_mn10300_plt0_gotid_offset,
	elf_mn10300_plt_temp_offset, elf_mn10300_plt_symbol_offset,
	elf_mn10300_plt_reloc_offset: New macros.
	(ELF_DYNAMIC_INTERPRETER): Likewise.
	(_bfd_mn10300_elf_create_dynamic_sections): New function.
	(_bfd_mn10300_elf_adjust_dynamic_symbol): Likewise.
	(_bfd_mn10300_elf_discard_copies): Likewise.
	(_bfd_mn10300_elf_size_dynamic_sections): Likewise.
	(_bfd_mn10300_elf_finish_dynamic_symbol): Likewise.
	(_bfd_mn10300_elf_finish_dynamic_sections): Likewise.
	(elf_backend_can_gc_sections,
	elf_backend_create_dynamic_sections,
	elf_backend_adjust_dynamic_sections,
	elf_backend_size_dynamic_sections,
	elf_backend_finish_dynamic_symbol,
	elf_backend_finish_dynamic_sections, elf_backend_want_got_plt,
	elf_backend_plt_readonly, elf_backend_want_plt_sym,
	elf_backend_got_header_size, elf_backend_plt_header_size): New
	macros.

2003-07-09  Alexandre Oliva  <aoliva@redhat.com>

	2001-05-06  Alexandre Oliva  <aoliva@redhat.com>
	* elf-m10300.c (compute_function_info): Account for AM33
	registers in `movm' when computing stack space for `call' when
	linking for AM33/2.0 link.
	2000-04-01  Alexandre Oliva  <aoliva@cygnus.com>
	* archures.c (bfd_mach_am33_2): Renamed from bfd_mach_am332.
	* bfd-in2.h: Rebuilt.
	* cpu-m10300.c (bfd_am33_2_arch): Renamed from bfd_am332_arch.
	* elf-m10300.c: Updated.
	2000-03-31  Alexandre Oliva  <aoliva@cygnus.com>
	* archures.c (bfd_mach_am332): Defined.
	* bfd-in2.h: Rebuilt.
	* cpu-m10300.c (bfd_am332_arch): Defined.
	(bfd_am33_arch): Chained with am33-2.
	* elf-m10300.c (elf_mn10300_mach): Handle am332.
	(_bfd_mn10300_elf_final_write_processing): Likewise.

2003-07-09  H.J. Lu <hongjiu.lu@intel.com>

	* elfxx-ia64.c (IA64_HOWTO): Set dst_mask to -1LL.

2003-07-10  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (bfd_elf64_mkobject): Define.
	(struct ppc64_elf_obj_tdata): New.
	(ppc64_elf_tdata, ppc64_tlsld_got): Define.
	(ppc64_elf_mkobject): New function.
	(struct got_entry): Add "owner".  Move "tls_type".
	(struct ppc_link_hash_table): Delete "relgot", "tlsld_got".
	(ppc64_elf_init_stub_bfd): New function.
	(create_got_section): Create header .got in dynobj.  Create .got
	and .rela.got in each bfd.  Stash pointers in ppc64_elf_obj_tdata.
	(ppc64_elf_create_dynamic_sections): Don't call create_got_section.
	Look for dynobj .got, and test it.
	(ppc64_elf_copy_indirect_symbol): Adjust for changed got.
	(update_local_sym_info): Likewise.
	(ppc64_elf_check_relocs): Likewise.
	(ppc64_elf_gc_sweep_hook): Likewise.
	(ppc64_elf_tls_optimize): Likewise.
	(allocate_dynrelocs): Likewise.
	(ppc64_elf_size_dynamic_sections): Likewise.
	(ppc64_elf_relocate_section): Likewise.
	(ppc64_elf_next_toc_section): Update comment.
	(toc_adjusting_stub_needed): Remove unneeded cast.
	(ppc64_elf_build_stubs): Check for stub sections in stub bfd by
	testing section flags.
	(ppc64_elf_build_stubs): Likewise.
	(ppc64_elf_size_stubs): Likewise.  Remove stub_bfd param.
	(ppc64_elf_finish_dynamic_sections): Write out got sections.
	(func_desc_adjust): Copy over dynamic info for undef weaks.
	* elf64-ppc.h (ppc64_elf_init_stub_bfd): Declare.
	(ppc64_elf_size_stubs): Update prototype.
	* elflink.h (elf_link_sort_relocs): Use link_orders to find reldyn
	input sections rather than scanning dynobj.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_link_hash_entry): Remove min_dyn_reloc_index.
	(bfd_mips_elf_swap_msym_in, bfd_mips_elf_swap_msym_out): Delete.
	(mips_elf_create_msym_section): Delete.
	(mips_elf_create_dynamic_relocation): Don't set min_dyn_reloc_index.
	(_bfd_mips_elf_copy_indirect_symbol): Likewise.
	(_bfd_mips_elf_create_dynamic_sections): Don't create .msym.
	(_bfd_mips_elf_size_dynamic_sections): Don't calculate its size.
	(_bfd_mips_elf_size_dynamic_sections): Don't add DT_MIPS_MSYM.
	(_bfd_mips_elf_finish_dynamic_symbol): Don't add symbols to .msym.
	(_bfd_mips_elf_finish_dynamic_sections): Likewise.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_irix6_finish_dynamic_symbol): Make the
	symbols protected.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_create_dynamic_relocation): Fix handling
	of relocations whose offset is -2.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_create_dynamic_relocation): Treat
	forced-local symbols like other locals.  Don't create relocations
	against STN_UNDEF in irix objects.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_create_dynamic_relocation): In SGI-
	compatible objects, add the values of defined external symbols
	to the addend.

2003-07-09  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (_bfd_mips_elf_finish_dynamic_symbol): Always
	initialize a GOT entry to the symbol's st_value.

2003-07-08  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct elf_obj_tdata): Move linker_section_pointers..
	* elf32-ppc.c (struct ppc_elf_obj_tdata): ..to here.  New.
	(ppc_elf_tdata): Define.
	(elf_local_ptr_offsets): Adjust.
	(ppc_elf_mkobject): New function.
	(bfd_elf32_mkobject): Define.

	* elfcode.h (elf_object_p): Allocate tdata via _bfd_set_format.
	* elfcore.h (elf_core_file_p): Likewise.
	* section.c (bfd_section_init): Remove prototype.

2003-07-08  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct elf_link_hash_entry): Remove linker_section_pointer
	field.
	(enum elf_linker_section_enum): Delete.
	(struct elf_linker_section): Delete.
	(struct elf_linker_section_pointers): Delete.
	(struct elf_obj_tdata): Remove #if 0 chunk.  Remove linker_section.
	Make linker_section_pointers a void**.
	(elf_local_ptr_offsets, elf_linker_section): Don't define.
	* elf32-ppc.c (enum elf_linker_section_enum): New, cut-down version
	of old item in elf-bfd.h.
	(struct elf_linker_section): Likewise.
	(struct elf_linker_section_pointers): Likewise.
	(elf_local_ptr_offsets): Define.
	(struct ppc_elf_link_hash_entry): Add linker_section_pointer.
	(ppc_elf_link_hash_newfunc): Init it.
	(struct ppc_elf_link_hash_table): Add sbss.
	(ppc_elf_link_hash_table_create): zmalloc rather than clearing
	individual fields.
	(elf_create_linker_section): Fold into..
	(ppc_elf_create_linker_section): ..here.  Remove hole_size code.
	Make rela section here if shared.
	(elf_find_pointer_linker_section): Pass lsect rather than enum.
	(elf_create_pointer_linker_section): Adjust.  zalloc rather than
	clearing in a loop.
	(elf_finish_pointer_linker_section): Adjust.  Don't make rela
	section here.
	(ppc_elf_check_relocs): Adjust.
	(ppc_elf_add_symbol_hook): Tighten hash creator test.  Remove code
	creating .sbss by hand.
	* elf.c (_bfd_elf_link_hash_newfunc): Adjust.

2003-07-04  Jakub Jelinek  <jakub@redhat.com>

	* elf32-s390.c (elf_howto_table): Change R_390_GOT12 to
	complain_overflow_bitfield.
	* elf64-s390.c (elf_howto_table): Change R_390_GOT12 to
	complain_overflow_bitfield.

2003-07-04  Jakub Jelinek  <jakub@redhat.com>

	* elf-bfd.h (SYMBOL_REFERENCES_LOCAL, SYMBOL_CALLS_LOCAL): Return
	true even if -pie.

2003-07-04  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (struct elfNN_ia64_link_hash_table): Add rel_fptr_sec.
	(elfNN_ia64_dynamic_symbol_p): Change info->shared into
	!info->executable.
	(get_fptr): For -pie create .opd as writable section and create
	.rela.opd as well.
	(elfNN_ia64_check_relocs): Change info->shared into
	!info->executable.
	(allocate_fptr): Likewise.
	(allocate_dynrel_entries): Account for a relative reloc for -pie
	@fptr().  Don't account for a relative reloc if -pie want_ltoff_fptr
	for undefweak symbol.  Account for an IPLT reloc in .rela.opd
	section if -pie.
	(set_got_entry): Don't create a relative reloc if -pie
	want_ltoff_fptr for undefweak symbol.
	(set_fptr_entry): Emit an IPLT reloc in .rela.opd for -pie.
	(elfNN_ia64_relocate_section): Emit a relative reloc for -pie
	@fptr().

	* elfxx-ia64.c (elfNN_ia64_relocate_section): Issue undefined_symbol
	even if -pie.
	* elf32-i386.c (elf_i386_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf32-s390.c (elf_s390_relocate_section): Likewise.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.

2003-07-04  Paul Clarke <paulc@senet.com.au>

	* elf32-h8300.c (R_H8_DIR32A16): Fix name field.
	(elf32_h8_relax_section) <R_H8_DIR16A8>: Adjust position of relocation.
	<R_H8_DIR32A16>: Fix type of relocation.

2003-07-04  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_create_dynamic_sections): Return if dynamic
	sections were created already.  Remove unnecessary tests of
	the previous change.

2003-07-04  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_create_dynamic_sections): Don't call
	bfd_make_section for existing sections.

2003-07-04  Alan Modra  <amodra@bigpond.net.au>

	* elf32-sparc.c (elf32_sparc_check_relocs): Don't call
	create_got_section if we already have done so.
	* elf32-sh.c (sh_elf_create_dynamic_sections): Likewise.
	(sh_elf_check_relocs): Likewise.
	(sh_elf_adjust_dynamic_symbol): Delete "dynobj" var.  Use
	htab->root.dynobj instead.
	(sh_elf_check_relocs): Likewise.
	(sh_elf_finish_dynamic_sections): Likewise.

	* section.c (bfd_make_section): Return NULL for existing section.

2003-07-04  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_create_dynamic_sections): Don't call
	ppc_elf_create_got if we've already done so.

	* elf-bfd.h (_bfd_elf_create_linker_section) Don't declare.
	(_bfd_elf_find_pointer_linker_section): Likewise.
	(bfd_elf32_create_pointer_linker_section): Likewise.
	(bfd_elf32_finish_pointer_linker_section): Likewise.
	(bfd_elf64_create_pointer_linker_section): Likewise.
	(bfd_elf64_finish_pointer_linker_section): Likewise.
	(_bfd_elf_make_linker_section_rela): Likewise.
	* elfcode.h (elf_create_pointer_linker_section): Don't define.
	(elf_finish_pointer_linker_section): Likewise.
	* elflink.c (_bfd_elf_make_linker_section_rela): Delete.
	(_bfd_elf_create_linker_section): Move this function..
	(_bfd_elf_find_pointer_linker_section): ..and this..
	* elflink.h (elf_create_pointer_linker_section): ..and this..
	(elf_finish_pointer_linker_section): ..and this..
	* elf32-ppc.c: ..to here, renaming to the following, and adjusting
	calls.
	(elf_create_linker_section): Convert to C90, tidy.
	(elf_find_pointer_linker_section): Likewise.
	(elf_create_pointer_linker_section): Likewise.
	(elf_finish_pointer_linker_section): Likewise.
	* elf32-i370.c: Delete #if 0 code.

2003-07-02  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_func_desc_adjust): Don't allow _savef* and
	_restf* to be satisfied by shared libs, and always force them local.
	(toc_adjusting_stub_needed): Avoid scanning linker created sections.
	Correct test for "bl".
	(ppc64_elf_relocate_section <R_PPC64_TLS>): Correct test for
	primary opcode 31.

2003-07-01  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (s390_elf_ldisp_reloc): New prototype.
	(s390_tls_reloc): New function.
	(elf_howto_table): Add long displacement relocations R_390_20,
	R_390_GOT20, R_390_GOTPLT20 and R_390_TLS_GOTIE20.
	(elf_s390_reloc_type_lookup): Likewise.
	(elf_s390_check_relocs): Likewise.
	(elf_s390_gc_sweep_hook): Likewise.
	(elf_s390_relocate_section): Likewise.
	* elf64-s390.c: Same changes as for elf32-s390.c.
	* reloc.c: Add long displacement relocations BFD_RELOC_390_20,
	BFD_RELOC_390_GOT20, BFD_RELOC_390_GOTPLT20 and
	BFD_RELOC_390_TLS_GOTIE20.
	* bfd-in2.h: Regenerate.
	* libbfd.h: Likewise.

2003-06-30  Alan Modra  <amodra@bigpond.net.au>

	* cpu-ia64-opc.c (ext_imms_scaled): Don't sign extend using shifts.
	(ins_imms, ins_immsm1u4): Likewise.  Warning fix.

2003-06-29  Alan Modra  <amodra@bigpond.net.au>

	* archive.c: Convert to C90, remove unnecessary prototypes and casts.
	Replace PTR with void *.  Formatting.
	* archive64.c: Likewise.
	* archures.c: Likewise.
	* bfd-in.h: Likewise.
	* bfd.c: Likewise.
	* bfdio.c: Likewise.
	* bfdwin.c: Likewise.
	* cache.c: Likewise.
	* corefile.c: Likewise.
	* format.c: Likewise.
	* init.c: Likewise.
	* libbfd-in.h: Likewise.
	* libbfd.c: Likewise.
	* linker.c: Likewise.
	* opncls.c: Likewise.
	* reloc.c: Likewise.
	* section.c: Likewise.
	* simple.c: Likewise.
	* syms.c: Likewise.
	* targets.c: Likewise.
	* bfd-in2.h: Regenerate.
	* libbfd.h: Regenerate.

	* ecoff.c (bfd_debug_section): Add missing kept_section initialization.
	* libbfd-in.h (_bfd_sh_align_load_span): Don't declare if defined.
	* libbfd.c (COERCE32, EIGHT_GAZILLION): Simplify.
	(bfd_getb64): Rewrite without parens.
	(bfd_getl64, bfd_getb_signed_64, bfd_getl_signed_64): Likewise.
	* cache.c (insert, snip): Remove INLINE.
	* linker.c (bfd_link_add_undef): Likewise.

2003-06-29  Andreas Jaeger  <aj@suse.de>

	* elf64-x86-64.c: Convert to ISO C90 prototypes, remove
	unnecessary prototypes.  Replace PTR with void *.
	(elf64_x86_64_adjust_dynamic_symbol): Use SYMBOL_CALLS_LOCAL to
	trim plt entries.  Move undefweak non-default visibility test ...
	(allocate_dynrelocs): ... from here.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead of INFO.
	Change all callers.
	(allocate_dynrelocs): Use SYMBOL_CALLS_LOCAL.  Use
	SYMBOL_REFERENCES_LOCAL for dynreloc check.
	(elf64_x86_64_relocate_section): Use SYMBOL_CALLS_LOCAL for
	dynreloc and .got relocs.
	(elf64_x86_64_finish_dynamic_symbol): Use SYMBOL_REFERENCES_LOCAL
	for .got relocs.

2003-06-29  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c: Allow lazy binding for R_MIPS_JALR.

2003-06-27  Nick Clifton  <nickc@redhat.com>

	* opncls.c (bfd_add_gnu_debuglink_section): Rename to
	bfd_add_gnu_debuglink_section and only create the section, do not
	fill in its contents.
	(bfd_fill_in_gnu_debuglink_section): New function.  Fill in the
	contents of a .gnu-debuglink section.
	* bfd-in2.h: Regenerate.

2003-06-27  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c: Revert .got alignment to 2**4.

2003-06-27  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elf32-mips.c: Fix addend for _gp_disp special symbol.

2003-06-27  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c (_bfd_mips_elf_fake_sections): Remove non-default
	relocation header setup.

2003-06-25  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_howto_table): Remove unnecessary cast.
	(ppc_elf_reloc_type_lookup): Modify comment.
	(ppc_elf_info_to_howto): Ditto.
	(ppc_elf_relocate_section): Ditto.
	(ppc_elf_check_relocs): Call ppc_elf_howto_init.

2003-06-25  Alan Modra  <amodra@bigpond.net.au>

	* aout-ns32k.c: Correct spelling of "relocatable".
	* aoutx.h: Likewise.
	* bfd-in.h: Likewise.
	* bfd.c: Likewise.
	* bout.c: Likewise.
	* coff-a29k.c: Likewise.
	* coff-alpha.c: Likewise.
	* coff-arm.c: Likewise.
	* coff-i386.c: Likewise.
	* coff-i860.c: Likewise.
	* coff-i960.c: Likewise.
	* coff-m68k.c: Likewise.
	* coff-m88k.c: Likewise.
	* coff-mcore.c: Likewise.
	* coff-mips.c: Likewise.
	* coff-or32.c: Likewise.
	* coff-ppc.c: Likewise.
	* coff-rs6000.c: Likewise.
	* coff-sh.c: Likewise.
	* coff-tic80.c: Likewise.
	* coff64-rs6000.c: Likewise.
	* cofflink.c: Likewise.
	* cpu-ns32k.c: Likewise.
	* ecoff.c: Likewise.
	* ecofflink.c: Likewise.
	* elf-bfd.h: Likewise.
	* elf-eh-frame.c: Likewise.
	* elf-hppa.h: Likewise.
	* elf-m10200.c: Likewise.
	* elf-m10300.c: Likewise.
	* elf.c: Likewise.
	* elf32-arm.h: Likewise.
	* elf32-avr.c: Likewise.
	* elf32-cris.c: Likewise.
	* elf32-d10v.c: Likewise.
	* elf32-dlx.c: Likewise.
	* elf32-fr30.c: Likewise.
	* elf32-frv.c: Likewise.
	* elf32-h8300.c: Likewise.
	* elf32-hppa.c: Likewise.
	* elf32-i370.c: Likewise.
	* elf32-i386.c: Likewise.
	* elf32-i860.c: Likewise.
	* elf32-i960.c: Likewise.
	* elf32-ip2k.c: Likewise.
	* elf32-iq2000.c: Likewise.
	* elf32-m32r.c: Likewise.
	* elf32-m68hc11.c: Likewise.
	* elf32-m68hc1x.c: Likewise.
	* elf32-m68k.c: Likewise.
	* elf32-mcore.c: Likewise.
	* elf32-mips.c: Likewise.
	* elf32-msp430.c: Likewise.
	* elf32-openrisc.c: Likewise.
	* elf32-ppc.c: Likewise.
	* elf32-s390.c: Likewise.
	* elf32-sh.c: Likewise.
	* elf32-sh64.c: Likewise.
	* elf32-sparc.c: Likewise.
	* elf32-v850.c: Likewise.
	* elf32-vax.c: Likewise.
	* elf32-xstormy16.c: Likewise.
	* elf32-xtensa.c: Likewise.
	* elf64-alpha.c: Likewise.
	* elf64-hppa.c: Likewise.
	* elf64-mips.c: Likewise.
	* elf64-mmix.c: Likewise.
	* elf64-ppc.c: Likewise.
	* elf64-s390.c: Likewise.
	* elf64-sh64.c: Likewise.
	* elf64-sparc.c: Likewise.
	* elf64-x86-64.c: Likewise.
	* elfcode.h: Likewise.
	* elflink.h: Likewise.
	* elfn32-mips.c: Likewise.
	* elfxx-ia64.c: Likewise.
	* elfxx-mips.c: Likewise.
	* i386linux.c: Likewise.
	* ieee.c: Likewise.
	* libcoff-in.h: Likewise.
	* linker.c: Likewise.
	* m68klinux.c: Likewise.
	* pdp11.c: Likewise.
	* pe-mips.c: Likewise.
	* peXXigen.c: Likewise.
	* reloc.c: Likewise.
	* reloc16.c: Likewise.
	* sparclinux.c: Likewise.
	* sunos.c: Likewise.
	* syms.c: Likewise.
	* versados.c: Likewise.
	* vms.c: Likewise.
	* xcofflink.c: Likewise.
	* bfd-in2.h: Regenerate.
	* libcoff.h: Regenerate.
	* libbfd.h: Regenerate.

2003-06-24  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_check_relocs): Report plt reloc against
	local sym errors.

	* elf32-i386.c: Convert to C90 function definitions, remove unnecessary
	prototypes and casts.  Replace PTR with void *.  Formatting.
	* elf32-ppc.c: Likewise.  Break long strings too.
	(ppc_elf_relax_section): Use enum elf_ppc_reloc_type for r_type.
	(ppc_elf_unhandled_reloc): Internationalize error message.
	* elf32-ppc.h: Remove PARAMS.

2003-06-23  Mark Mitchell  <mark@codesourcery.com>

	* elf32-ppc.c (ppc_elf_begin_write_processing): Use bytes to count
	APUinfo slots.
	(ppc_elf_final_write_processing): Likewise.

2003-06-23  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.h (elf_link_input_bfd): Check raw size when using
	kept_section to preserve debug information discarded by
	linkonce.

2003-06-20  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (struct ppc_link_hash_table): Add top_id.
	(ppc64_elf_setup_section_lists): Set it.
	(ppc64_elf_relocate_section): Check sym section id against top_id.
	(ppc_build_one_stub): Comment on top_id.

2003-06-20  Ralf Corsepius  <corsepiu@faw.uni-ulm.de>

	* config.bfd: Add tic4x-*-rtems*.

2003-06-20  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Convert to C90 function definitions, remove unnecessary
	prototypes and casts.  Replace PTR with void *.  Format copyright.
	Mention ABI links.
	(struct ppc_link_hash_table): Rename sgot, srelgot, splt, srelplt,
	sdynbss, srelbss, sglink, sbrlt and srelbrlt to got, relgot .. relbrlt.
	(ppc_type_of_stub): Make r_type an enum.
	(ppc64_elf_size_stubs): Likewise.
	* elf64-ppc.h: Remove PARAMS macro.

2003-06-19  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_link_hash_table_create): Reinstate init of
	elf hash tab fields.

	* elf64-ppc.c (ppc64_elf_reloc_type_lookup): Tidy prototype.
	(ppc64_elf_info_to_howto): Likewise.
	(ppc64_elf_build_stubs): Add "stats" param, and print statistics.
	* elf64-ppc.h (ppc64_elf_build_stubs): Adjust prototype.

2003-06-19  Alan Modra  <amodra@bigpond.net.au>

	* elf64-sparc.c (sparc64_elf_relocate_section): Ignore R_SPARC_DISP32
	reloc overflow on discarded eh_frame entries.

2003-06-19  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (toc_adjusting_stub_needed): New function.
	(ppc64_elf_next_input_section): Use it here to set has_gp_reloc.
	Return error condition.
	(ppc64_elf_size_stubs): Restrict toc adjusting stubs to sections
	that have has_gp_reloc set.
	(struct ppc_link_hash_table): Add stub_count.
	(ppc_build_one_stub): Increment it.
	(ppc64_elf_link_hash_table_create): zmalloc rather than clearing
	individual fields.
	* elf64-ppc.h (ppc64_elf_next_input_section): Update prototype.

2003-06-18  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_gc_record_vtentry): Revert last change.  Correct
	size calculation from addend.  Round size up.

2003-06-18  Hans-Peter Nilsson  <hp@axis.com>

	* elf32-cris.c (cris_elf_relocate_section) <case
	R_CRIS_32_GOTREL>: When linking a program, don't complain about a
	symbol from a normal object or an undefined weak symbol.

2003-06-18  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): Accept a symbol on
	R_PPC64_TOC relocs.

2003-06-17  H.J. Lu <hongjiu.lu@intel.com>

	* section.c (struct sec): Put back kept_section.
	(STD_SECTION): Put back kept_section initialization.
	* bfd-in2.h: Regenerate.

	* elflink.h (elf_link_input_bfd): Also check discarded linkonce
	sections for relocateable output. Use kept_section to preserve
	debug information discarded by linkonce.

2003-06-17  Roland McGrath  <roland@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relocate_section): Support
	segment-relative relocation between different segments.

2003-06-17  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): Do unaligned reloc
	optimizations earlier.

	* elf64-ppc.c (struct ppc_link_hash_table): Reinstate top_index.
	Restore previous input_list type.
	(ppc64_elf_link_hash_table_create): Undo last change.
	(ppc64_elf_setup_section_lists): Reinstate code setting up input lists
	per output section, but don't bother with bfd_abs_section marker.
	(ppc64_elf_next_input_section): Adjust for multiple input section
	lists.
	(group_sections): Likewise.

2003-06-17  Jakub Jelinek  <jakub@redhat.com>

	* elf64-ppc.c (ppc64_elf_relocation_section): Ensure
	*r_offset == r_addend for RELATIVE relocs against .got.

2003-06-17  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): Optimize unaligned relocs.

2003-06-17  Nick Clifton  <nickc@redhat.com>

	* elflink.h (elf_gc_record_vtentry): Allocate an extra element
	in the vtable_entries_used array to allow for the accessing
	the largest element.

2003-06-17  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (struct ppc_link_hash_table): Remove top_index.  Modify
	input_list.
	(ppc64_elf_link_hash_table_create): Init input_list here.
	(ppc64_elf_setup_section_lists): Remove code setting up input lists
	per output section.  Set toc_off for abs and other standard sections.
	(ppc64_elf_reinit_toc): Don't set elf_gp on input bfds lacking a toc.
	(ppc64_elf_next_input_section): Adjust for single input section list.
	Don't set toc_curr from input bfds that haven't set elf_gp.
	(group_sections): Adjust for single input section list.

	* elf64-ppc.c (ppc64_elf_relocate_section): Correct pcrel section zero.

2003-06-16  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): When optimizing toctprel
	tls, check that a TOC16_DS or TOC16_LO_DS reloc isn't pointing to a
	dtprel entry.  Ensure TLS_LD DTPMOD reloc has a zero addend.  Write
	got section for RELATIVE relocs.  Fix wrong comment.  Change condition
	under which dynamic relocs update the section contents.

2003-06-13  Robert Millan  <zeratul2@wanadoo.es>

	* config.bfd: Add i386-netbsd-gnu target.

2003-06-12  Nick Clifton  <nickc@redhat.com>

	* opncls.c (calc_crc32): Rename to
	bfd_calc_gnu_debuglink_crc32 and export.
	(GNU_DEBUGLINK): Define and use to replace occurrences of
	hard-coded ".gnu_debuglink" in the code.
	(get_debug_link_info): Prevent aborts by replacing call to
	xmalloc with a call to malloc.
	(find_separate_debug_file): Prevent aborts by replacing calls
	to xmalloc and xstrdup with calls to malloc and strdup.
	(bfd_add_gnu_debuglink): New function.  Add a .gnu_debuglink
	section to a bfd.
	* bfd-in2.h: Regenerate.

2003-06-12 Federico G. Schwindt <fgsch@lodoss.net>

	* config.bfd (i[3-7]86-*-openbsd[0-2].* | i[3-7]86-*-openbsd3.[0-3]):
	New target (was i[3-7]86-*-openbsd* before).
	(i[3-7]86-*-openbsd*): Change to use bfd_elf32_i386_vec.
	(vax-*-openbsd*): New target.

2003-06-11  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c (MIPS_ELF_OPTIONS_SECTION_NAME): Use .MIPS.options
	for n32, too.
	(MIPS_ELF_STUB_SECTION_NAME): Use .MIPS.stubs for n32, too.
	(mips_elf_rel_dyn_section): Use appropriate section alignment.
	(mips_elf_create_got_section): Likewise.
	(_bfd_mips_elf_create_dynamic_sections): Likewise.

2003-06-11  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elf32-mips.c (mips_elf_generic_reloc): New Function.
	(elf_mips_howto_table_rel): Use it.
	(gprel32_with_gp): Move prototype.
	(mips_elf_hi16_reloc): Check for ! BSF_LOCAL instead of zero addend.
	Use mips_elf_generic_reloc.
	(mips_elf_got16_reloc): Check for ! BSF_LOCAL instead of zero addend.
	Code cleanup.
	(_bfd_mips_elf32_gprel16_reloc): Check for ! BSF_LOCAL instead of
	zero addend.
	(mips_elf_gprel32_reloc): Likewise. Use the same GP assignment logic
	as in the other *_gprel*_reloc functions.
	(gprel32_with_gp): Handle partial_inplace properly.
	(mips32_64bit_reloc): Use mips_elf_generic_reloc.
	(mips16_gprel_reloc): Check for ! BSF_LOCAL instead of zero addend.
	Do addend handling directly instead of calling
	_bfd_mips_elf_gprel16_with_gp. Handle partial_inplace properly.
	* elf64-mips.c (mips_elf64_hi16_reloc): Check for ! BSF_LOCAL instead
	of zero addend. Handle partial_inplace properly.
	(mips_elf64_got16_reloc): Check for ! BSF_LOCAL instead of zero
	addend.
	(mips_elf64_gprel16_reloc): Likewise.
	(mips_elf64_literal_reloc): Likewise.
	(mips_elf64_gprel32_reloc): Likewise. Use the same GP assignment
	logic as in the other *_gprel*_reloc functions. Handle
	partial_inplace properly.
	(mips_elf64_shift6_reloc): Check for ! BSF_LOCAL instead of zero
	addend. Handle partial_inplace properly.
	(mips16_gprel_reloc): Likewise. Do addend handling directly instead
	of calling _bfd_mips_elf_gprel16_with_gp.
	* elfn32-mips.c (mips_elf_got16_reloc): Check for BSF_LOCAL.
	(mips_elf_gprel32_reloc): Check for ! BSF_LOCAL instead
	of zero addend.
	(mips_elf_shift6_reloc): Handle partial_inplace properly.
	(mips16_gprel_reloc): Likewise. Do addend handling directly instead
	of calling _bfd_mips_elf_gprel16_with_gp.
	* elfxx-mips.c (_bfd_mips_elf_gprel16_with_gp): Handle
	partial_inplace properly. Fix wrong addend handling. Fix overflow
	check.
	(_bfd_mips_elf_sign_extend): Renamed from mips_elf_sign_extend and
	exported.
	(mips_elf_calculate_relocation): Use _bfd_mips_elf_sign_extend.
	(_bfd_mips_elf_relocate_section): Likewise.
	(mips_elf_create_dynamic_relocation): Update sec_info_type access.
	* elfxx-mips.h (_bfd_mips_relax_section): Fix prototype declaration.
	(_bfd_mips_elf_sign_extend): New prototype.

2003-06-11 Federico G. Schwindt <fgsch@lodoss.net>

	* config.bfd (sparc-*-openbsd[0-2].* | sparc-*-openbsd3.[0-1]):
	New target (was sparc-*-openbsd* before).
	(sparc-*-openbsd*): Change to use bfd_elf32_sparc_vec.

	* configure.in (vax-*-openbsd*): Set COREFILE to netbsd-core.lo.
	* configure: Regenerate.

2003-06-11  H.J. Lu <hongjiu.lu@intel.com>

	* po/Make-in (DESTDIR): New.
	(install-data-yes): Support $(DESTDIR).
	(uninstall): Likewise.

2003-06-11  Alan Modra  <amodra@bigpond.net.au>

	* Makefile.am (config.status): Depend on version.h.
	Run "make dep-am".
	* Makefile.in: Regenerate.
	* po/SRC-POTFILES.in: Regenerate.

2003-06-10  Alan Modra  <amodra@bigpond.net.au>
	    Gary Hade <garyhade@us.ibm.com>

	* elf64-ppc.c (ppc64_elf_relocate_section <*_DS>): Special case lq.

2003-06-10  Richard Sandiford  <rsandifo@redhat.com>

	* archures.c (bfd_mach_h8300sxn): New architecture.
	* bfd-in2.h: Regenerate.
	* cpu-h8300.c (h8300_scan): Check for 'sxn'.
	(h8300sxn_info_struct): New.
	(h8300sx_info_struct): Link to it.
	* elf32-h8300.c (elf32_h8_mach): Add h8300sxn case.
	(elf32_h8_final_write_processing): Likewise.

2003-06-08  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Move TARGET_LITTLE_SYM and other macros used by
	elfxx-target.h so that we can use elf_backend_got_header_size.
	(ELF_MACHINE_ALT1, ELF_MACHINE_ALT2): Delete.
	(GLINK_CALL_STUB_SIZE): Modify.  Define new glink call stub and
	associated macros.
	(ppc64_elf_howto_raw <GOT_TPREL16_DS, GOT_TPREL16_LO_DS>): Correct
	dst_mask.
	(enum ppc_stub_type): Add ppc_stub_long_branch_r2off and
	ppc_stub_plt_branch_r2off.
	(struct ppc_stub_hash_entry): Reorganize.
	(struct ppc_link_hash_table): Add no_multi_toc, multi_toc_needed,
	toc_curr, toc_off and emit_stub_syms.
	(ppc64_elf_link_hash_table_create): Init them.
	(ppc_stub_name): Correct string size.
	(ppc64_elf_check_relocs): Set has_gp_reloc on GOT and TOC relocs.
	(ppc64_elf_size_dynamic_sections): Set no_multi_toc if GOT entries
	used.
	(ppc_type_of_stub): Tweak root.type test.
	(build_plt_stub): Remove glink code.  Adjust for insn macro changes.
	(ppc_size_one_stub): Handle ppc_stub_long_branch_r2off and
	ppc_stub_plt_branch_r2off.
	(ppc_build_one_stub): Likewise.  Fix var shadowing.  Correct addis,addi
	range test.  Use toc_off to calculte r2 values.  Handle emit_stub_syms.
	(ppc64_elf_setup_section_lists): Remove htab creator flavour test.
	Initialize elf_gp and toc_curr.
	(ppc64_elf_next_toc_section, ppc64_elf_reinit_toc): New functions.
	(ppc64_elf_next_input_section): Set toc_off.
	(group_sections): Ensure groups have the same TOC.
	(ppc64_elf_size_stubs): Check whether we need a TOC adjusting stub.
	(ppc64_elf_build_stubs): Add emit_stub_syms param, and stash in htab.
	Build new glink stub.
	(ppc64_elf_relocate_section): Handle multiple TOCs.  Fix comments.
	(ppc64_elf_finish_dynamic_sections): Adjust DT_PPC64_GLINK.
	* elf64-ppc.h (ppc64_elf_build_stubs): Update prototype.
	(ppc64_elf_next_toc_section, ppc64_elf_reinit_toc): Declare.
	* section.c (struct sec): Rename flag12 to has_gp_reloc.
	(STD_SECTION): Update.
	* ecoff.c (bfd_debug_section): Update comment.
	* bfd-in2.h: Regenerate.

2003-06-05  Daniel Jacobowitz  <drow@mvista.com>

	* elfcode.h (elf_slurp_reloc_table_from_section): Don't dereference
	NULL function pointers.

2003-06-05  Daniel Jacobowitz  <drow@mvista.com>

	* simple.c (bfd_simple_get_relocated_section_contents): Call
	_bfd_generic_link_add_symbols instead of bfd_link_add_symbols.

2003-06-04  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* coff-tic54x.c: Removed the ticoff0_bad_format_hook() and
	ticoff1_bad_format_hook() functions. Removed the coff0 and coff1
	swaptables.
	* coff-tic4x.c: Ditto
	* coffcode.h: Added extra arguments to CREATE_BIG_COFF_TARGET_VEC
	and CREATE_LITTLE_COFF_TARGET_VEC. Created the macro
	CREATE_BIGHDR_COFF_TARGET_VEC. Created the ticoff0_bad_format_hook(),
	ticoff1_bad_format_hook() functions. Created the coff0 and coff1
	swap tables.
	* coff-tic4x.c: Adopted new CREATE_xxx_COFF_TARGET_VEC macros.
	* coff-a29k.c: Append COFF_SWAP_TABLE argument
	* coff-apollo.c: Ditto
	* coff-arm.c: Ditto
	* coff-h8300.c: Ditto
	* coff-h8500.c: Ditto
	* coff-i960.c: Ditto
	* coff-m68k.c: Ditto
	* coff-m88k.c: Ditto
	* coff-mcore.c: Ditto
	* coff-sh.c: Ditto
	* coff-sparc.c: Ditto
	* coff-tic80.c: Ditto
	* coff-we32k.c: Ditto
	* coff-z8k.c: Ditto
	* coff-w65.c: Ditto

2003-06-04  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* coff-tic4x.c (ticoff0_swap_table, ticoff1_swap_table): Fixed
	initialization bug

2003-06-03  Jakub Jelinek  <jakub@redhat.com>

	* elf.c (_bfd_elf_print_private_bfd_data): Handle PT_GNU_STACK.
	(bfd_section_from_phdr): Likewise.
	(map_sections_to_segments): Create PT_GNU_STACK segment header.
	(get_program_header_size): Count with PT_GNU_STACK.
	* elf-bfd.h (struct elf_obj_tdata): Add stack_flags.
	* elflink.h (bfd_elfNN_size_dynamic_sections): Set stack_flags.

2003-06-03  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.h (elf_link_input_bfd): Call linker error_handler
	for discarded definitions.

2003-06-03  Elias Athanasopoulos  <elathan@phys.uoa.gr>

	* syms.c (decode_section_type): Return 'n' if section flags are
	SEC_HAS_CONTENTS && SEC_READONLY.

2003-06-03  Nick Clifton  <nickc@redhat.com>

	* elf32-v850.c (v850_elf_howto_t): Rename R_V850_32to
	R_V850_ABS32.  Add entry for R_V850_REL32.
	(v850_elf_reloc_map): Likewise.
	(v850_elf_check_relocs): Likewise.
	(v850_elf_perform_relocation): Likewise.
	(v850_elf_final_link_relocate): Likewise.  Include computation
	to make R_V850_REl32 pc-relative.

2003-06-03  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_size_dynamic_sections): Create .interp section
	and DT_DEBUG dynamic tag even for position independent executables.
	* elf64-sh64.c (sh64_elf64_size_dynamic_sections): Likewize.

2003-06-02  Daniel Jacobowitz  <drow@mvista.com>

	* config.bfd: Move obsolete entries out of the range of the
	targmatch sed script.

2003-06-02  Daniel Jacobowitz  <drow@mvista.com>

	* config.bfd (mips*-dec-bsd*, mips*-*-pe*): Mark as obsolete.

2003-05-31  Jakub Jelinek  <jakub@redhat.com>

	* elf32-ppc.c (allocate_dynrelocs): Use single slot for first 8192
	plt entries, not just 8191.

2003-05-30  Daniel Jacobowitz  <drow@mvista.com>

	* elfxx-mips.c (_bfd_mips_elf_discard_info): Correct loop index.
	Reported by Ken Faiczak <kfaiczak@SANDVINE.com>.

2003-05-30  Ulrich Drepper  <drepper@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* elflink.h (elf_link_add_object_symbols): Use !info->executable
	instead of info->shared where appropriate.
	(bfd_elfNN_size_dynamic_sections, elf_link_output_extsym): Likewise.
	* elflink.c (_bfd_elf_create_got_section): Likewise.
	(_bfd_elf_link_create_dynamic_sections): Likewise.
	(_bfd_elf_link_assign_sym_version): Likewise.
	* elf32-i386.c (elf_i386_size_dynamic_sections): Create .interp section
	and DT_DEBUG dynamic tag even for position independent executables.
	* elf32-ppc.c (ppc_elf_size_dynamic_sections): Likewise.
	* elf32-s390.c (elf_s390_size_dynamic_sections: Likewise.
	* elf64-ppc.c (ppc64_elf_size_dynamic_sections: Likewise.
	* elf64-s390.c (elf_s390_size_dynamic_sections: Likewise.
	* elf64-x86-64.c (elf64_x86_64_size_dynamic_sections: Likewise.
	* elfxx-ia64.c (elfNN_ia64_size_dynamic_sections: Likewise.
	* elf32-sparc.c (elf32_sparc_size_dynamic_sections: Likewise.
	* elf64-alpha.c (elf64_alpha_size_dynamic_sections: Likewise.
	* elf64-sparc.c (sparc64_elf_size_dynamic_sections: Likewise.

2003-05-30  Kris Warkentin <kewarken@qnx.com>

	* elf.c (elfcore_grok_nto_status): Only set lwpid for the active or
	signalled thread.
	(elfcore_grok_nto_gregs): Only make .reg section for the active thread.

2003-05-29  Nick Clifton  <nickc@redhat.com>

	* pef.c: Include "safe-ctype.h" instead of <ctype.h>.
	Tidy up formatting.
	* Makefile.am: Add dependency on safe-ctype.h.
	* Makefile.in: Regenerate.

2003-05-29  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elfxx-mips.c: Don't force symbols local unconditionally.

2003-05-28  Alan Modra  <amodra@bigpond.net.au>

	* elf32-hppa.c (elf32_hppa_relocate_section): Delete bogus
	undefined_symbol call.

2003-05-27  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c (mips_elf_hash_sort_data): Fix formattting.
	(mips_elf_link_hash_table): Likewise.

2003-05-22  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elf64-mips.c (elf_mips_gnu_rel16_s2): Add internally used
	R_MIPS_GNU_REL16_S2 support.
	(bfd_elf64_bfd_reloc_type_lookup): Use it.
	(mips_elf64_rtype_to_howto): Use it.
	* elfn32-mips.c (elf_mips_gnu_rel16_s2): Add internally used
	R_MIPS_GNU_REL16_S2 support.
	(bfd_elf32_bfd_reloc_type_lookup): Use it.
	(mips_elf_n32_rtype_to_howto): Use it.

2003-05-21  Stuart F. Downing  <sdowning@fame.com>

	* som.h: Define PA_2_0 before including a.out.h

2003-05-07  Eric Christopher  <echristo@redhat.com>
	    Alexandre Oliva   <aoliva@redhat.com>

	* elfxx-mips.c (_bfd_mips_elf_merge_private_bfd_data): Adjust
	pic tests, change to warning.
	(_bfd_mips_elf_final_link): Remove EF_MIPS_CPIC flag setting.

2003-05-21  Marcus Comstedt  <marcus@mc.pp.se>

	* config.bfd: Check for a target triplet of shl-...-netbsdelf as
	well as shle-...-netbsdelf.  Remove duplicate entry.

2003-05-21  Nick Clifton  <nickc@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto_table): Fix dst_mask
	for X_STORMY16_REL_12 reloc.

	* elf.c (bfd_elf_get_needed_list): Use is_elf_hash_table to check
	the type of the hash table in the bfd_link_info structure.
	(bfd_elf_get_runpath_list): Likewise.

2003-05-19  Roland McGrath  <roland@redhat.com>

	* elf.c (bfd_elf_bfd_from_remote_memory): New function.
	* bfd-in.h: Declare it.
	* bfd-in2.h: Regenerated.
	* elfcode.h (NAME(_bfd_elf,bfd_from_remote_memory)): New function.
	* elf-bfd.h (struct elf_backend_data): New function pointer member
	elf_backend_bfd_from_remote_memory.
	(_bfd_elf32_bfd_from_remote_memory, _bfd_elf64_bfd_from_remote_memory):
	Declare them.
	* elfxx-target.h (elf_backend_bfd_from_remote_memory): New macro.
	(elfNN_bed): Add that to the initializer.

2003-05-15  Roland McGrath  <roland@redhat.com>

	* elf.c (elfcore_grok_note): Grok NT_AUXV note, make ".auxv" section.

2003-05-20  Jakub Jelinek  <jakub@redhat.com>

	* elflink.h (elf_link_output_extsym): Only issue error about !=
	STV_DEFAULT symbols if they are bfd_link_hash_undefined.

2003-05-20  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.c (_bfd_elf_merge_symbol): Check ELF_LINK_DYNAMIC_DEF
	when removing the old definition for symbols with non-default
	visibility.

2003-05-18  Jason Eckhardt  <jle@rice.edu>

	* elf32-i860.c (elf32_i860_relocate_highadj): Simplify calculation.

2003-05-17  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (elf_m68k_check_relocs): Cache reloc section in
	elf_section_data during processing of pc-relative and absolute
	relocations.
	(elf_m68k_relocate_section): Use the cached reloc section instead
	of computing it again.  Fix handling of visibility.  Don't modify
	addend when copying over a relocation into the output.

2003-05-17  Alan Modra  <amodra@bigpond.net.au>

	* elf32-i386.c (elf_i386_adjust_dynamic_symbol): Use SYMBOL_CALLS_LOCAL
	to trim plt entries.  Move undefweak non-default visibility test..
	(allocate_dynrelocs): ..from here.
	* elf32-ppc.c (ppc_elf_adjust_dynamic_symbol): Don't test
	dynamic_sections_created here.  Update comment.  Move undefweak
	non-default visibility test..
	(allocate_dynrelocs): ..from here.  Fix comment.
	* elf64-ppc.c (ppc64_elf_adjust_dynamic_symbol): Use SYMBOL_CALLS_LOCAL
	to trim plt entries.  Move undefweak non-default visibility test..
	(allocate_dynrelocs): ..from here.  Fix comment.
	* elflink.h (elf_link_output_extsym): Compare ELF_ST_VISIBILITY with
	STV_DEFAULT rather than comparing with zero.
	* elflink.c (_bfd_elf_merge_symbol): Likewise.
	(_bfd_elf_fix_symbol_flags): Likewise.  Format comment.

2003-05-17  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* bfd.c (_bfd_get_gp_value): Prevent illegal access for abfd null
	pointers.
	(_bfd_set_gp_value): Likewise.

2003-05-16  Michael Snyder  <msnyder@redhat.com>
	From Bernd Schmidt  <bernds@redhat.com>
	* archures.c (bfd_mach_h8300sx): New.
	* bfd-in2.h: Regenerate.
	* cpu-h8300.c (h8300_scan)): Add support for h8300sx.
	(h8300sx_info_struct): New.
	(h8300s_info_struct): Link to it.
	* elf32-h8300.c (elf32_h8_mach): Add support for h8300sx.
	(elf32_h8_final_write_processing): Likewise.
	(elf32_h8_relax_section): Likewise.

2003-05-16  Kelley Cook  <kelleycook@wideopenwest.com>

	* config.bfd: Accept i[3-7]86 variants.
	* configure.host: Likewise.
	* configure.in: Likewise.
	* configure: Regenerate.

2003-05-15  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.c (_bfd_elf_fix_symbol_flags): Also hide protected
	symbol.

2003-05-15  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.h (elf_link_check_versioned_symbol): Also allow
	the base version.

2003-05-15  Alan Modra  <amodra@bigpond.net.au>
	    H.J. Lu <hongjiu.lu@intel.com>

	* elf32-i386.c (allocate_dynrelocs): Use SYMBOL_CALLS_LOCAL.
	(elf_i386_relocate_section): Likewise.
	* elf32-ppc.c (allocate_dynrelocs): Likewise.
	(ppc_elf_relocate_section): Likewise.
	* elf64-ppc.c (allocate_dynrelocs): Likewise.
	(ppc64_elf_relocate_section): Likewise.

2003-05-15  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elf32-mips.c (gprel32_with_gp): Remove useless N64 ABI case.

2003-05-13  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.c (_bfd_m68hc11_elf_merge_private_bfd_data): Check for
	processor capability, allow merge of HC12 and HCS12 in some cases.
	(m68hc11_elf_hash_table_create): Use bfd_malloc instead of bfd_zalloc.
	* cpu-m68hc12.c (bfd_m68hc12s_arch): New struct.
	(bfd_m68hc12_arch): Link it.
	(scan_mach): New function.

2003-05-13  Andrew Haley  <aph@redhat.com>

	* elf.c (bfd_elf_hash): Mask lower 32 bits of hash.

2003-05-13  Alan Modra  <amodra@bigpond.net.au>
	    H.J. Lu  <hongjiu.lu@intel.com>

	* elf-bfd.h (SYMBOL_REFERENCES_LOCAL, SYMBOL_CALLS_LOCAL): Move from
	elf32-ppc.c.  Add ELF_LINK_FORCED_LOCAL check.
	* elf32-ppc.c: (SYMBOL_REFERENCES_LOCAL, SYMBOL_CALLS_LOCAL): Delete.
	(allocate_dynrelocs): Use SYMBOL_REFERENCES_LOCAL for dynreloc check.
	(ppc_elf_relocate_section): Likewise.
	* elf64-ppc.c (allocate_dynrelocs): Likewise.
	(ppc64_elf_relocate_section): Likewise.  Use for .got relocs too.
	(ppc64_elf_adjust_dynamic_symbol): Don't assume symbols with .plt
	relocs need no other types.
	* elf32-i386.c (allocate_dynrelocs): Use SYMBOL_REFERENCES_LOCAL for
	dynreloc check.
	(elf_i386_relocate_section): Likewise.  Use for .got relocs too.
	(elf_i386_finish_dynamic_symbol): Use SYMBOL_REFERENCES_LOCAL for
	.got relocs.

2003-05-13  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_adjust_dynamic_symbol): For weak symbols,
	copy ELF_LINK_NON_GOT_REF from weakdef.
	(allocate_dynrelocs): For undef weak syms with non-default
	visibility, a) don't allocate plt entries, b) don't allocate
	.got relocs, c) discard dyn rel space
	(sh_elf_relocate_section): d) don't generate .got relocs, e)
	don't generate dynamic relocs.
	(sh_elf_copy_indirect_symbol): Don't copy ELF_LINK_NON_GOT_REF
	for weakdefs when symbol already adjusted.

2003-05-12  Nick Clifton  <nickc@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto_table): use 'bitfield'
	overflow detection for R_XSTORMY16_16 reloc.

2003-05-12  Paul Clarke  <paulc@senet.com.au>

	* elf32-h8300.c: Fix typo in name of R_H8_DIR8 reloc.

2003-05-11  Jason Eckhardt  <jle@rice.edu>

	* elf32-i860.c (elf32_i860_relocate_highadj): Properly
	adjust upper bits.
	(elf32_i860_relocate_splitn): Obtain upper 5 bits from the
	proper place.
	(elf32_i860_relocate_pc16): Obtain upper 5 bits from the
	proper place.

2003-05-11  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (elf_m68k_relocate_section): Replace ugly
	complicated tests for unresolvable relocs with a simple direct
	scheme using "unresolved_reloc" var.  Report some detail on
	bfd_reloc_outofrange and similar errors.

2003-05-09  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (allocate_dynrelocs, elf_s390_relocate_section):
	Fix WILL_CALL_FINISH_DYNAMIC_SYMBOL call.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead of INFO.
	* elf64-s390.c: Likewise.

2003-05-09  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (ELIMINATE_COPY_RELOCS): Define as one.
	(elf_s390_adjust_dynamic_symbol): For weak symbols, copy
	ELF_LINK_NON_GOT_REF from weakdef.
	(elf_s390_copy_indirect_symbol): Test whether the weakdef sym has
	already been adjusted before treating it specially.
	* el64-s390.c: Likwise.

2003-05-09  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* elf32-s390.c (allocate_dynrelocs): For undef weak syms with
	non-default visibility, a) don't make them dynamic, b) discard
	space for dynamic relocs.
	(elf_s390_relocate_section): Initialize the GOT entries and skip
	R_390_{8,16,32}/R_390_PC{16,16DBL,32DBL,32} for weak undefined
	symbols with non-default visibility.
	* elf64-s390.c: Likewise.

2003-05-09  Alan Modra  <amodra@bigpond.net.au>

	* cpu-arm.c (arm_check_note): Warning fix.
	* elf32-iq2000.c (iq2000_elf_check_relocs): Warning fixes.  Arrange
	to keep relocs if edited.
	(iq2000_elf_print_private_bfd_data): Return TRUE.
	* elfxx-ia64.c (elfNN_ia64_relax_section): Use ELFNN_R_SYM, not
	ELF64_R_SYM.
	(elfNN_ia64_relax_ldxmov): Warning fix.
	* xtensa-isa.c (xtensa_add_isa): Warning fix.
	* xtensa-modules.c (get_num_opcodes): Warning fix.

2003-05-09  Andrey Petrov <petrov@netbsd.org>

	* elf.c (elf_fake_sections): Use correct cast for sh_name.

2003-05-09  Alan Modra  <amodra@bigpond.net.au>

	* elflink.c (_bfd_elf_link_create_dynamic_sections): Move from
	elflink.h.  Replace LOG_FILE_ALIGN with bed->s->log_file_align.
	(_bfd_elf_create_dynamic_sections): Use bed->s->log_file_align.
	(bfd_elf_record_link_assignment): Move from elflink.h.
	(_bfd_elf_merge_symbol): Likewise.
	(_bfd_elf_add_default_symbol): Likewise.
	(_bfd_elf_export_symbol): Likewise.
	(_bfd_elf_link_find_version_dependencies): Likewise.
	(_bfd_elf_link_assign_sym_version): Likewise.
	(_bfd_elf_link_read_relocs): Likewise.
	(_bfd_elf_link_size_reloc_section): Likewise.
	(_bfd_elf_fix_symbol_flags): Likewise.
	(_bfd_elf_adjust_dynamic_symbol): Likewise.
	(_bfd_elf_link_sec_merge_syms): Likewise.
	(elf_link_read_relocs_from_section): Likewise.  Use bed->s->sizeof_rel
	and bed->s->sizeof_rela.
	(_bfd_elf_link_output_relocs): Likewise.
	* elf-bfd.h (struct elf_size_info): Rename file_align to
	log_file_align.
	(struct elf_info_failed): Move from elflink.h.
	(struct elf_assign_sym_version_info): Likewise.
	(struct elf_find_verdep_info): Likewise.
	(_bfd_elf_create_dynamic_sections): Delete duplicate declaration.
	(_bfd_elf_merge_symbol, _bfd_elf_add_default_symbol,
	_bfd_elf_export_symbol, _bfd_elf_link_find_version_dependencies,
	_bfd_elf_link_assign_sym_version,
	_bfd_elf_link_create_dynamic_sections, _bfd_elf_link_read_relocs,
	_bfd_elf_link_size_reloc_section, _bfd_elf_link_output_relocs,
	_bfd_elf_fix_symbol_flags, _bfd_elf_adjust_dynamic_symbol,
	_bfd_elf_link_sec_merge_syms): Declare.
	(bfd_elf32_link_create_dynamic_sections): Don't declare.
	(_bfd_elf32_link_read_relocs): Likewise.
	(bfd_elf64_link_create_dynamic_sections): Likewise.
	(_bfd_elf64_link_read_relocs): Likewise.
	* elflink.h: Move lots o' stuff elsewhere.
	* bfd-in.h (bfd_elf32_record_link_assignment): Don't declare.
	(bfd_elf64_record_link_assignment): Likewise.
	(bfd_elf_record_link_assignment): Declare.
	* bfd-in2.h: Regenerate.
	* elfcode.h (elf_link_create_dynamic_sections): Don't declare.
	(NAME(_bfd_elf,size_info)): Adjust for log_file_align.
	* elf.c (_bfd_elf_init_reloc_shdr): Adjust for bed->s->log_file_align.
	(assign_file_positions_for_segments): Likewise.
	(assign_file_positions_except_relocs): Likewise.
	(swap_out_syms, elfcore_write_note): Likewise.
	* elf-m10200.c: Adjust for changed function names.
	* elf-m10300.c: Likewise.
	* elf32-arm.h: Likewise.
	* elf32-h8300.c: Likewise.
	* elf32-hppa.c: Likewise.
	* elf32-ip2k.c: Likewise.
	* elf32-m32r.c: Likewise.
	* elf32-m68hc11.c: Likewise.
	* elf32-m68hc1x.c: Likewise.
	* elf32-m68k.c: Likewise.
	* elf32-mips.c: Likewise.
	* elf32-ppc.c: Likewise.
	* elf32-sh.c: Likewise.
	* elf32-v850.c: Likewise.
	* elf32-xtensa.c: Likewise.
	* elf64-alpha.c: Likewise.
	* elf64-hppa.c: Likewise.
	* elf64-mmix.c: Likewise.
	* elf64-ppc.c: Likewise.
	* elf64-sh64.c: Likewise.
	* elfxx-ia64.c: Likewise.
	* elfxx-mips.c: Likewise.
	(MIPS_ELF_LOG_FILE_ALIGN): Use log_file_align.
	* elf64-alpha.c (alpha_elf_size_info): Adjust for log_file_align.
	* elf64-hppa.c (hppa64_elf_size_info): Likewise.
	* elf64-mips.c (mips_elf64_size_info): Likewise.
	* elf64-s390.c (s390_elf64_size_info): Likewise.
	* elf64-sparc.c (sparc64_elf_size_info): Likewise.

2003-05-08  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.h (elf_add_default_symbol): After skipping the
	unversioned symbol, go to non-default one.

2003-05-07  H.J. Lu <hongjiu.lu@intel.com>

	* elfxx-ia64.c (_bfd_elf_link_hash_hide_symbol): Also clear the
	want_plt field.
	(elfNN_ia64_relocate_section): Don't do dynamic symbol lookup
	for symbols with non-default visibility.

2003-05-07  H.J. Lu <hongjiu.lu@intel.com>

	* elflink.h (elf_link_check_versioned_symbol): Also handle the
	case that a DSO references a hidden symbol which may be
	satisfied by a versioned symbol in another DSO.
	(elf_link_output_extsym): Check versioned definition for hidden
	symbol referenced by a DSO.

2003-05-07  Nick Clifton  <nickc@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto_table): Reset
	R_XSTORMY16_16 reloc to ignore overflows.

2003-05-06  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (_bfd_mips_elf_merge_private_bfd_data): Improve
	error message for mixing different-endian files.  Check for ABI
	compatibility of input files with the selected emulation.

2003-05-05  Alan Modra  <amodra@bigpond.net.au>

	* elf32-i386.c (allocate_dynrelocs): For undef weak syms with
	non-default visibility, a) don't make them dynamic, b) discard
	space for dynamic relocs.
	* elf64-x86-64.c (allocate_dynrelocs): Likewise.

	* elf32-ppc.c (allocate_dynrelocs): For undef weak syms with
	non-default visibility, a) don't allocate plt entries, b) don't
	allocate .got relocs, c) discard dyn rel space,
	(ppc_elf_relocate_section): d) don't generate .got relocs, e)
	don't generate dynamic relocs.
	* elf64-ppc.c (allocate_dynrelocs): As above.
	(ppc64_elf_relocate_section): As above.

2003-05-05  Andreas Jaeger  <aj@suse.de>

	* elf64-x86-64.c (allocate_dynrelocs): Don't allocate dynamic
	relocation entries for weak undefined symbols with non-default
	visibility.
	(elf64_x86_64_relocate_section): Initialize the GOT entries and
	skip R_386_32/R_386_PC32 for weak undefined symbols with
	non-default visibility.

2003-05-04  H.J. Lu <hjl@gnu.org>

	* elf32-i386.c (allocate_dynrelocs): Don't allocate dynamic
	relocation entries for weak undefined symbols with non-default
	visibility.
	(elf_i386_relocate_section): Initialize the GOT entries and
	skip R_386_32/R_386_PC32 for weak undefined symbols with
	non-default visibility.

	* elfxx-ia64.c (allocate_fptr): Don't allocate function
	descriptors for weak undefined symbols with non-default
	visibility.
	(allocate_dynrel_entries): Don't allocate relocation entries
	for symbols resolved to 0.
	(set_got_entry): Don't install dynamic relocation for weak
	undefined symbols with non-default visibility.
	(set_pltoff_entry): Likewise.

	* elflink.h (elf_fix_symbol_flags): Hide weak undefined symbols
	with non-default visibility.
	(elf_link_output_extsym): Don't make weak undefined symbols
	with non-default visibility dynamic.

2003-05-04  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_merge_symbol): Correctly handle weak definition.

2003-05-04  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_merge_symbol): Don't record a hidden/internal
	symbol dynamic. Check indirection when removing the old
	definition for symbols with non-default visibility.
	(elf_add_default_symbol): Skip when told by elf_merge_symbol.

2003-05-02  Nick Clifton  <nickc@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto_table): Make the
	R_XSTORMY16_8 and R_XSTORMY16_16 relocs detect and complain about
	unsigned overflow.

2003-05-02  Andreas Jaeger  <aj@suse.de>

	* elf64-x86-64.c (elf_x86_64_copy_indirect_symbol): Don't copy
	ELF_LINK_NON_GOT_REF for weakdefs when symbol already adjusted.
	(ELIMINATE_COPY_RELOCS): Define as one.  Use throughout.
	(elf_x86_64_adjust_dynamic_symbol): For weak symbols, copy
	ELF_LINK_NON_GOT_REF from weakdef.

2003-05-02  Charles Lepple <clepple@ghz.cc>
	    Nick Clifton <nickc@redhat.com>

	* acinclude.m4: Fix name of --enable-install-libbfd switch.
	* aclocal.m4: Regenerate.
	* configure: Regenerate.
	* Makefile.in: Regenerate.

2003-05-01  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_copy_indirect_symbol): Test whether the
	weakdef sym has already been adjusted before treating it specially.
	* elf32-i386.c (elf_i386_copy_indirect_symbol): Don't copy
	ELF_LINK_NON_GOT_REF for weakdefs when symbol already adjusted.
	* elf64-ppc.c (ppc64_elf_copy_indirect_symbol): Likewise.
	(ppc64_elf_check_relocs): Set ELF_LINK_NON_GOT_REF.

2003-04-28  H.J. Lu <hjl@gnu.org>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Relax ldxmov during
	the relax finalize pass.

	* section.c (struct sec): Add need_finalize_relax and remove
	flag11.
	(STD_SECTION): Update struct sec initializer.
	* bfd-in2.h: Regenerated.

2003-04-28  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_merge_symbol): Call elf_backend_copy_indirect_symbol
	to copy any information related to dynamic linking when we flip
	the indirection.

2003-04-27  H.J. Lu <hjl@gnu.org>

	* elf-bfd.h (ELF_LINK_DYNAMIC_DEF): New.
	(ELF_LINK_DYNAMIC_WEAK): New.

	* elflink.h (elf_merge_symbol): Add one argument to indicate if
	a symbol should be skipped. Ignore definitions in dynamic
	objects for symbols with non-default visibility.
	(elf_add_default_symbol): Adjusted.
	(elf_link_add_object_symbols): Check if a symbol should be
	skipped. Don't merge the visibility field with the one from
	a dynamic object.
	(elf_link_check_versioned_symbol): Use undef_bfd.
	(elf_link_output_extsym): Warn if a forced local symbol is
	referenced from dynamic objects. Make non-weak undefined symbol
	with non-default visibility a fatal error.

2003-04-27  Daniel Jacobowitz  <drow@mvista.com>

	* configure.in: Bump version on HEAD to 2.14.90.
	* configure: Regenerated.

2003-04-26  Stephane Carrez  <stcarrez@nerim.fr>

	PR savannah/3331:
	* elf32-m68hc11.c (m68hc11_elf_relax_section): Clear prev_insn_group
	when we couldn't relax something.

2003-04-25  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_merge_symbol): When we find a regular definition
	for an indirect symbol, flip the indirection so that the old
	direct symbol now points to the new definition.

2003-04-24  Roland McGrath  <roland@redhat.com>

	* elf.c (bfd_section_from_phdr): Map PT_GNU_EH_FRAME to "eh_frame_hdr".

2003-04-24  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c: Formatting and comment fixes.
	(ELIMINATE_COPY_RELOCS): Move before ppc_elf_copy_indirect_symbol.
	(ppc_elf_copy_indirect_symbol): Copy flags here for weakdefs.

2003-04-24 Dhananjay Deshpande <dhananjayd@kpitcummins.com>

	* archures.c (bfd_mach_h8300hn, bfd_mach_h8300sn): Added.
	* bfd-in2.h: Rebuilt.
	* coff-h8300.c (BADMAG): Add check for H8300HNBADMAG & H8300SNBADMAG.
	* coffcode.h (coff_set_arch_mach_hook): Add case for H8300HNMAGIC
	& H8300SNMAGIC.
	(coff_set_flags): Add case for bfd_mach_h8300hn & bfd_mach_h8300sn.
	* cpu-h8300.c (h8300_scan): Handle h8300hn, h8300sn.
	(h8300sn_info_struct, h8300hn_info_struct): New.
	* elf32-h8300.c (elf32_h8_mach): Handle case for h8300hn & h8300sn
	(elf32_h8_final_write_processing): Likewise.

2003-04-23  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (tpoff): New.
	(struct elf_sh_dyn_relocs): Remove tls_tpoff32.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead of INFO.
	(allocate_dynrelocs): Don't make unnecessary dynamic TLS
	relocations.  Adjust WILL_CALL_FINISH_DYNAMIC_SYMBOL uses.
	(sh_elf_relocate_section): Likewise. Remove unnecessary tests.
	(dtpoff_base): Fix wrong indentation.
	(sh_elf_check_relocs): Don't set DF_STATIC_TLS flag with non-TLS
	relocations.  Don't set tls_tpoff32 flag.  Don't make unnecessary
	R_SH_TLS_TPOFF32 relocations.

2003-04-23  J"orn Rennecke <joern.rennecke@superh.com>

	* archures.c (enum bfd_architecture): Amend comment to refer to SuperH.
	* cpu-sh.c: Likewise.
	* elf32-sh.c: Likewise.
	* reloc.c (bfd_reloc_code_real): Likewise.
	* elf32-sh64-com.c: Change comment to refer to SuperH.
	* elf32-sh64.c: Likewise.
	* elf64-sh64.c: Likewise.
	* bfd-in2.h (enum bfd_architecture): Regenerate.

2003-04-23  Alan Modra  <amodra@bigpond.net.au>

	From Julien LEMOINE <speedblue@debian.org>
	* elf32-i386.c (elf_i386_info_to_howto): Delete.
	(elf_info_to_howto): Define as elf_i386_info_to_howto_rel.

2003-04-22  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* archures.c: Replace references to Mitsubishi M32R with references
	to Renesas M32R.
	* relocs.c: Likewise.
	* bfd-in2.h: Regenerate.

2003-04-21  Richard Henderson  <rth@redhat.com>

	* elf64-alpha.c (alpha_elf_dynamic_symbol_p): Return false for an
	executable when a symbol is defined both regular and dynamic.

2003-04-21  Stephane Carrez  <stcarrez@nerim.fr>

	* Makefile.am (BFD32_BACKENDS): Add elf32-m68hc1x.lo.
	(elf32-m68hc1x.lo): Update dependencies
	* configure.in: Add elf32-m68hc1x.lo.
	* configure: Rebuild.
	* Makefile.in: Rebuild.

2003-04-21  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc1x.c: New file (from elf32-m68hc11.c and elf32-m68hc12.c)
	(m68hc11_elf_hash_table_create): New function.
	(elf32_m68hc11_link_hash_table_free): New function.
	(stub_hash_newfunc): New function.
	(m68hc11_add_stub): New function.
	(elf32_m68hc11_add_symbol_hook): New function.
	(elf32_m68hc11_setup_section_lists): New function.
	(elf32_m68hc11_next_input_section): New function.
	(elf32_m68hc11_size_stubs): New function.
	(elf32_m68hc11_build_stubs): New function.
	(m68hc11_get_relocation_value): New function.
	(elf32_m68hc11_relocate_section): Call the above to redirect
	some relocations to the trampoline code.
	(m68hc11_elf_export_one_stub): New function.
	(m68hc11_elf_set_symbol): New function.
	(elf32_m68hc11_build_stubs): Call it via bfd_hash_traverse.
	(m68hc11_elf_get_bank_parameters): Get parameters only when the info
	is not yet initialized.

	* elf32-m68hc1x.h: New file (from elf32-m68hc11.c and elf32-m68hc12.c)
	(elf32_m68hc11_stub_hash_entry): New struct.
	(m68hc11_page_info): Add trampoline handler address.
	(m68hc11_elf_link_hash_table): Add stubs generation members.
	(elf32_m68hc11_add_symbol_hook): Declare.
	(elf32_m68hc11_setup_section_lists): Declare.
	(elf32_m68hc11_size_stubs): Declare.
	(elf32_m68hc11_build_stubs): Declare.

	* elf32-m68hc11.c (m68hc11_elf_ignore_reloc): Move to elf32-m68hc1x.c.
	(elf32_m68hc11_gc_mark_hook, elf32_m68hc11_gc_sweep_hook): Likewise.
	(elf32_m68hc11_check_relocs, elf32_m68hc11_relocate_section): Ditto.
	(_bfd_m68hc11_elf_set_private_flags): Ditto.
	(_bfd_m68hc11_elf_merge_private_bfd_data): Ditto.
	(_bfd_m68hc11_elf_print_private_bfd_data): Ditto.
	(bfd_elf32_bfd_link_hash_table_create): Define.
	(elf_backend_add_symbol_hook): Define.
	(m68hc11_elf_bfd_link_hash_table_create): New function.
	(m68hc11_elf_build_one_stub): New function.
	(m68hc11_elf_size_one_stub): New function.
	(m68hc11_elf_bfd_link_hash_table_create): Install the above.
	(bfd_elf32_bfd_link_hash_table_create): Define.

	* elf32-m68hc12.c (m68hc11_elf_ignore_reloc): Remove.
	(m68hc12_addr_is_banked): Remove, use m68hc11_addr_is_banked.
	(m68hc12_phys_addr): Ditto.
	(m68hc12_phys_page): Ditto.
	(m68hc12_elf_special_reloc): Move to elf32-m68hc1x.c.
	(elf32_m68hc11_gc_mark_hook): Likewise.
	(elf32_m68hc11_gc_sweep_hook): Likewise.
	(elf32_m68hc11_check_relocs): Likewise.
	(elf32_m68hc11_relocate_section): Likewise.
	(_bfd_m68hc12_elf_set_private_flags): Likewise.
	(_bfd_m68hc12_elf_merge_private_bfd_data): Likewise.
	(_bfd_m68hc12_elf_print_private_bfd_data): Likewise.
	(m68hc12_elf_build_one_stub): New function.
	(m68hc12_elf_size_one_stub): New function.
	(m68hc12_elf_bfd_link_hash_table_create): New function, use the above.
	(elf_backend_add_symbol_hook): Define.
	(elf_m68hc11_howto_table): Use TRUE for pcrel relocs; fix masks.

2003-04-18  Nick Clifton  <nickc@redhat.com>

	* format.c (bfd_check_format_matches): Only check associated
	vector if the matching_vector has been created.

2003-04-15  Alexandre Oliva  <aoliva@redhat.com>

	* dwarf2.c (_bfd_dwarf2_find_nearest_line): Fix typo in
	2003-04-09's change.

2003-04-15  Brian Ford  <ford@vss.fsi.com>

	* peicode.h (coff_swap_scnhdr_in): If a section holds
	uninitialized data and is from an object file or from an
	executable image that has not initialized the s_size field, or if
	the physical size is padded, use the virtual size (stored in
	s_paddr) instead.

2003-04-15  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_link_add_object_symbols): Properly report
	filename for alignment reduction.

2003-04-15  Rohit Kumar Srivastava <rohits@kpitcummins.com>

	* archures.c: Replace occurrances of 'Hitachi' with 'Renesas'.
	* reloc.c: Likewise.
	* coff-h8300.c: Likewise.
	* coff-h8500.c: Likewise.
	* coff-sh.c: Likewise.
	* cpu-h8300.c: Likewise.
	* cpu-sh.c: Likewise.
	* elf32-h8300.c: Likewise.
	* elf32-sh.c: Likewise.
	* elf32-sh64-com.c: Likewise.
	* elf32-sh64.c: Likewise.
	* elf64-sh64.c: Likewise.
	* bfd-in2.h: Regenerate.

2003-04-14  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_link_add_object_symbols): Maintain maximum
	alignment for common symbols. Warn reducing alignment for
	common symbols. Report old filename when symbol size changes.

2003-04-12  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_calculate_relocation): Adjust two other
	occurrences of the same test changed in the previous patch.
	Optimize.

2003-04-11  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_get_global_gotsym_index): New.
	(mips_elf_calculate_relocation): Decay GOT_PAGE/GOT_OFST to
	GOT_DISP/addend only if the symbol got a global GOT entry.

2003-04-10  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_calculate_relocation): Decay
	GOT_PAGE/GOT_OFST referencing overridable symbol to
	GOT_DISP/addend.
	(_bfd_mips_elf_check_relocs): Handle GOT_PAGE referencing
	global symbol as GOT_DISP.

2003-04-10  Bob Wilson  <bob.wilson@acm.org>

	* elf32-xtensa.c (elf_xtensa_relocate_section): Don't continue to the
	next relocation on an undefined symbol.

2003-04-09  Richard Henderson  <rth@redhat.com>

	* elf64-alpha.c (elf64_alpha_relocate_section) <R_ALPHA_GPREL32>:
	Ignore relocations against r_symndx == 0.

2003-04-09  H.J. Lu <hjl@gnu.org>

	* elf64-alpha.c (elf64_alpha_relocate_section): Don't return
	FALSE for undefined symbols.
	* elfxx-ia64.c (elfNN_ia64_relocate_section): Likewise.

2003-04-09  Alexandre Oliva  <aoliva@redhat.com>

	* dwarf2.c (_bfd_dwarf2_find_nearest_line): Try DWARF3-standard
	and IRIX-specific shift-to-64-bit 4-byte lengths before following
	addr_size.

2003-04-08  Alexandre Oliva  <aoliva@redhat.com>

	* elf32-mips.c (bfd_elf32_bfd_reloc_type_lookup): Detect (ctor)
	pointer size from ABI, not arch_bits_per_address.

2003-04-07  Kevin Buettner  <kevinb@redhat.com>

	* elfn32-mips.c (elf32_mips_grok_prstatus): Adjust core file related
	constants for n32 ABI.

2003-04-06  Andrew Cagney  <cagney@redhat.com>

	* simple.c (bfd_simple_get_relocated_section_contents): Disable
	free that leads to GDB vs BFD memory corruption.

2003-04-04  Stephane Carrez  <stcarrez@nerim.fr>

	* elf32-m68hc11.c (m68hc11_elf_relax_delete_bytes): Also adjust
	symbols that mark the end of the section.
	(m68hc11_elf_relax_section): Use R_M68HC11_PCREL_8 relocs when
	converting to a relative branch so that the offset is computed after
	the relaxation; also relocate a jsr into a bsr if possible but don't
	relax them if they are to a far symbol as we need to call the
	trampoline code.
	(elf_m68hc11_howto_table): Set pcrel_offset to true.

2003-04-04  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* archures.c: Namespace cleanup. Rename bfd_mach_c3x to
	bfd_mach_tic3x and bfd_mach_c4x to bfd_mach_tic4x
	* bfd-in2.h: Regenerate
	* coff-tic4x.c: Namespace cleanup. Replace s/c4x/tic4x/
	* cpu-tic4x.c: Ditto

2003-04-03  Nick Clifton  <nickc@redhat.com>

	* peXXigen.c (_bfd_XXi_swap_scnhdr_out): Compute ps and ss
	differently for object files and executables.
	* peicode.h (coff_swap_scnhdr_in): Only set the s_size field
	for object files or for executables who have not already
	initialised the field.
	* libpei.h (bfd_pe_executable_p): New macro.  Return true if
	the PE format bfd is an executable.

2003-04-03  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_check_relocs): Don't use SYMBOL_REFERENCES_LOCAL
	here as it's too early to reliably determine locality.
	(ppc_elf_gc_sweep_hook): Likewise.
	(SYMBOL_REFERENCES_LOCAL): Expand comment.

2003-04-02  Bob Wilson  <bob.wilson@acm.org>

	* xtensa-modules.c: Remove comment indicating that this is a
	generated file.

2003-04-02  Alan Modra  <amodra@bigpond.net.au>

	* elfxx-mips.c (_bfd_mips_elf_hide_symbol): Test for NULL dynobj.

2003-04-01  Bob Wilson  <bob.wilson@acm.org>

	* Makefile.am (ALL_MACHINES): Add cpu-xtensa.lo.
	(ALL_MACHINES_CFILES): Add cpu-xtensa.c.
	(BFD32_BACKENDS): Add elf32-xtensa.lo, xtensa-isa.lo, and
	xtensa-modules.lo.
	(BFD32_BACKENDS_CFILES): Add elf32-xtensa.c, xtensa-isa.c, and
	xtensa-modules.c.
	(cpu-xtensa.lo): New target.
	(elf32-xtensa.lo): Likewise.
	(xtensa-isa.lo): Likewise.
	(xtensa-modules.lo): Likewise.
	* Makefile.in: Regenerate.
	* archures.c (bfd_architecture): Add bfd_{arch,mach}_xtensa.
	(bfd_archures_list): Add bfd_xtensa_arch.
	* config.bfd: Handle xtensa-*-*.
	* configure.in: Handle bfd_elf32_xtensa_{le,be}_vec.
	* configure: Regenerate.
	* reloc.c: Add BFD_RELOC_XTENSA_{RTLD,GLOB_DAT,JMP_SLOT,RELATIVE,
	PLT,OP0,OP1,OP2,ASM_EXPAND,ASM_SIMPLIFY}.
	* targets.c (bfd_elf32_xtensa_be_vec): Declare.
	(bfd_elf32_xtensa_le_vec): Likewise.
	(bfd_target_vector): Add bfd_elf32_xtensa_{be,le}_vec.
	* cpu-xtensa.c: New file.
	* elf32-xtensa.c: Likewise.
	* xtensa-isa.c: Likewise.
	* xtensa-modules.c: Likewise.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Likewise.

2003-04-01  Nick Clifton  <nickc@redhat.com>

	* archures.c (bfd_mach_arm_unknown): Define.
	* bfd-in.h (bfd_arm_merge_machines, bfd_arm+update_notes,
	bfd_arm_get_mach_from_notes): Prototype.
	* bfd-in2.h: Regenerate.
	* coff-arm.c (coff_arm_merge_private_bfd_data): Call
	bfd_arm_merge_machines.
	(coff_arm_final_link_postscript): Call bfd_arm_update_notes.
	* coffcode.h (coff_set_arch_mach_hook): Call
	bfd_arm_get_mach_from_notes.
	* coffgen.c (coff_real_object_p): Revert previous delta.
	* cpu_arm.c (arm_check_note): New function.  Examine a note in a
	.note section.
	(bfd_arm_merge_machines): New function: Handle the merging of ARM
	binaries compiled for different architectures..
	(bfd_arm_update_notes): New function: Update an ARM note section.
	(bfd_arm_get_mach_from_notes): New function: Extract a bfd machine
	number from an ARM note section.
	* elf32-arm.h (elf32_arm_object_p): Use
	bfd_arm_get_mach_from_notes.
	(elf32_arm_merge_private_bfd_data): Use bfd_arm_merge_machines.
	(elf32_arm_final_write_processing): Use bfd_arm_update_notes.

2003-04-01  Ben Elliston  <bje@wasabisystems.com>

	* dwarf2.c (read_attribute_value): Correct typo in comment.

2003-04-01  Nick Clifton  <nickc@redhat.com>

	* dwarf2.c (concat_filename): Use bfd_malloc() and strdup()
	instead of concat().
	(decode_line_info): Only free filename if it is not NULL.
	(add_line_info): Make a copy of the filename when storing it into
	the info structure.

2003-03-31  Andreas Schwab  <schwab@suse.de>
	    Daniel Jacobowitz  <drow@mvista.com>

	* simple.c (bfd_simple_get_relocated_section_contents): Add
	parameter symbol_table.  Optionally use it instead of the symbol
	table from the bfd.  Save and restore output offsets and output
	sections  around bfd_get_relocated_section_contents.  Fix a memory
	leak.
	(simple_save_output_info, simple_restore_output_info): New
	functions.
	* bfd-in2.h: Regenerate.
	* dwarf2.c (read_abbrevs): Use
	bfd_simple_get_relocated_section_contents instead of
	bfd_get_section_contents.
	(decode_line_info): Likewise.
	(_bfd_dwarf2_find_nearest_line): Likewise.  Don't call
	find_rela_addend.
	(find_rela_addend): Remove.
	* elfxx-ia64.c (elfNN_ia64_reloc): Weaken sanity check for
	debugging sections.
	(elfNN_ia64_hash_table_create): Create the hash table with malloc,
	not bfd_zalloc.

2003-03-31  David Heine  <dlheine@suif.stanford.edu>

	* aoutx.h (aout_link_hash_table_create): Use bfd_malloc instead of
	bfd_alloc.
	* dwarf2.c (concat_filename): Always allocate space for the
	returned filename.
	(decode_line_info): Free the allocated filename returned by
	concat_filename.
	* elf-eh-frame.c (bfd_elf_write_section_eh_frame): Fix memory leaks.
	* elf.c (copy_private_bfd_data): Likewise.
	(_bfd_elf_slurp_version_tables): Fix bug freeing contents pointer.
	* elflink.h (elf_link_sort_relocs): Fix memory leak.
	* format.c (bfd_check_format_matches): Likewise.
	* linker.c (bfd_generic_final_link): Likewise.
	* opncls.c (find_separate_debug_info): Likewise.
	* simple.c (bfd_simple_get_relocated_section_contents): Likewise.

2003-03-28  H.J. Lu <hjl@gnu.org>

	* elflink.h (elf_link_add_object_symbols): Correctly combine
	visibilities.

2003-03-27  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Reset self_dtpmod_offset
	to -1 before recomputing got offsets.

2003-03-26  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (WILL_CALL_FINISH_DYNAMIC_SYMBOL): Define.
	(elf_m68k_relocate_section): Use it to correctly handle symbols
	forced to be local.
	(elf_m68k_finish_dynamic_symbol): Emit RELATIVE reloc for got
	entries for symbols that are forced to be local.

2003-03-25  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (_bfd_mips_relax_section): New function.
	* elfxx-mips.h (_bfd_mips_relax_section): Declare.
	* elfn32-mips.c, elf64-mips.c: Use it.

2003-03-25  Stan Cox   <scox@redhat.com>
	    Nick Clifton  <nickc@redhat.com>

	Contribute support for Intel's iWMMXt chip - an ARM variant:

	* archures.c: Add bfd_mach_arm_iWMMXt.
	* reloc.c: Add BFD_RELOC_ARM_CP_OFF_IMM_S2.
	* bfd-in2.h: Regenerate.
	* libbfd.h: Regenerate.
	* coff-arm.c (coff_arm_merge_private_bfd_data): Allow iWMMXt
	object files to be linked with XScale ones.
	(coff_arm_final_link_postscript): Update note section.
	* coffcode.h (coff_set_arch_mach_hook): Handle note section.
	* coffgen.c (coff_real_object_p): Call bfd_coff_set_arch_mach_hook
	after identifying a coff binary.
	* cpu-arm.c (processors): Add iWMMXt.
	(arch_inf): Likewise.
	* elf32-arm.h (arm_object_p): Handle note section.
	(elf32_arm_merge_private_bfd_data): Allow iWMMXt object files to
	be linked with XScale ones.
	(elf32_arm_section_flags): New function: Set flags on note section.
	(elf32_arm_final_write_processing): Handle note section.

2003-03-21  DJ Delorie  <dj@redhat.com>

	* elf32-xstormy16.c (elf32_xstormy16_relocate_section): Call
	_bfd_elf_rela_local_sym.

2003-03-20  H.J. Lu <hjl@gnu.org>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Don't try relax for
	non-ELF outputs.

2003-03-20  Nick Clifton  <nickc@redhat.com>

	* peXXigen.c (_bfd_XXi_swap_aouthdr_out): Initialise $idata2 and
	$idata5 in case bfd_coff_final_link is not called.

2003-03-19  Jakub Jelinek  <jakub@redhat.com>

	* elf64-sparc.c (struct sparc64_elf_section_data): Add reloc_count
	field.
	(canon_reloc_count): Define.
	(sparc64_elf_slurp_one_reloc_table, sparc64_elf_slurp_reloc_table,
	sparc64_elf_canonicalize_dynamic_reloc): Use it instead of
	reloc_count.
	(sparc64_elf_canonicalize_reloc): New routine.
	(bfd_elf64_canonicalize_reloc): Define.

2003-03-18  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Handle relaxation
	againt mergeable sections.  Take r_addend into account when caching
	trampolines.

2003-03-18  Richard Henderson  <rth@redhat.com>

	* elfxx-ia64.c (get_dyn_sym_info): Return NULL gracefully for
	local symbols that have no dyninfo.

2003-03-14  Gene Smith  <gene.smith@siemens.com>

	* ieee.c (ieee_write_expression): Handle the case where symbol is
	NULL.
	General formatting improvements.

2003-03-13  Nick Clifton  <nickc@redhat.com>

	* configure.in (LINGUAS): Add zh_CN.
	* configure: Regenerate.
	* po/zh_CN.po: New file.

2003-03-13  Elias Athanasopoulos  <elathan@phys.uoa.gr>

	* aout-cris.c (BYTES_IN_WORD): Don't define.
	aout-encap.c: Likewise.
	aout-ns32k.c: Likewise.
	aout-tic30.c: Likewise.
	hp300bsd.c: Likewise.
	i386aout.c: Likewise.
	i386dynix.c: Likewise.
	i386linux.c: Likewise.
	i386lynx.c: Likewise.
	i386mach3.c: Likewise.
	m68k4knetbsd.c: Likewise.
	m68klinux.c: Likewise.
	m68klynx.c: Likewise.
	m68knetbsd.c: Likewise.
	m88kmach3.c: Likewise.
	mipsbsd.c: Likewise.
	newsos3.c: Likewise.
	sparclinux.c: Likewise.
	sparclynx.c: Likewise.
	sparcnetbsd.c: Likewise.
	vaxbsd.c: Likewise. Fix comment formatting.

2003-03-12  Alexandre Oliva  <aoliva@redhat.com>

	* Reverted 2003-03-02's patch.

	* elfxx-target.h (bfd_elfNN_canonicalize_reloc): Make it
	overridable.
	* elf64-mips.c (mips_elf64_canonicalize_reloc,
	mips_elf64_get_dynamic_reloc_upper_bound,
	mips_elf64_canonicalize_dynamic_reloc): New, adapted from elf.c.
	(bfd_elf64_get_canonicalize_reloc,
	bfd_elf64_get_dynamic_reloc_upper_bound,
	bfd_elf64_canonicalize_dynamic_reloc): Define.
	(mips_elf64_slurp_reloc_table): Support dynamic.
	(mips_elf64_slurp_one_reloc_table): Adjust.

2003-03-12  Nick Clifton  <nickc@redhat.com>

	* xsym.c (bfd_sym_fetch_type_information_table_entry): Change
	'index' to 'offset' in test for zero value.

2003-03-11  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_create_dynamic_relocation): Do not create
	dynamic relocations pointing to local or section symbols, use the
	NULL symbol instead.  Document the choice to not emit an
	additional R_MIPS_64 relocation.

2003-03-11  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_relocate_section): Subtract tls seg vma from
	zero index dynamic tls relocs generated for the GOT.  Tidy code.
	Set "relocation" to 1 on DTPMOD32 relocs.  Optimize HA adjustment.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.

2003-03-07  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_relocate_section): Don't look for a nop after
	a tls_get_addr call.

	* elf32-ppc.c (ELIMINATE_COPY_RELOCS): Define as one.
	(ppc_elf_adjust_dynamic_symbol): For weak symbols, copy
	ELF_LINK_NON_GOT_REF from weakdef.
	* elf64-ppc.c (ELIMINATE_COPY_RELOCS): Define as one.
	(ppc64_elf_adjust_dynamic_symbol): For weak symbols, copy
	ELF_LINK_NON_GOT_REF from weakdef.
	* elf32-i386.c (ELIMINATE_COPY_RELOCS): Define as one.  Use throughout.
	(elf_i386_adjust_dynamic_symbol): For weak symbols, copy
	ELF_LINK_NON_GOT_REF from weakdef.

2003-03-06  Jakub Jelinek <jakub@redhat.com>
	Andrew Haley  <aph@redhat.com>

	* elflink.h (elf_bfd_discard_info): Don't process eh frames if
	output is relocateable.

2003-03-06  Steven Konopa <skonopa@kgo.csc.com>

	* som.c (som_fixup_formats): Correct formats for R_AUX_UNWIND and
	R_COMMENT.

2003-03-06  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_create_linker_section): Don't capitalize
	error messages.
	(ELIMINATE_COPY_RELOCS): Define to zero.
	(ppc_elf_relocate_section): Don't deref htab->tls_sec when calculating
	TLSLD relocs.  Report reloc types on a number of errors.  Optimize
	LOCAL24PC check for non-local syms.  Don't capitalize error messages.
	* elf64-ppc.c (ELIMINATE_COPY_RELOCS): Define to zero.
	(ppc64_elf_relocate_section): Don't deref htab->tls_sec when
	calculating TLSLD relocs.  Report reloc types on a number of errors.
	Don't capitalize error messages.

2003-03-03  H.J. Lu <hjl@gnu.org>

	* elfxx-ia64.c (USE_BRL): Removed.
	(oor_ip): Removed.

2003-03-03  J"orn Rennecke <joern.rennecke@superh.com>

	* elf32-sh.c (sh_elf_howto_tab): Make R_SH_IND12W into an ordinary
	relocation (no special function), and make it non-partial_inplace.
	(sh_elf_relax_section): When creating a bsr, use a consistent value
	no matter if the symbol is extern or not;  set addend to -4.
	Don't swap load / non-load instructions for SH4.
	(sh_elf_relax_delete_bytes): In R_SH_IND12W case, check the offset
	rather than if the symbol is external to determine if adjusting the
	offset makes sense.  Adjust the addend too if appropriate.
	(sh_elf_relocate_section): In R_SH_IND12W, don't fiddle with the
	relocation.

2003-03-03  Nick Clifton  <nickc@redhat.com>

	* po/da.po: Installed latest translation.

2003-03-02  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>

	* elf32-mips.c (elf_mips_howto_table_rel): Change definition of
	R_MIPS_PC16 to rightshift 2.
	(elf_reloc_map mips_reloc_map): Map to rightshifted BFD reloc.
	(bfd_elf32_bfd_reloc_type_lookup): Support
	BFD_RELOC_MIPSEMB_16_PCREL_S2.
	* elf64-mips.c (mips_elf64_howto_table_rel): Change definition of
	R_MIPS_PC16 to rightshift 2.
	(mips_elf64_howto_table_rela): Likewise.
	(mips_reloc_map): Map to rightshifted BFD reloc.
	* elfn32-mips.c: The same as in elf64-mips.c.
	* elfxx-mips.c (mips_elf_got_for_ibfd): Typo in comment.
	(mips_elf_calculate_relocation): Handle rightshifted addends for
	R_MIPS_PC16.
	* reloc.c (BFD_RELOC_MIPSEMB_16_PCREL_S2): New BFD relocation for
	MIPS Embedded PIC. Remove superfluous empty COMMENT.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Regenerate.

2003-02-28  Richard Henderson  <rth@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Correct bounds
	for ltoff22x relaxation.

2003-03-01  Alan Modra  <amodra@bigpond.net.au>

	* bfd-in.h (_bfd): Don't define.
	* bfd.c: Rename occurrences of "struct _bfd" to "struct bfd".
	* syms.c: Likewise.
	* bfd-in2.h: Regenerate.

2003-02-27  Richard Henderson  <rth@redhat.com>

	* elfxx-ia64.c (struct elfNN_ia64_dyn_sym_info): Add want_gotx;
	(elfNN_ia64_check_relocs): Set it.
	(allocate_global_data_got): Check it.
	(allocate_local_got): Likewise.
	(allocate_dynrel_entries): Likewise.
	(elfNN_ia64_relax_ldxmov): New.
	(elfNN_ia64_relax_section): Handle LTOFF22X, LDXMOV.
	(elfNN_ia64_choose_gp): Split out from ...
	(elfNN_ia64_final_link): ... here.

2003-02-27  Andrew Cagney  <cagney@redhat.com>

	* bfd.c (struct bfd): Rename "struct _bfd".
	* bfd-in.h: Update copyright.
	(struct bfd): Rename "struct _bfd".
	(_bfd): Define for backward compatibility.
	* bfd-in2.h: Regenerate.

2003-02-25  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_bfd_final_link): Apportion reloc counts to rel_hdr
	and rel_hdr2 when initially counting input relocs rather than after
	creating output reloc sections.
	(elf_link_read_relocs_from_section): Don't abort with wrong reloc
	sizes.

	* Makefile.am: Run "make dep-am".
	* Makefile.in: Regenerate.

2003-02-24  Kris Warkentin  <kewarken@qnx.com>

	* elf.c (elfcore_read_notes): Add check for QNX style core file.
	(elfcore_grog_nto_note): New function.
	(elfcore_grog_nto_gregs): New function.
	(elfcore_grog_nto_status): New function.

2003-02-24  Alan Modra  <amodra@bigpond.net.au>

	* elflink.c (_bfd_elf_create_got_section): Check existing .got
	section flags before concluding that we've already been called.
	Don't use register keyword.
	(_bfd_elf_create_dynamic_sections): Don't use register keyword.
	(_bfd_elf_create_linker_section): Formatting.

2003-02-20  jmc  <jmc@prioris.mini.pw.edu.pl>

	* coff-h8300.c: Fix typo: intial -> initial.
	* coff-ppc.c: Likewise.

2003-02-20  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c: Formatting.
	(allocate_dynrelocs): LD and GD relocs against the same sym need
	separate GOT entries.
	(ppc_elf_relocate_section): Correct GOT handling for multiple GOT
	entries per symbol.

2003-02-19  Alan Modra  <amodra@bigpond.net.au>

	* elf32-hppa.c (elf32_hppa_gc_sweep_hook): Simplify dynamic reloc
	removal.  Localize vars.  Remove unnecessary dynobj test.
	* elf32-i386 (WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead
	of INFO.
	(allocate_dynrelocs): Adjust WILL_CALL_FINISH_DYNAMIC_SYMBOL uses,
	and optimize.
	(elf_i386_relocate_section): Likewise.
	(elf_i386_gc_sweep_hook): Simplify dyn reloc removal.  Localize vars.
	* elf32-s390.c (elf_s390_gc_sweep_hook): Likewise.
	* elf32-sh.c (sh_elf_gc_sweep_hook): Likewise.
	* elf64-s390.c (elf_s390_gc_sweep_hook): Likewise.
	* elf64-x86-64.c (elf64_x86_64_gc_sweep_hook): Likewise.
	* elf32-sparc.c (elf32_sparc_gc_sweep_hook): Likewise.  Remove
	local_dynrel for section too.  Don't touch HIPLT22, LOPLT10, PCPLT32
	or PCPLT10 relocs.  Don't subtract twice on PLT32 relocs.
	Formatting.

	* elf64-ppc.c (ELIMINATE_COPY_RELOCS): Define.
	(ppc64_elf_check_relocs): Use it.  Correct comment.  Move SEC_ALLOC
	test.
	(ppc64_elf_adjust_dynamic_symbol): Use ELIMINATE_COPY_RELOCS.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead of INFO.
	(allocate_dynrelocs): Adjust WILL_CALL_FINISH_DYNAMIC_SYMBOL uses,
	and optimize.  Use ELIMINATE_COPY_RELOCS.
	(ppc64_elf_relocate_section): Likewise.

	* elf32-ppc.c (struct ppc_elf_dyn_relocs): Add pc_count field.
	(ppc_elf_copy_indirect_symbol): Copy pc_count field.
	(ELIMINATE_COPY_RELOCS): Define.
	(ppc_elf_adjust_dynamic_symbol): Convert copy relocs to dynamic.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Pass SHARED instead of INFO.
	(MUST_BE_DYN_RELOC): Define.
	(allocate_dynrelocs): Adjust WILL_CALL_FINISH_DYNAMIC_SYMBOL uses,
	and optimize.  Trim dyn_relocs.
	(ppc_elf_check_relocs): Don't generate dyn_relocs when we know they'll
	not be used.  Do generate dyn_relocs for copy reloc avoidance.  Keep
	track of pc_rel dyn relocs.
	(ppc_elf_relocate_section): Remove "will_become_local".  Adjust
	WILL_CALL_FINISH_DYNAMIC_SYMBOL use.  Trim dyn relocs as per
	allocate_dynrelocs.  Don't recalculate "sec".

2003-02-18  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_relocate_section): Remove unnecessary test.
	* elf64-ppc.c (ppc64_elf_tls_optimize): Decrement tlsld_got.refcount
	on invalid LD relocs.
	(allocate_dynrelocs): Invalid LD relocs don't use tlsld_got entry.
	(ppc64_elf_relocate_section): Unify new handling of LD relocs and
	tlsld_got entry.  Use IS_PPC64_TLS_RELOC.

	* elf32-ppc.h: New file.
	* elf32-ppc.c: Include elf32-ppc.h.
	(NOP, CROR_151515, CROR_313131, TP_OFFSET, DTP_OFFSET): Define.
	(struct ppc_elf_link_hash_entry): Rename "root" to "elf".  Adjust uses.
	Add "tls_mask" field.
	(TLS_GD, TLS_LD, TLS_TPREL, TLS_DTPREL, TLS_TLS, TLS_TPRELGD): Define.
	(struct ppc_elf_link_hash_table): Rename "root" to "elf".  Adjust uses.
	Add got, relgot, plt, relplt, dynbss, relbss, dynsbss, relsbss,
	sdata, sdata2, tls_sec, tls_get_addr, tlsld_got fields.
	Make use of htab shortcuts throughout file.
	(ppc_elf_link_hash_newfunc): Init tls_mask field.
	(ppc_elf_link_hash_table_create): Init new fields.
	(ppc_elf_copy_indirect_symbol): Copy tls_mask.
	(ppc_elf_howto_raw): Add tls relocs.
	(ppc_elf_reloc_type_lookup): Handle them.
	(ppc_elf_unhandled_reloc): New function.
	(ppc_elf_create_got): Stash got section pointer in hash table,
	return status.  Make .rela.got too.
	(ppc_elf_create_dynamic_sections): Stash section pointers in htab.
	(ppc_elf_adjust_dynamic_symbol): Only set up copy relocs when
	NON_GOT_REF set.  Don't allocate space in .plt here..
	(allocate_dynrelocs): ..do so here instead, properly ref-counting and
	not allocating plt entries unnecessarily.  Allocate got entries here.
	(WILL_CALL_FINISH_DYNAMIC_SYMBOL): Define.
	(ppc_elf_size_dynamic_sections): Allocate local got entries.  Pass
	"info" during allocate_dynrelocs hash traversal.  Use htab section
	shortcuts rather than searching for named sections.  Get rid of
	"plt" and "strip" booleans.
	(update_local_sym_info, bad_shared_reloc): New functions.
	(ppc_elf_check_relocs): Handle TLS relocs.  Move .rela.got creation to
	ppc_elf_create_got.  Don't mark got or plt reloc syms dynamic, do so
	in allocate_dynreloc.  Use update_local_sym_info and bad_shared_reloc.
	Disallow R_PPC_EMB_RELSDA, R_PPC_EMB_NADDR32, R_PPC_EMB_NADDR16,
	R_PPC_EMB_NADDR16_LO, R_PPC_EMB_NADDR16_HI and R_PPC_EMB_NADDR16_HA
	in shared libs.  R_PPC_PLTREL32 is a plt reloc too.  Refcount all
	relocs that might use a plt entry.  Set NON_GOT_REF too.
	Enumerate all do-nothing relocs.
	(ppc_elf_gc_sweep_hook): Simplify removal of dynrelocs.  Handle
	tls relocs and all plt relocs.
	(ppc_elf_tls_setup, ppc_elf_tls_optimize): New functions.
	(ppc_elf_finish_dynamic_symbol): Don't build got entries here.
	(ppc_elf_finish_dynamic_sections): Rewrite tag code using htab
	shortcuts.
	(ppc_elf_relocate_section): Tidy.  Handle TLS relocs.  Use
	bfd_elf_local_sym_name.  Simplify unresolved reloc code.  Build got
	entries and got relocs here.  Warn on non-zero got reloc addend.
	Split out branch taken/not taken reloc code into a separate switch
	and correct offset calculation. Allow BRTAKEN/BRNTAKEN dynamic relocs.
	Split out HA reloc adjustments to separate switch statement.  Don't
	warn on reloc overflow if we've already warned about undefined.
	Don't rebuild sym name when reporting errors.  Report all possible
	errors from _bfd_final_link_relocate.
	(bfd_elf32_bfd_final_link): Don't define.

2003-02-18  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_relocate_section): Don't init "r".  Don't
	rebuild sym name when reporting errors.

2003-02-17  Nick Clifton  <nickc@redhat.com>

	* elflink.h (elf_link_output_extsym): Only check
	allow_shlib_undefined for shared libraries.
	* elf32-i386.c (elf_i386_relocate_section): Remove bogus check
	of allow_shlib_undefined.
	* elf32-cris.c (cris_elf_relocate_section): Likewise.
	* elf32-hppa.c (elf32_hppa_relocate_section): Likewise.
	* elf32-m68k.c (elf_m68k_relocate_section): Likewise.
	* elf32-ppc.c (ppc_elf_relocate_section): Likewise.
	* elf32-s390.c (elf_s390_relocate_section): Likewise.
	* elf32-sh.c (sh_elf_relocate_section): Likewise.
	* elf32-sparc.c (elf32_sparc_relocate_section): Likewise.
	* elf32-vax.c (elf_vax_relocate_section): Likewise.
	* elf64-alpha.c (elf64_alpha_relocate_section): Likewise.
	* elf64-hppa.c (elf64_hppa_relocate_section): Likewise.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.
	* elf64-s390.c (elf_s390_relocate_section): Likewise.
	* elf64-sparc.c (sparc64_elf_relocate_section): Likewise.
	* elf64-x86-64.c (elf64_x86_64_relocate_section): Likewise.
	* elfxx-ia64.c (elfNN_ia64_relocate_section): Likewise.
	* elfxx-mips.c (_bfd_mips_elf_relocate_section): Likewise.

2003-02-17  Nick Clifton  <nickc@redhat.com>

	* elf.c (SEGMENT_AFTER_SEGMENT): Add third parameter - the
	address field to use in the comparison.
	(SEGMENT_OVERLAPS): Check that LMAs overlap as well.

2003-02-14  Bob Wilson  <bob.wilson@acm.org>

	* elfcore.h (elf_core_file_p): Compare alternate machine codes for ELF
	backends when checking if the generic ELF target should be used.

	* syms.c (_bfd_stab_section_find_nearest_line): For line number stabs
	outside of functions, treat values as absolute addresses.

	* bfd.c: Change embedded documentation to use consistent indentation
	and to split up long lines.  Change informal style of description
	for functions lacking real documentation.
	* coffcode.h: Break up long lines in embedded documentation.
	* format.c: Likewise.
	* targets.c: Likewise.
	* libcoff.h: Regenerate.
	* bfd-in2.h: Regenerate.

2003-02-14  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_link_hash_table_create): Init tls_get_addr.
	(ppc64_elf_copy_indirect_symbol): Merge tls_mask too.
	(ppc64_elf_gc_sweep_hook): Simplify removal of dyn_relocs.
	(allocate_dynrelocs): Don't treat undefined and undefweak specially.
	(ppc_size_one_stub): Fix warning, and tighten plt entry check.
	(group_sections): Don't share a stub section if stubs are for a large
	section.  Adjust comment.
	(ppc64_elf_size_stubs): Roughly double the size left for stubs if
	!stubs_always_before_branch.
	(ppc64_elf_relocate_section): Initialize tlsld GOT entry once.  Don't
	treat undefined and undefweak specially when processing dyn relocs.

2003-02-13  Jakub Jelinek  <jakub@redhat.com>

	* elflink.h (elf_link_add_object_symbols): Handle .symver x, x@FOO.

2003-02-13  Nick Clifton  <nickc@redhat.com>

	* elf32-arm.h (elf32_thumb_to_arm_stub): Include section VMAs
	in computation of offset to insert into BL instruction.

2003-02-11  Uwe Stieber  <uwe@wwws.de>

	* config.bfd: Add support for kaOS as cross build target system.

2003-02-11  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_check_relocs): Match versioned
	.__tls_get_addr too.
	(ppc64_elf_tls_setup): Ensure cached tls_get_addr is not indirect.

2003-02-10  Kaz kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (elf_sh_dyn_relocs): Add tls_tpoff32 field.
	(elf_sh_link_hash_entry): Remove tls_tpoff32 field.
	(sh_elf_link_hash_newfunc): Remove the initialization of
	tls_tpoff32 field.
	(allocate_dynrelocs): Keep dyn_relocs if it includes the entry
	for which tls_tpoff32 flag is set.
	(sh_elf_relocate_section): Covert to LE only if the dyn_relocs
	of the symbol includes the entry matched with the input_section
	and having tls_tpoff32 flag on.  When linking statically, set
	symbol index of R_SH_TLS_TPOFF32 relocation to zero if the symbol
	is defined in this executable.
	(sh_elf_check_relocs): Set tls_tpoff32 flag appropriately.

2003-02-10  Jakub Jelinek  <jakub@redhat.com>

	* elf32-s390.c (elf_s390_size_dynamic_sections): Set relocs to TRUE
	even if there is just non-empty .rela.plt.

2003-02-10  Nick Clifton  <nickc@redhat.com>

	* archures.c (bfd_mach_arm_ep9312): Define.
	* bfd-in2.h: Regenerate.
	* cpu-arm.c (processors[]): Add ep9312.
	(bfd_arm_arch): Add ep9312.
	* elf32-arm.h (elf32_arm_merge_private_data): Update error
	messages and add test for Maverick floating point support.
	(elf32_arm_print_private_bfd_data): Handle
	EF_ARM_MAVERICK_FLOAT flag.
	(elf32_arm_object_p): New function.
	(elf_backend_object_p): Define.

2003-02-10  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Rename assorted occurrences of tls_type and similar
	variables, structure fields or function params to tls_mask or
	similar to better reflect usage.
	(struct got_entry): Comment.
	(struct ppc_link_hash_entry): Expand comment, and renumber TLS_*.
	(get_tls_mask): Rename from get_tls_type.

2003-02-09  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (TLS_GD_LD): Don't define..
	(TLS_GD): ..define this instead and update all uses.
	(TLS_TPRELGD): Define.
	(ppc64_elf_link_hash_table_create): Tweak initialization of
	init_refcount and init_offset.
	(ppc64_elf_check_relocs): Add one extra element to t_symndx array.
	Mark second slot of GD or LD toc entries.
	(get_tls_type): Return an int.  Distinguish toc GD and LD entries
	from other tls types.
	(ppc64_elf_tls_setup): New function, split out from..
	(ppc64_elf_tls_optimize): ..here.  Don't optimize when symbols are
	defined in a dynamic object.  Fix LD optimization.  Don't set TLS_TPREL
	on GD->IE optimization, use TLS_TPRELGD instead.  Use get_tls_type
	return value to properly decide whether toc GD and LD entries can
	optimize away __tls_get_addr call.  Check next reloc after DTPMOD64
	to determine GD or LD rather than looking at TLS_LD flag.  Don't
	attempt to adjust got entry tls_type here..
	(allocate_dynrelocs): ..instead, adjust got entry tls_type here, and
	look for possible merges.
	(ppc64_elf_size_dynamic_sections): Adjust local got entries for
	optimization.
	(ppc64_elf_size_stubs): Tweak __tls_get_addr fudge.
	(ppc64_elf_relocate_section): Rename some vars to better reflect usage.
	Make use of return value from get_tls_type to properly detect GD and
	LD optimizations.  Split tlsld/gd hi/ha from lo/ds case.  Don't
	handle tls_get_addr removal when looking at REL24 relocs, do it when
	looking at the previous reloc.  Check reloc after DTPMOD64 to determine
	GD or LD.
	* elf64-ppc.h (ppc64_elf_tls_setup): Declare.

2003-02-08  Alan Modra  <amodra@bigpond.net.au>

	* elf32-hppa.c (group_sections): Don't share a stub section if
	stubs are for a large section.

	* elf32-hppa.c (elf32_hppa_size_stubs): Double the size left for
	stubs if !stubs_always_before_branch.

2003-02-07  Nick Clifton  <nickc@redhat.com>

	* elf.c (swap_out_syms): Generate an error message if an
	equivalent output section cannot be found for a symbol.

2003-02-07  Jakub Jelinek  <jakub@redhat.com>

	* elf64-alpha.c (elf64_alpha_relax_section): Don't crash if
	local_got_entries is NULL.

2003-02-06  Andreas Schwab  <schwab@suse.de>

	* elf-eh-frame.c (get_DW_EH_PE_signed): Define.
	(read_value): Add parameter is_signed, use signed extraction if
	the value is signed.
	(_bfd_elf_write_section_eh_frame): Pass signed flag of the
	encoding to read_value.

2003-02-06  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_copy_indirect_symbol): Don't copy got and
	plt info when called to transfer weak sym info.

2003-02-05  Alan Modra  <amodra@bigpond.net.au>

	* reloc.c: Add PPC and PPC64 TLS relocs.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Regenerate.
	* elf64-ppc.c (TP_OFFSET, DTP_OFFSET): Declare.
	(ppc64_elf_howto_raw): Add TLS howto's.  Adjust R_PPC64_NONE to be
	against a 32 bit field.
	(ppc64_elf_reloc_type_lookup): Handle TLS relocs.
	(_ppc64_elf_section_data): Add t_symndx and comments.
	(ppc64_elf_section_data): Use elf_section_data macro.
	(ppc64_elf_new_section_hook): American spelling.
	(struct got_entry, struct plt_entry): New.
	(MUST_BE_DYN_RELOC): Rename from IS_ABSOLUTE_RELOC.
	(struct ppc_stub_hash_entry): Add "addend" field.
	(struct ppc_link_hash_entry): Add "tls_type".
	(TLS_TLS, TLS_GD_LD, TLS_LD, TLS_TPREL, TLS_DTPREL,
	TLS_EXPLICIT): Define.
	(struct ppc_link_hash_table): Add tls_sec, tls_get_addr, tlsld_got.
	(link_hash_newfunc): Init new fields.
	(ppc64_elf_link_hash_table_create): Likewise.  Set init_refcount and
	init_offset to NULL.
	(ppc64_elf_copy_indirect_symbol): Copy got and plt info.  Don't call
	_bfd_elf_link_hash_copy_indirect, rather insert relevant code from
	there.
	(update_local_sym_info, update_plt_info): New functions.
	(ppc64_elf_check_relocs): Use them.  Handle TLS relocs.  Adjust GOT
	handling to use got.glist rather than got.refcount.  Likewise for PLT.
	(ppc64_elf_gc_sweep_hook): Handle TLS relocs, new GOT and PLT lists.
	(func_desc_adjust): Adjust for new PLT list.
	(ppc64_elf_adjust_dynamic_symbol): Likewise.
	(get_sym_h, get_tls_type): New functions.
	(ppc64_elf_edit_opd): Remove unused variable.  Use get_sym_h.
	(ppc64_elf_tls_optimize): New function.
	(allocate_dynrelocs): Adjust for new PLT and GOT lists.  Allocate
	TLS relocs.
	(ppc64_elf_size_dynamic_sections): Likewise.
	(ppc_type_of_stub): Adjust for new PLT list.
	(ppc_build_one_stub): Likewise.
	(ppc64_elf_size_stubs): Likewise.  Use get_sym_h.  Treat __tls_get_addr
	calls specially.
	(ppc64_elf_relocate_section): Adjust for new GOT and PLT lists.  Handle
	TLS relocs.  Report local syms using bfd_elf_local_sym_name.  Don't
	init GOT entries that have a reloc.  Generate GOT relocs here..
	(ppc64_elf_finish_dynamic_symbol): ..not here.  Adjust for PLT list.
	* elf64-ppc.h (ppc64_elf_tls_optimize): Declare.

2003-02-04  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (elf_m68k_hash_entry): Define.
	(elf_m68k_link_hash_traverse): Remove.
	(elf_m68k_link_hash_newfunc): Use struct bfd_hash_entry and
	elf_m68k_hash_entry instead of struct elf_m68k_link_hash_entry to
	reduce casting.
	(elf_m68k_check_relocs): Use elf_m68k_hash_entry instead of
	casting.
	(elf_m68k_size_dynamic_sections): Use elf_link_hash_traverse
	instead of elf_m68k_link_hash_traverse.
	(elf_m68k_discard_copies): Change first parameter to pointer to
	struct elf_link_hash_entry and use elf_m68k_hash_entry when struct
	elf_m68k_link_hash_entry is needed.

2003-02-04  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct got_entry, struct plt_entry): Forward declare.
	(struct elf_link_hash_entry): Add "glist" and "plist" fields to
	"got" union, and declare as gotplt_union.  Use gotplt_uinion for
	"plt" field.
	(struct elf_link_hash_table): Make "init_refcount" a gotplt_union.
	Add "init_offset" field.
	(struct elf_obj_tdata <local_got>): Add "struct got_entry **" to union.
	(elf_local_got_ents): Declare.
	* elf.c (_bfd_elf_link_hash_newfunc): Adjust initialization of "got"
	and "plt".
	(_bfd_elf_link_hash_hide_symbol): Use "init_offset".
	(_bfd_elf_link_hash_table_init): Set "init_offset".
	* elflink.h (NAME(bfd_elf,size_dynamic_sections)): Set init_refcount
	from init_offset.
	(elf_adjust_dynamic_symbol): Set plt and got offsets using init_offset.

	* elf.c (bfd_elf_local_sym_name): Split out from..
	(group_signature): ..here.
	* elf-bfd.h (bfd_elf_local_sym_name): Declare.

2003-02-04  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (enum elf_link_info_type): Remove.
	(struct bfd_elf_section_data): Move sec_info_type, use_rela_p fields
	to struct sec.  Remove linkonce_p field.
	(elf_linkonce_p): Delete.
	(elf_discarded_section): Update for sec_info_type change.
	* section.c (struct sec): Add sec_info_type, use_rela_p, has_tls_reloc,
	flag11, flag12, flag13, flag14, flag15, flag16, flag20, flag24.
	(ELF_INFO_TYPE_NONE): Define.
	(ELF_INFO_TYPE_STABS): Define.
	(ELF_INFO_TYPE_MERGE): Define.
	(ELF_INFO_TYPE_EH_FRAME): Define.
	(ELF_INFO_TYPE_JUST_SYMS): Define.
	(STD_SECTION): Update struct sec initializer.
	* ecoff.c (bfd_debug_section): Likewise.
	* elf.c: Likewise.  Update occurrences of sec_info_type and use_rela_p.
	* elflink.h: Likewise.
	* elf-eh-frame.c: Likewise.
	* elf64-alpha.c: Likewise.
	* elfxx-ia64.c: Likewise.
	* elfxx-mips.c: Likewise.
	* bfd-in2.h: Regenerate.

	* elf32-sparc.c (sec_do_relax): Use elf_section_data macro rather than
	referring to used_by_bfd.
	* elf64-sparc.c (sec_do_relax): Likewise.
	* elf64-mmix.c (mmix_elf_section_data): Likewise.
	* elfxx-mips.c (mips_elf_section_data): Likewise.
	* ieee.c (ieee_slurp_section_data): Use ieee_per_section macro.
	(ieee_get_section_contents): Likewise.
	(ieee_new_section_hook): Formatting.
	(ieee_canonicalize_reloc): Remove commented out code.
	* mmo.c (mmo_section_data): Define.  Use throughout file.
	* oasys.c (oasys_get_section_contents): Use oasys_per_section macro.

2003-01-31  Graydon Hoare <graydon@redhat.com>

	* Makefile.am (opncls.lo): Add dependency upon libiberty.h.
	* Makefile.in: Regenerate.
	* opncls.c (calc_crc32, get_debug_link_info,
	seperate_debug_file_exists, find_seperate_debug_file): New
	internal functions.
	(bfd_follow_gnu_debuglink): New function.  Follow the pointer
	contained inside a .gnu_debuglink section.
	* bfd-in2.h: Regenerate.

2003-01-29  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_got_entry_hash): Don't dereference
	entry->abfd when it's NULL.

2003-01-27  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_create_dynamic_relocation): Handle
	_bfd_elf_section_offset returning -2 the same way as -1.

	* elfxx-mips.c (mips_elf_multi_got): New function.
	(struct mips_got_entry): Make symndx and gotidx signed.  Moved
	addend into union along with address and link hash entry.
	(struct mips_got_info): Added bfd2got and next.
	(struct mips_elf_hash_sort_data): Added max_unref_got_dynindx.
	(mips_elf_got_section, mips_elf_create_got_section): Use
	SEC_EXCLUDE bit to tell whether we really need the got
	section.  Take boolean arguments to disregard an excluded
	section, or to create it as excluded.  Adjust all callers.
	Use mips_elf_got_section all over.
	(mips_elf_local_got_index, mips_elf_got_page,
	mips_elf_got16_entry): Take input bfd as argument, and pass it
	on to mips_elf_create_local_got_entry.
	(mips_elf_global_got_index, mips_elf_create_local_got_entry):
	Take input bfd as argument, and manage entries in the
	appropriate GOT.
	(mips_elf_got_offset_from_index): Take input bfd as argument,
	and use it to adjust the GP offset of the bfd.
	(mips_elf_sort_hash_table, mips_elf_sort_hash_table_f): Move
	unreferenced GOT entries of global symbols to the end.
	(mips_elf_record_global_got_symbol): Take input bfd as
	argument.  Add entries to the master GOT hash table.
	(struct mips_elf_bfd2got_hash): New.
	(struct mips_elf_got_per_bfd_arg): New.
	(struct mips_elf_set_global_got_offset_arg): New.
	(mips_elf_hash_bfd_vma, mips_elf_multi_got_entry_hash,
	mips_elf_multi_got_entry_eq, mips_elf_bfd2got_entry_hash,
	mips_elf_bfd2got_entry_eq, mips_elf_make_got_per_bfd,
	mips_elf_merge_gots, mips_elf_set_global_got_offset,
	mips_elf_resolve_final_got_entry,
	mips_elf_resolve_final_got_entries, mips_elf_adjust_gp,
	mips_elf_got_for_ibfd): New functions.
	(ELF_MIPS_GP_OFFSET): Don't depend on SGI_COMPAT.
	(MIPS_ELF_GOT_MAX_SIZE): New macro.
	(STUB_LW): Generate 64-bit stub regardless of SGI_COMPAT.
	(mips_elf_got_entry_hash): Take new fields into account.  Use
	mips_elf_hash_bfd_vma.
	(mips_elf_got_entry_eq): Take new fields into account.
	(mips_elf_create_got_section): Initialize new fields.
	(mips_elf_calculate_relocation): Pass input_bfd to functions
	that now take it.  Adjust gp for the input_bfd.
	(mips_elf_allocate_dynamic_relocation,
	mips_elf_create_dynamic_relocation,
	_bfd_mips_elf_create_dynamic_sections): Use...
	(mips_elf_rel_dyn_section): New function.  Borrow code from...
	(_bfd_mips_elf_check_relocs): Pass input_bfd to functions that
	now take it.  Create the got section if needed, even if
	excluded, before recording a global got symbol.  Move some
	code to...
	(mips_elf_record_local_got_symbol): New fn.
	(_bfd_mips_elf_size_dynamic_sections): Disable combreloc.
	Compute multi-got global entries offsets.  Move GOT code to...
	(_bfd_mips_elf_always_size_sections): Call mips_elf_multi_got
	if the GOT is too big.
	(_bfd_mips_elf_finish_dynamic_symbol): Set got entry of
	undefweak symbol to zero.  Generate dynamic relocations for
	non-primary GOT entries for global symbols.
	(_bfd_mips_elf_finish_dynamic_sections): Handle multi-got
	case.  Generate dynamic relocations for local got entries.
	Sort dynamic relocations on N64 too, using...
	(sort_dynamic_relocs_64): New fns.
	(_bfd_mips_elf_hide_symbol): Adjust multi-got counters.
	(_bfd_mips_elf_merge_private_bfd_data): Ignore EF_MIPS_XGOT.

2003-01-27  Alexandre Oliva  <aoliva@redhat.com>

	* bfd.c (struct _bfd): Added id field.
	* opncls.c (_bfd_id_counter): New static variable.
	(_bfd_new_bfd): Use it.
	* bfd-in2.h: Rebuilt.

2003-01-25  Alan Modra  <amodra@bigpond.net.au>

	* elf32-sparc.c (bfd_elf32_new_section_hook): Define.

2003-01-25  Jakub Jelinek  <jakub@redhat.com>

	* elf32-sparc.c (_bfd_sparc_elf_howto_table): Add TLS relocs.
	(elf32_sparc_rev32_howto): New variable.
	(sparc_reloc_map): Add TLS relocs.
	(elf32_sparc_reloc_type_lookup, elf32_sparc_info_to_howto):
	Handle REV32.
	(sparc_elf_hix22_reloc, sparc_elf_lox10_reloc, elf32_sparc_mkobject):
	New functions.
	(struct elf32_sparc_dyn_relocs, struct elf32_sparc_link_hash_entry,
	struct elf32_sparc_link_hash_table):
	New structures.
	(elf32_sparc_tdata, elf32_sparc_local_got_tls_type,
	elf32_sparc_hash_table): Define.
	(link_hash_newfunc, elf32_sparc_link_hash_table_create,
	create_got_section, elf32_sparc_create_dynamic_sections,
	elf32_sparc_copy_indirect_symbol, elf32_sparc_tls_transition): New
	functions.
	(elf32_sparc_check_relocs): Handle TLS relocs.  Add dynamic reloc
	reference counting.
	(elf32_sparc_gc_sweep_hook): Likewise.
	(elf32_sparc_adjust_dynamic_symbol): Likewise.
	(elf32_sparc_size_dynamic_sections): Likewise.
	(elf32_sparc_relocate_section): Likewise.
	(allocate_dynrelocs, readonly_dynrelocs, dtpoff_base, tpoff):
	New functions.
	(elf32_sparc_object_p): Allocate backend private object data.
	(bfd_elf32_bfd_link_hash_table_create,
	elf_backend_copy_indirect_symbol, bfd_elf32_mkobject,
	elf_backend_can_refcount): Define.
	(elf_backend_create_dynamic_sections): Define to
	elf32_sparc_create_dynamic_sections.
	* reloc.c: Add SPARC TLS relocs.
	* bfd-in2.h, libbfd.h: Rebuilt.
	* elf64-sparc.c (sparc64_elf_howto_table): Add TLS relocs.
	(sparc_reloc_map): Likewise.

2003-01-24  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* bfd-in2.h: Regenerate.
	* elf32-s390.c (elf_s390_mkobject, elf_s390_tls_transition,
	s390_tls_reloc, dtpoff_base, tpoff, invalid_tls_insn): New functions.
	(elf_howto_table): Add TLS relocs.
	(elf_s390_reloc_type_lookup): Likewise.
	(elf_s390_link_hash_entry): Add tls_type.
	(elf_s390_hash_entry, elf_s390_obj_tdata, elf_s390_local_got_tls_type):
	New macros.
	(elf_s390_link_hash_table): Add tls_ldm_got.
	(link_hash_newfunc): Initialize tls_type.
	(elf_s390_link_hash_table_create): Initialize refcount of tls_ldm_got.
	(elf_s390_copy_indirect_symbol): Copy tls_type information.
	(elf_s390_check_relocs): Support TLS relocs.
	(elf_s390_gc_sweep_hook): Likewise.
	(allocate_dynrelocs): Likewise.
	(elf_s390_size_dynamic_sections): Likewise.
	(elf_s390_relocate_section): Likewise.
	(elf_s390_finish_dynamic_symbol): Likewise.
	(bfd_elf32_mkobject): Define for TLS.
	* elf64-s390.c: Same changes as for elf32-s390.c.
	* libbfd.h: Regenerate.
	* reloc.c: Add s390 TLS relocations.

2003-01-24  Charles Lepple  <clepple@ghz.cc>

	* aclocal.m4: Fix name of --enable-install-libbfd switch.

2003-01-23  Nick Clifton  <nickc@redhat.com>

	* Add sh2e support:
	2002-04-02  Elena Zannoni  <ezannoni@redhat.com>
	* archures.c (bfd_mach_sh2e): Added.
	* bfd-in2.h: Rebuilt.
	* cpu-sh.c (arch_info_struct): Added SH2e.
	* elf32-sh.c (sh_elf_set_mach_from_flags): Handle EF_SH2E.

2003-01-23  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h (struct bfd_elf_section_data): Remove tdata.  Change
	dynindx to an int.  Rearrange for better packing.
	* elf.c (_bfd_elf_new_section_hook): Don't alloc if already done.
	* elf32-mips.c (bfd_elf32_new_section_hook): Define.
	* elf32-sh64.h: New.  Split out from include/elf/sh.h.
	(struct _sh64_elf_section_data): New struct.
	(sh64_elf_section_data): Don't dereference sh64_info (was tdata).
	* elf32-sh64-com.c: Include elf32-sh64.h.
	* elf32-sh64.c: Likewise.
	(sh64_elf_new_section_hook): New function.
	(bfd_elf32_new_section_hook): Define.
	(sh64_elf_fake_sections): Adjust for sh64_elf_section_data change.
	(sh64_bfd_elf_copy_private_section_data): Likewise.
	(sh64_elf_final_write_processing): Likewise.
	* elf32-sparc.c (struct elf32_sparc_section_data): New.
	(elf32_sparc_new_section_hook): New function.
	(SET_SEC_DO_RELAX, SEC_DO_RELAX): Delete.
	(sec_do_relax): Define.
	(elf32_sparc_relax_section): Adjust to use sec_do_relax.
	(elf32_sparc_relocate_section): Likewise.
	* elf64-mips.c (bfd_elf64_new_section_hook): Define.
	* elf64-mmix.c (struct _mmix_elf_section_data): New.
	(mmix_elf_section_data): Define.  Use throughout file.
	(mmix_elf_new_section_hook): New function.
	(bfd_elf64_new_section_hook): Define.
	* elf64-ppc.c (struct _ppc64_elf_section_data): New.
	(ppc64_elf_section_data): Define.  Use throughout.
	(ppc64_elf_new_section_hook): New function.
	(bfd_elf64_new_section_hook): Define.
	* elf64-sparc.c (struct sparc64_elf_section_data): New.
	(sparc64_elf_new_section_hook): New function.
	(SET_SEC_DO_RELAX, SEC_DO_RELAX): Delete.
	(sec_do_relax): Define.
	(sparc64_elf_relax_section): Adjust to use sec_do_relax.
	(sparc64_elf_relocate_section): Likewise.
	(bfd_elf64_new_section_hook): Define.
	* elfn32-mips.c (bfd_elf32_new_section_hook): Define.
	* elfxx-mips.c (struct _mips_elf_section_data): New.
	(mips_elf_section_data): Define.  Use throughout.
	(_bfd_mips_elf_new_section_hook): New function.
	(mips_elf_create_got_section): Don't alloc used_by_bfd.
	* elfxx-mips.h (_bfd_mips_elf_new_section_hook): Declare.
	* elfxx-target.h (bfd_elfNN_new_section_hook): Add #ifndef.
	* Makefile.am: Run "make dep-am".
	* Makefile.in: Regenerate.

2003-01-21  Richard Henderson  <rth@redhat.com>

	* elf64-alpha.c (ALPHA_ELF_LINK_HASH_PLT_LOC): New.
	(struct alpha_elf_link_hash_entry): Add plt_old_section, plt_old_value.
	(elf64_alpha_adjust_dynamic_symbol): Set them.
	(elf64_alpha_size_plt_section_1): Reset them when plt entry removed.
	(elf64_alpha_relax_tls_get_addr): Handle LDM relocs.  Frob the
	symbol index when relaxing LDM to TPREL.
	(elf64_alpha_relax_section): Likewise.  Allow relaxation of GD
	relocs, even if the target isn't locally defined.
	(elf64_alpha_check_relocs): Frob LDM reloc symndx to zero.
	(elf64_alpha_relocate_section): Likewise.  Force TP-relative
	relocs vs symndx 0 to the tp base.

2003-01-21  Fabio Alemagna  <falemagn@aros.org>

	* config.bfd: Handle i[3456]86-*-aros*.

2003-01-21  Andreas Schwab  <schwab@suse.de>

	* elf32-ppc.c (struct ppc_elf_dyn_relocs): Define.
	(struct ppc_elf_link_hash_entry): Define.
	(ppc_elf_hash_entry): New function.
	(struct ppc_elf_link_hash_table): Define.
	(ppc_elf_hash_table): New function.
	(ppc_elf_link_hash_newfunc): New function.
	(ppc_elf_link_hash_table_create): New function.
	(ppc_elf_copy_indirect_symbol): New function.
	(allocate_dynrelocs): New function.
	(readonly_dynrelocs): New function.
	(ppc_elf_size_dynamic_sections): Allocate space for dynamic
	relocs and determine DT_TEXTREL.
	(ppc_elf_check_relocs): Don't do that here, just count the
	dynamic relocs.
	(ppc_elf_gc_sweep_hook): Discard any dynamic relocs against the
	removed section.
	(bfd_elf32_bfd_link_hash_table_create): Define.
	(elf_backend_copy_indirect_symbol): Define.

2003-01-21  Richard Henderson  <rth@redhat.com>

	* elf64-alpha.c (alpha_dynamic_entries_for_reloc): GOTTPREL and
	TPREL also get a reloc if shared.  Remove SREL support.
	(elf64_alpha_emit_dynrel): New.
	(elf64_alpha_relocate_section): Use it.  Resolve dynamic TPREL
	and GOTTPREL relocs to local symbols against the tp base.
	(elf64_alpha_finish_dynamic_symbol): Use elf64_alpha_emit_dynrel.

	* elf64-alpha.c (elf64_alpha_relax_got_load): Decrement got
	use count before clobbering r_type.
	(elf64_alpha_relax_tls_get_addr): Don't use pos[1] if insn
	ordering would mean dataflow inspection is necessary.

2003-01-20  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* coffcode.h (coff_set_flags): Added get/set arch hooks.

2003-01-20  Fabio Alemagna  <falemagn@aros.org>

	* elf32-sh.c: Treat elfNN_bed like other macros defined in
	  elfxx-target.h and #undef it before #define'ing it.
	* elf32-i386.c: Likewise.
	* elf32-sh64.c: Likewise.
	* elf64-alpha.c: Likewise.
	* elf64-sh64.c: Likewise.

2003-01-20  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* bfd-in2.h: Regenerate.
	* elf32-s390.c (elf_s390_adjust_gotplt): New prototype.
	(elf_howto_table): Rename R_390_GOTOFF to R_390_GOTOFF32. Add
	R_390_GOTOFF16, R_390_GOTOFF64, R_390_GOTPLT12, R_390_GOTPLT16,
	R_390_GOTPLT32, R_390_GOTPLT64, R_390_GOTPLTENT, R_390_PLTOFF16,
	R_390_PLTOFF32 and R_390_PLTOFF64.
	(elf_s390_reloc_type_lookup): Likewise.
	(struct elf_s390_link_hash_entry): Add gotplt_refcount to keep track
	of GOTPLT references to a function.
	(link_hash_newfunc): Initialize gotplt_refcount.
	(elf_s390_check_relocs): Move allocation of local_got_refcounts array
	and creation of the got section out of the main switch. Add support
	for the gotoff, gotplt and pltoff relocations.
	(elf_s390_gc_sweep_hook): Add reference counting for gotoff, gotplt
	and pltoff.
	(elf_s390_adjust_gotplt): New function.
	(elf_s390_adjust_dynamic_symbol): Adjust gotplt refcount for removed
	plt entries.
	(allocate_dynrelocs): Add comment.
	(elf_s390_relocate_section): Change r_type to unsigned. Add support
	for gotoff, gotplt and pltoff relocations.
	* elf64-s390.c: Same changes as for elf32-s390.c.
	* libbfd.h: Regenerate.
	* reloc.c: Add BFD_RELOC_390_GOTOFF64, BFD_RELOC_390_GOTPLT12,
	BFD_RELOC_390_GOTPLT16, BFD_RELOC_390_GOTPLT32, BFD_RELOC_390_GOTPLT64,
	BFD_RELOC_390_GOTPLTENT, BFD_RELOC_390_PLTOFF16, BFD_RELOC_390_PLTOFF32
	and BFD_RELOC_390_PLTOFF64.

2003-01-18  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relocate_section): Handle
	R_IA64_TPREL64[LM]SB against non-global symbol properly.

2003-01-16  Jakub Jelinek  <jakub@redhat.com>

	* elfxx-ia64.c (struct elfNN_ia64_link_hash_table): Add
	self_dtpmod_done and self_dtpmod_offset.
	(allocate_global_data_got): Only use one got entry for all
	dtpmod relocs against local symbols.
	(allocate_dynrel_entries): Only need .rela.got entry for
	dtpmod against global symbol.
	(elfNN_ia64_size_dynamic_sections): Initialize self_dtpmod_offset.
	Reserve space in .rela.got for the local dtpmod entry.
	(set_got_entry): Initialize the common local dtpmod .got entry.
	(elfNN_ia64_relocate_section): Handle R_IA_64_DTPREL64LSB
	and R_IA_64_DTPREL64MSB.

2003-01-16  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Include elf/ppc64.h rather than elf/ppc.h.
	(R_PPC_*): Rename all occurrences to R_PPC64_*.
	(R_PPC64_ADDR30): Rename all occurrences to R_PPC64_REL30.
	(enum elf_ppc_reloc_type): Ditto to enum elf_ppc64_reloc_type.
	(ppc64_elf_gc_sweep_hook): Handle R_PPC64_REL30 along with other
	relative relocs, not with absolute ones.
	* Makefile.am: Run "make dep-am".
	* Makefile.in: Regenerate.
	* po/SRC-POTFILES.in: Regenerate.

2003-01-15  Andreas Schwab  <schwab@suse.de>

	* elf32-ppc.c (ppc_elf_check_relocs): Don't set DF_TEXTREL for a
	relocation against a non-allocated readonly section.

2003-01-10  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_relocate_section): Adjust addend for GOT16_HA.
	* elf64-ppc.c (ppc64_elf_relocate_section): Likewise.  PLTGOT16_HA too.

2002-01-08  Klee Dienes  <kdienes@apple.com>

	* Makefile.am (ALL_MACHINES): Use cpu-msp430.lo, not cpu-msp430.c.
	(BFD32_BACKENDS): Use elf32-msp430.lo, not elf32-msp430.c.
	* Makefile.in: Regenerate.

2003-01-08  Alexandre Oliva  <aoliva@redhat.com>

	* elfn32-mips.c (prev_reloc_section): New.
	(GET_RELOC_ADDEND): Use it.  Parenthesize macro arguments.
	(SET_RELOC_ADDEND): Parenthesize macro argument.

2003-01-07  John David Anglin  <dave.anglin@nrc.gc.ca>

	* elf32-hppa.c (final_link_relocate): For all DP relative relocations,
	adjust addil instructions if the symbol has no section.

2003-01-07  DJ Delorie  <dj@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto_table): Make REL_12 not
	partial_inplace.

2003-01-07  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (elf_m68k_check_relocs): Don't set DF_TEXTREL for
	PC relative relocations.
	(elf_m68k_discard_copies): Set it here instead.

2002-01-02  Ben Elliston  <bje@redhat.com>
	    Jeff Johnston  <jjohnstn@redhat.com>

	* Makefile.am (ALL_MACHINES): Add cpu-iq2000.lo.
	(ALL_MACHINES_CFILES): Add cpu-iq2000.c.
	(BFD32_BACKENDS): Add elf32-iq2000.lo.
	(BFD32_BACKENDS_CFILES): Add elf32-iq2000.c.
	(cpu-iq2000.lo): New target.
	* Makefile.in: Regenerate.
	* config.bfd: Handle iq2000-*-elf.
	* archures.c (bfd_architecture): Add bfd_{arch,mach}_iq2000.
	(bfd_archures_list): Add bfd_iq2000_arch.
	* configure.in: Handle bfd_elf32_iq2000_vec.
	* configure: Regenerate.
	* reloc.c: Add BFD_RELOC_IQ2000_OFFSET_16, BFD_RELOC_IQ2000_OFFSET_21,
	and BFD_RELOC_IQ2000_UHI16.
	* targets.c (bfd_elf32_iq2000_vec): Declare.
	(bfd_target_vector): Add bfd_elf32_iq2000_vec.
	* elf.c (prep_headers): Set e_machine to EM_IQ2000.
	* cpu-iq2000.c: New file.
	* elf32-iq2000.c: Likewise.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Likewise.

2003-01-02  Richard Sandiford  <rsandifo@redhat.com>

	* elfxx-mips.c: Include libiberty.h.
	(elf_mips_isa, _bfd_mips_elf_mach_extends_p): Remove.
	(mips_set_isa_flags): New function, split out from...
	(_bfd_mips_elf_final_write_processing): ...here.  Only call
	mips_set_isa_flags if the EF_MIPS_MACH bits are clear.
	(mips_mach_extensions): New array.
	(mips_32bit_flags_p): New function.
	(_bfd_mips_elf_merge_private_bfd_data): Rework architecture checks.
	Use mips_32bit_flags_p to check if one binary is 32-bit and the
	other is 64-bit.  When adopting IBFD's architecture, adopt the
	bfd_mach as well as the flags.

2003-01-02  Nick Kelsey  <nickk@ubicom.com>

	* elf32-ip2k.c: Re-work of linker relaxation code for the ip2k to
	fix internal errors, fix bad code generation, fix incorrect stabs
	information, and improve ability to eliminate redundant page
	instructions. Added code to ip2k_final_link_relocate to self-verify
	the linker relaxation.  Fix formatting problems.

2002-12-30  Chris Demetriou  <cgd@broadcom.com>

	* aoutx.h (NAME(aout,machine_type)): Add bfd_mach_mipsisa32r2 case.
	* archures.c (bfd_mach_mipsisa32r2): New define.
	* bfd-in2.h: Regenerate.
	* cpu-mips.c (I_mipsisa32r2): New enum value.
	(arch_info_struct): Add entry for I_mipsisa32r2.
	* elfxx-mips.c (elf_mips_isa, _bfd_elf_mips_mach)
	(_bfd_mips_elf_print_private_bfd_data): Handle E_MIPS_ARCH_32R2.
	(_bfd_mips_elf_final_write_processing): Add
	bfd_mach_mipsisa32r2 case.
	(_bfd_mips_elf_merge_private_bfd_data): Handle merging of
	binaries marked as using MIPS32 Release 2.

2002-12-30    Dmitry Diky <diwil@mail.ru>

	* Makefile.am: Add msp430 target.
	* configure.in: Likewise.
	* Makefile.in: Regenerate.
	* configure: Regenerate.
	* archures.c: Add msp430 architecture vector.
	* config.bfd: Likewise.
	* reloc.c: Add msp430 relocs.
	* targets.c: Add msp320 target.
	* cpu-msp430.c: New file: msp430 cpu detection.
	* elf32-msp430.c: New file: msp430 reloc processing.
	* bfd-in2.h: Regenerate.
	* libbfd.h: Regenerate.

2002-12-28  Jakub Jelinek  <jakub@redhat.com>

	* elf.c (elf_sort_sections): Don't reorder .tbss.
	(assign_file_positions_for_segments): Only adjust off/voff
	for increased alignment in PT_LOAD or PT_NOTE segment,
	but adjust p_filesz for .tbss too.  in PT_LOAD consider
	.tbss to have zero memory size.
	(copy_private_bfd_data) [SECTION_SIZE]: Define.
	[IS_CONTAINED_BY_VMA, IS_CONTAINED_BY_LMA]: Use it.
	[INCLUDE_SECTION_IN_SEGMENT]: Only put SHF_TLS sections
	into PT_TLS segment.  Never put SHF_TLS sections in
	segments other than PT_TLS or PT_LOAD.

	* elf64-alpha.c (elf64_alpha_finish_dynamic_sections): Clear .plt
	sh_entsize.

2002-12-23  DJ Delorie  <dj@redhat.com>

	* coff64-rs6000.c (xcoff64_ppc_relocate_section): Fix logic reversal.

2002-12-23  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_link_output_extsym): Heed strip_discarded.

2002-12-23  Nick Clifton  <nickc@redhat.com>

	* archures.c (bfd_arch_get_compatible): Add third parameter
	'accept_unknowns'.  Only accept unknown format BFDs if
	accept_unknowns is true, or if the format is "binary".
	* bfd-in2.h: Regenerate.

2002-12-21  Nick Clifton  <nickc@redhat.com>

	* coff-arm.c (coff_arm_relocate_section): Disable WINCE workaround
	that subtracted 8 from pc relative relocations.

2002-12-20  Kazu Hirata  <kazu@cs.umass.edu>

	* coff-h8300.c: Fix comment typos.
	* coffcode.h: Likewise.
	* cpu-cris.c: Likewise.
	* elf32-vax.c: Likewise.
	* genlink.h: Likewise.
	* linker.c: Likewise.
	* som.c: Likewise.
	* tekhex.c: Likewise.
	* vms-misc.c: Likewise.

2002-12-20  DJ Delorie  <dj@redhat.com>

	* reloc.c: Add BFD_RELOC_XSTORMY16_12.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Regenerate.
	* elf32-xstormy16.c (xstormy16_elf_howto): Add R_XSTORMY16_12.
	(xstormy16_reloc_map): Add R_XSTORMY16_12.

2002-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/bfdint.texi: Fix typos.

2002-12-20  Paul Eggert  <eggert@twinsun.com>

	Port to POSIX 1003.1-2001.
	* acinclude.m4 (AM_INSTALL_LIBBFD): Do not rely on "test -o".
	* configure.in (build-warnings): Likewise.
	(Horrible hacks to build DLLs on Windows): Do not rely on "tail -1".
	* aclocal.m4: Regenerate.
	* config.in: Regenerate.
	* configure: Regenerate.

2002-12-19  Alan Modra  <amodra@bigpond.net.au>

	* coff-h8300.c: Include libiberty.h.
	(h8300_reloc16_extra_cases): Check the hash table creator before
	referencing h8300 specific fields.  Stash the hash table pointer
	in a local var.  Comment typo fixes.
	(h8300_bfd_link_add_symbols): Likewise.

	* reloc.c (struct reloc_howto_struct): Revise src_mask and
	dst_mask comments.
	* bfd-in2.h: Regenerate.

2002-12-18  Alan Modra  <amodra@bigpond.net.au>

	* elf32-ppc.c (ppc_elf_relocate_section): Reorganize dynamic reloc
	code a little.  Comment on dynamic relocs against section symbols.

2002-12-17  Roger Sayle  <roger@eyesopen.com>

	* configure.host (ia64-*-hpux*): Support 64 bit targets using
	the HP compiler's "long long".

2002-12-16  Andrew MacLeod  <amacleod@redhat.com>

	* elf32-xstormy16.c (xstormy16_elf_howto): Add R_XSTORMY16_LO16
	and R_XSTORMY16_HI16) howto entries.
	(xstormy16_reloc_map): Map R_XSTORMY16_{LO,HI}16 to BFD_RELOC_{LO,HI}16.
	(xstormy16_info_to_howto_rela): Use R_XSTORMY16_GNU_VTINHERIT to
	determine the start of the second reloc table.

2002-12-16  Nathan Tallent  <eraxxon@alumni.rice.edu>

	* ecofflink.c: Fix the reading of the debugging information
	of Tru64/Alpha binaries that are produced by recent Compaq
	compilers.
	(mk_fdrtab): Fix error in creating the FDR (file descriptor)
	table.
	(lookup_line): Because of the strange information sometimes
	generated by Compaq's recent compilers, change how the FDR
	table is searched so that PDRs (procedure descriptors) are
	correctly found.  Note that this change is really more of a hack;
	however, I have included extensive documentation as to why
	this is the best solution short of an extensive rewrite or
	another hack.
	(fdrtab_lookup): Add comments to explain the algorithm.

2002-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* elf-m10300.c (elf32_mn10300_link_hash_newfunc): Reorder
	initializers to match struct declaration.

2002-12-12  Alan Modra  <amodra@bigpond.net.au>

	* dwarf2.c (comp_unit_contains_address): Comment typo fix.
	* elf.c (get_program_header_size): Likewise.
	* elf32-m32r.c (m32r_elf_lo16_reloc): Likewise.
	(m32r_elf_generic_reloc): Likewise.
	* elf32-ppc.c (ppc_elf_howto_init): Likewise.
	* elflink.h (elf_bfd_discard_info): Likewise.

2002-12-12  Alan Modra  <amodra@bigpond.net.au>

	* elf32-i386.c (elf_i386_finish_dynamic_sections): Add output_offset
	to DT_JMPREL.  Use srelplt input section size for DT_PLTRELSZ and
	DT_RELSZ adjustment, not output section.  Avoid writing tags when
	unchanged.  Don't assume linker script is sane, adjust DT_REL too.
	* elf32-hppa.c (elf32_hppa_finish_dynamic_sections): Just use raw
	size of srelplt for DT_PLTRELSZ.  Use srelplt input section size for
	DT_RELASZ adjustment, not output section.  Avoid writing tags when
	unchanged.  Adjust DT_RELA.
	* elf64-ppc.c (ppc64_elf_finish_dynamic_sections): Tweaks for better
	formatting.  Avoid writing tags when unchanged.  Adjust DT_RELA.

2002-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (mips_elf_calculate_relocation): Don't divide
	addend by 4.

2002-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (struct mips_got_entry): New.
	(struct mips_got_info): Added got_entries field.
	(mips_elf_got_entry_hash, mips_elf_got_entry_eq): New functions.
	(mips_elf_local_got_index, mips_elf_got_page,
	mips_elf_got16_entry): Re-implement in terms of new...
	(mips_elf_create_local_got_entry): Rewrite to use got_entries.
	Change return type.
	(mips_elf_highest): Warning clean-up.
	(mips_elf_create_got_section): Initialize got_entries.
	(_bfd_mips_elf_check_relocs): Use got_entries to estimate
	local got size.
	(_bfd_mips_elf_size_dynamic_sections): Do not account for
	GOT_PAGE entries, since we now reuse GOT16 entries.

2002-12-10  Jason Thorpe  <thorpej@wasabisystems.com>

	* aoutx.h (set_section_contents): Allow an otherwise unrepresentable
	read-only section that lies after .text and before .data to be
	written into the output file and included in a_text.
	(translate_to_native_sym_flags): If an otherwise unrepresentable
	section was merged with .text, convert its symbols to N_TEXT
	symbols.
	* libaout.h (aout_section_merge_with_text_p): New macro.

2002-12-08  Alan Modra  <amodra@bigpond.net.au>

	* bfd-in.h: Comment typo fix.  Formatting.
	* bfd-in2.h: Regenerate.
	* coff64-rs6000.c (xcoff64_openr_next_archived_file): Warning fix.
	* elf32-m68hc12.c (m68hc12_elf_set_mach_from_flags): Prototype.
	* elf64-mmix.c (mmix_dump_bpo_gregs): Warning fix.

2002-12-05  Richard Henderson  <rth@redhat.com>

	* elfxx-ia64.c (elfNN_ia64_relax_section): Handle PCREL21BI.
	Only send PCREL21B though the plt.  Fix installed reloc type.
	(elfNN_ia64_relocate_section): Give error for dynamic reloc
	against PCREL22 or PCREL64I; clean up error messages for
	branch relocs.

2002-12-04  Kevin Buettner  <kevinb@redhat.com>

	* elf64-mips.c (elf64_mips_grok_prstatus, elf64_mips_grok_psinfo):
	New functions.
	(elf_backend_grok_prstatus, elf_backend_grok_psinfo): Define.

2002-12-04  David Mosberger  <davidm@hpl.hp.com>

	* cpu-ia64-opc.c: Add operand constant "ar.csd".

2002-12-04  H.J. Lu <hjl@gnu.org>

	* elfxx-ia64.c (get_local_sym_hash): Use section ID instead of
	BFD address when constructing local name.

2002-12-04  Andreas Schwab  <schwab@suse.de>

	* elf32-m68k.c (struct elf_m68k_link_hash_table): Add sym_sec
	member.
	(elf_m68k_link_hash_table_create): Initialize it.
	(elf_m68k_check_relocs): Handle symbols that are forced to be
	local due to visibility changes.
	(elf_m68k_adjust_dynamic_symbol): Likewise.
	(elf_m68k_size_dynamic_sections): Likewise.
	(elf_m68k_discard_copies): Likewise.
	(elf_m68k_relocate_section): Likewise.

2002-12-04  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_edit_opd): Correct typo.

2002-12-04  Alan Modra  <amodra@bigpond.net.au>

	* srec.c (srec_write_symbols): Restore '$' prefix to address
	accidentally removed in 2002-04-04 change.
	(srec_get_symtab): Use 0 instead of `(long) FALSE'.

2002-12-03  Nick Clifton  <nickc@redhat.com>

	* elf32-ppc.c (apuinfo_list_init): New function.
	(apuinfo_list_add): New function: Add a value to the list.
	(apuinfo_list_length): New function: Return the number of
	values on the list.
	(apuinfo_list_element): New function: Return a value on the
	list.
	(apuinfo_list_finish): New function: Free the resources used
	by the list.
	(ppc_elf_begin_write_processing): New function.  Scan the
	input bfds for apuinfo sections.
	(ppc_elf_write_section): New function: Delay the creation of
	the contents of an apuinfo section in an output bfd.
	(ppc_elf_final_write_processing): New function.  Create the
	contents of an apuinfo section in an output bfd.
	(elf_backend_begin_write_processing): Define.
	(elf_backend_final_write_processing): Define.
	(elf_backend_write_section): Define.

2002-12-03  Richard Henderson  <rth@redhat.com>

	* cpu-ia64-opc.c (elf64_ia64_operands): Add ldxmov entry.

2002-12-01  Stephane Carrez  <stcarrez@nerim.fr>

	Fix PR savannah/1417:
	* elf32-m68hc11.c (m68hc11_elf_relax_delete_bytes): Don't adjust
	branch if it goes to the start of the deleted region.

2002-12-01  Stephane Carrez  <stcarrez@nerim.fr>

	* bfd-in2.h (bfd_mach_m6812): Rebuild.
	* archures.c (bfd_mach_m6812_default, bfd_mach_m6812,
	bfd_mach_m6812s): Declare.

	* elf32-m68hc12.c (m68hc12_elf_set_mach_from_flags): New function.
	(_bfd_m68hc12_elf_set_private_flags): Call it.
	(_bfd_m68hc12_elf_print_private_bfd_data): Report processor version.
	(_bfd_m68hc12_elf_merge_private_bfd_data): Merge the flags and
	report microcontroller incompatibilities (HC12 vs HCS12).
	(elf_backend_object_p): Update.

2002-11-30  Alan Modra  <amodra@bigpond.net.au>

	* bfd-in.h (TRUE_FALSE_ALREADY_DEFINED, BFD_TRUE_FALSE): Delete.
	(enum bfd_boolean, boolean): Delete.
	(bfd_boolean): Typedef to an int.
	(FALSE, TRUE): Define.
	* aix386-core.c, aix5ppc-core.c, aout-adobe.c, aout-arm.c, aout-cris.c,
	aout-encap.c, aout-ns32k.c, aout-target.h, aout-tic30.c, aoutf1.h,
	aoutx.h, archive.c, archive64.c, archures.c, bfd-in.h, bfd.c, bfdwin.c,
	binary.c, bout.c, cache.c, cisco-core.c, coff-a29k.c, coff-alpha.c,
	coff-apollo.c, coff-arm.c, coff-aux.c, coff-h8300.c, coff-h8500.c,
	coff-i386.c, coff-i860.c, coff-i960.c, coff-ia64.c, coff-m68k.c,
	coff-m88k.c, coff-mcore.c, coff-mips.c, coff-or32.c, coff-ppc.c,
	coff-rs6000.c, coff-sh.c, coff-sparc.c, coff-stgo32.c, coff-tic30.c,
	coff-tic4x.c, coff-tic54x.c, coff-tic80.c, coff-w65.c, coff-we32k.c,
	coff-z8k.c, coff64-rs6000.c, coffcode.h, coffgen.c, cofflink.c,
	corefile.c, cpu-a29k.c, cpu-alpha.c, cpu-arc.c, cpu-arm.c, cpu-avr.c,
	cpu-cris.c, cpu-d10v.c, cpu-d30v.c, cpu-dlx.c, cpu-fr30.c, cpu-frv.c,
	cpu-h8300.c, cpu-h8500.c, cpu-hppa.c, cpu-i370.c, cpu-i386.c,
	cpu-i860.c, cpu-i960.c, cpu-ia64.c, cpu-ip2k.c, cpu-m10200.c,
	cpu-m10300.c, cpu-m32r.c, cpu-m68hc11.c, cpu-m68hc12.c, cpu-m68k.c,
	cpu-m88k.c, cpu-mcore.c, cpu-mips.c, cpu-mmix.c, cpu-ns32k.c,
	cpu-openrisc.c, cpu-or32.c, cpu-pdp11.c, cpu-pj.c, cpu-powerpc.c,
	cpu-rs6000.c, cpu-s390.c, cpu-sh.c, cpu-sparc.c, cpu-tic30.c,
	cpu-tic4x.c, cpu-tic54x.c, cpu-tic80.c, cpu-v850.c, cpu-vax.c,
	cpu-w65.c, cpu-we32k.c, cpu-xstormy16.c, cpu-z8k.c, dwarf1.c,
	dwarf2.c, ecoff.c, ecofflink.c, efi-app-ia32.c, efi-app-ia64.c,
	elf-bfd.h, elf-eh-frame.c, elf-hppa.h, elf-m10200.c, elf-m10300.c,
	elf-strtab.c, elf.c, elf32-arc.c, elf32-arm.h, elf32-avr.c,
	elf32-cris.c, elf32-d10v.c, elf32-d30v.c, elf32-dlx.c, elf32-fr30.c,
	elf32-frv.c, elf32-gen.c, elf32-h8300.c, elf32-hppa.c, elf32-hppa.h,
	elf32-i370.c, elf32-i386.c, elf32-i860.c, elf32-i960.c, elf32-ip2k.c,
	elf32-m32r.c, elf32-m68hc11.c, elf32-m68hc12.c, elf32-m68k.c,
	elf32-mcore.c, elf32-mips.c, elf32-openrisc.c, elf32-or32.c,
	elf32-pj.c, elf32-ppc.c, elf32-s390.c, elf32-sh.c, elf32-sh64-com.c,
	elf32-sh64.c, elf32-sparc.c, elf32-v850.c, elf32-vax.c,
	elf32-xstormy16.c, elf64-alpha.c, elf64-gen.c, elf64-hppa.c,
	elf64-mips.c, elf64-mmix.c, elf64-ppc.c, elf64-ppc.h, elf64-s390.c,
	elf64-sh64.c, elf64-sparc.c, elf64-x86-64.c, elfarm-nabi.c,
	elfarm-oabi.c, elfcode.h, elfcore.h, elflink.c, elflink.h,
	elfn32-mips.c, elfxx-ia64.c, elfxx-mips.c, elfxx-mips.h,
	elfxx-target.h, format.c, freebsd.h, genlink.h, hash.c, hp300hpux.c,
	hppabsd-core.c, hpux-core.c, i386aout.c, i386linux.c, i386lynx.c,
	i386mach3.c, i386msdos.c, i386os9k.c, ieee.c, ihex.c, irix-core.c,
	libaout.h, libbfd-in.h, libbfd.c, libcoff-in.h, libecoff.h, libieee.h,
	libnlm.h, liboasys.h, libpei.h, libxcoff.h, linker.c, lynx-core.c,
	m68klinux.c, m68klynx.c, mach-o.c, mach-o.h, merge.c, mipsbsd.c,
	mmo.c, netbsd-core.c, netbsd.h, nlm.c, nlm32-alpha.c, nlm32-i386.c,
	nlm32-ppc.c, nlm32-sparc.c, nlmcode.h, oasys.c, opncls.c, osf-core.c,
	pc532-mach.c, pdp11.c, pe-arm.c, pe-i386.c, pe-mcore.c, pe-mips.c,
	pe-sh.c, peXXigen.c, pef.c, pei-arm.c, pei-i386.c, pei-mcore.c,
	pei-mips.c, pei-sh.c, peicode.h, ppcboot.c, ptrace-core.c, reloc.c,
	reloc16.c, riscix.c, rs6000-core.c, sco5-core.c, section.c, simple.c,
	som.c, som.h, sparclinux.c, sparclynx.c, srec.c, stabs.c, sunos.c,
	syms.c, targets.c, tekhex.c, ticoff.h, trad-core.c, versados.c,
	vms-gsd.c, vms-hdr.c, vms-misc.c, vms-tir.c, vms.c, vms.h,
	xcoff-target.h, xcofflink.c, xsym.c, xsym.h: Replace boolean with
	bfd_boolean, true with TRUE, false with FALSE.  Simplify comparisons
	of bfd_boolean vars with TRUE/FALSE.  Formatting.
	* bfd-in2.h, libbfd.h, libcoff.h: Regenerate

2002-11-28  Alan Modra  <amodra@bigpond.net.au>

	* elf-bfd.h: Replace occurrences of Elf32_Internal_* and
	Elf64_Internal_* with Elf_Internal_*.  Replace Elf_Internal_Rel
	with Elf_Internal_Rela.
	* elf-hppa.h, elf-m10200.c, elf-m10300.c, elf32-arc.c, elf32-arm.h,
	elf32-avr.c, elf32-cris.c, elf32-d10v.c, elf32-d30v.c, elf32-dlx.c,
	elf32-fr30.c, elf32-frv.c, elf32-gen.c, elf32-h8300.c, elf32-hppa.c,
	elf32-i370.c, elf32-i386.c, elf32-i860.c, elf32-i960.c, elf32-ip2k.c,
	elf32-m32r.c, elf32-m68hc11.c, elf32-m68hc12.c, elf32-m68k.c,
	elf32-mcore.c, elf32-mips.c, elf32-openrisc.c, elf32-or32.c,
	elf32-ppc.c, elf32-s390.c, elf32-sh.c, elf32-v850.c, elf32-vax.c,
	elf32-xstormy16.c, elf64-alpha.c, elf64-gen.c, elf64-hppa.c,
	elf64-mips.c, elf64-mmix.c, elf64-ppc.c, elf64-s390.c, elf64-sh64.c,
	elf64-sparc.c, elf64-x86-64.c, elfarm-nabi.c, elfarm-oabi.c,
	elfcode.h, elflink.h, elfn32-mips.c, elfxx-ia64.c, elfxx-mips.c: Ditto.
	* elf-hppa.h (elf_hppa_internal_shdr): Delete.  Use Elf_Internal_Shdr
	throughout instead.
	* elf.c (_bfd_elf_no_info_to_howto_rel): Delete.
	* elfcode.h (elf_swap_reloca_in): Pass source operand as a bfd_byte *.
	Remove INLINE keyword.
	(elf_swap_reloc_in): Likewise.  Also clear r_addend.
	(elf_swap_reloc_out, elf_swap_reloca_out): Pass destination operand
	as a bfd_byte *.
	(elf_write_relocs): Consolidate REL and RELA code.
	(elf_slurp_reloc_table_from_section): Simplify REL code.
	(NAME(_bfd_elf,size_info)): Populate reloc swap entries.
	* elf-bfd.h (MAX_INT_RELS_PER_EXT_REL): Define.
	* elflink.h (elf_link_read_relocs_from_section): Consolidate REL and
	RELA code.
	(elf_link_adjust_relocs): Likewise.  Don't malloc space for temp
	reloc array, use a fixed size of MAX_INT_RELS_PER_EXT_REL.
	(elf_link_output_relocs): Likewise.
	(elf_reloc_link_order): Likewise.
	(elf_finish_pointer_linker_section): Likewise.
	(struct elf_link_sort_rela): Remove union.
	(elf_link_sort_cmp1): Update to suit.
	(elf_link_sort_cmp2): Here too.
	(elf_link_sort_relocs): Consolidate REL and RELA code.  Fix memory
	over-allocation for int_rels_per_ext_rel != 1 case.
	* elf32-arm.h: Update all bfd_elf32_swap_reloc_out calls.
	* elf32-i386.c: Likewise.
	* elf32-cris.c: Likewise for bfd_elf32_swap_reloca_out.
	* elf32-hppa.c, elf32-i370.c, elf32-m68k.c, elf32-ppc.c, elf32-s390.c,
	elf32-sh.c, elf32-vax.c, elfxx-mips.c: Likewise.
	* elf64-alpha.c: Likewise for bfd_elf64_swap_reloca_out.
	* elf64-hppa.c, elf64-mips.c, elf64-ppc.c, elf64-s390.c, elf64-sh64.c,
	elf64-sparc.c, elf64-x86-64.c: Likewise.
	* elfxx-ia64.c: Likewise for bfd_elfNN_swap_reloca_out.
	* elfxx-mips.c (sort_dynamic_relocs): Likewise for
	bfd_elf32_swap_reloc_in.

	* elf32-arm.h: Update elf32_arm_info_to_howto calls.
	* elf32-mips.c: Likewise for mips_info_to_howto_rel.
	(mips_elf64_swap_reloc_in): Zero r_addend.
	(mips_elf64_be_swap_reloc_in): Likewise.
	(mips_elf64_slurp_one_reloc_table): Simplify.

	* elf64-alpha.c (alpha_elf_size_info): Populate reloc swap entries.
	* elf64-hppa.c (hppa64_elf_size_info): Likewise.
	* elf64-sparc.c (sparc64_elf_size_info): Likewise.

2002-11-28  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf32-sh.c (sh_elf_relocate_section): Don't complain about
	unresolved debugging relocs in dynamic applications.
	* elf64-sh64.c (sh_elf64_relocate_section): Likewise.

2002-11-26  Alan Modra  <amodra@bigpond.net.au>

	* elf-eh-frame.c (ENSURE_NO_RELOCS): Disregard R_*_NONE relocs.
	(_bfd_elf_discard_section_eh_frame): Don't discard duplicate CIEs
	on a relocatable link.  Comment typos.
	* elf.c (_bfd_elf_link_hash_newfunc): Assign elements of structure
	in the order they are declared.  Clear elf_hash_value too.
	(_bfd_elf_link_hash_table_init): Likewise assign in order.  Clear
	eh_info and tls_segment.
	* elflink.h (elf_link_input_bfd <emit_relocs>): Keep reloc offsets
	sorted when discarding relocs by turning them into R_*_NONE.

	* libbfd.c (warn_deprecated): Comment spelling.
	* po/SRC-POTFILES.in: Regenerate.

2002-11-21  Richard Henderson  <rth@redhat.com>

	* elflink.h (elf_link_add_object_symbols): Don't overwrite the
	arch's st_other bits when merging visibilities.
	(elf_link_output_extsym): Tidy clearing of visibility field.

2002-11-21  Alan Modra  <amodra@bigpond.net.au>

	* coff-mcore.c (SWAP_IN_RELOC_OFFSET): Define.
	(SWAP_OUT_RELOC_OFFSET): Define.

2002-11-20  Alexandre Oliva  <aoliva@redhat.com>

	* elf.c (_bfd_elf_link_hash_table_init): Make sure
	can_refcount is properly extended to the type of
	init_refcount.

2002-11-19  Alexandre Oliva  <aoliva@redhat.com>

	* elfxx-mips.c (MIPS_RELOC_RELA_P): New macro.
	(_bfd_mips_elf_relocate_section): Use it.

	* elfxx-mips.c (MNAME): New macro.
	(_bfd_mips_elf_check_relocs): Use it.
	(_bfd_mips_elf_discard_info): Likewise.
	(_bfd_mips_elf_final_link): Likewise.

2002-11-19  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c (ppc64_elf_edit_opd): When deleting relocs, adjust
	rel_hdr.sh_size too.

2002-11-18  Klee Dienes  <kdienes@apple.com>

	* Makefile.am (BFD32_LIBS): Add bfdwin.lo, bfdio.lo.
	(BFD32_LIBS_CFILES): Add bfdwin.c, bfdio.c.
	(BFD_H_FILES): Add bfdwin.c, bfdio.c.
	(LIBBFD_H_FILES): Add bfdwin.c, bfdio.c.
	Add dependencies for bfdwin.c, bfdio.c.
	* bfd.c: Remove bfd_get_mtime, bfd_get_size.
	* libbfd.c: Remove real_read, bfd_bread, _bfd_window_internal,
	bfd_init_window, bfd_free_window, bfd_get_file_window, bfd_bwrite,
	bfd_tell, bfd_flush, bfd_stat, bfd_seek.
	* bfdio.c: New file.  Contains real_read, bfd_bread, bfd_write,
	bfd_tell, bfd_flush, bfd_stat, bfd_seek, bfd_ge_mtime,
	bfd_get_size (moved from libbfd.c and bfd.c).
	* bfdwin.c New file.  Contains _bfd_window_internal,
	bfd_init_window, bfd_free_window, bfd_get_file_window (moved from
	libbfd.c and bfd.c).
	* po/SRC-POTFILES.in: Regenerate.
	* po/bfd.pot: Regenerate.
	* libbfd.h: Regenerate.
	* bfd-in2.h: Regenerate.
	* aclocal.m4: Regenerate.
	* Makefile.in: Regenerate.
	* configure: Regenerate.

2002-11-18  Klee Dienes  <kdienes@apple.com>

	* bfd.c (bfd_preserve_save): Don't zero BFD_IN_MEMORY.

2002-11-15  Kazu Hirata  <kazu@cs.umass.edu>

	* coff-h8300.c (h8300_reloc16_estimate): Do not optimize away
	jsr after a short jump.
	* elf32-h8300.c (elf32_h8_relax_section): Likewise.

2002-11-15  Klee Dienes  <kdienes@apple.com>

	* pef.c (bfd_pef_convert_architecture): Move declaration of
	ARCH_POWERPC and ARCH_M68K to the start of the function.

2002-11-14  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* coff-tic4x.c (tic4x_howto_table): Formatting fixup

2002-11-14  Hans-Peter Nilsson  <hp@bitrange.com>

	* elf64-mmix.c (_bfd_mmix_finalize_linker_allocated_gregs):
	For bpo_gregs_section->contents, allocate _raw_size, not
	_cooked_size.

2002-11-13  Klee Dienes  <kdienes@apple.com>

	* config.bfd: Add entries for powerpc-*-darwin and cousins.

2002-11-13  H.J. Lu <hjl@gnu.org>

	* elfcode.h (elf_object_p): Don't restore abfd->arch_info.

2002-11-13  Klee Dienes  <kdienes@apple.com>
	    Alan Modra  <amodra@bigpond.net.au>

	* bfd.c (struct bfd_preserve): New.
	(bfd_preserve_save): New function.
	(bfd_preserve_restore): Ditto.
	(bfd_preserve_finish): Ditto.
	* bfd-in2.h: Regenerate.
	* mach-o.c: Formatting.
	(bfd_mach_o_scan_read_symtab_symbol): Make "value" unsigned.
	(bfd_mach_o_object_p): Use bfd_preserve_save/restore/finish.
	(bfd_mach_o_core_p): Ditto.
	(bfd_mach_o_scan): Pass in mdata.
	* mach-o.h (bfd_mach_o_scan): Update prototype.
	* pef.c: Formatting.
	(bfd_pef_object_p): Use bfd_preserve_save/restore/finish.
	(bfd_pef_xlib_object_p): Ditto.
	(bfd_pef_scan): Pass in mdata.  Move version check to bfd_pef_object_p.
	* pef.h (bfd_pef_scan): Update prototype.
	* xsym.c: Formatting, K&R fixes.
	(bfd_sym_object_p): Use bfd_preserve_save/restore/finish.
	(bfd_sym_scan): New function split out from bfd_sym_object_p.
	* xsym.h (bfd_sym_scan): Declare.
	* elfcode.h (elf_object_p): Use bfd_preserve_save/restore/finish.
	* elfcore.h (elf_core_file_p): Likewise.
	* targets.c (_bfd_target_vector): Revert 2002-11-08 change.

2002-11-12  Nick Clifton  <nickc@redhat.com>

	* po/da.po: Updated Danish translation.

2002-11-12  Alan Modra  <amodra@bigpond.net.au>

	* elflink.h (elf_link_add_object_symbols): Optimize stabs for
	relocatable link too.
	(elf_link_input_bfd): When emitting relocs, adjust offsets for
	eh_frame and stab sections.  Zap deleted relocs.
	(elf_reloc_symbol_deleted_p): Return true for zero r_symndx.
	(elf_bfd_discard_info): Run for relocatable link too.
	* elf64-ppc.c (ppc64_elf_edit_opd): Rename from edit_opd.  Make global.
	Handle ld -r case.
	(ppc64_elf_size_dynamic_sections): Don't call edit_opd from here.
	* elf64-ppc.h (ppc64_elf_edit_opd): Declare.

	* elf-bfd.h (struct cie_header): Move from elf_eh-frame.c.
	(struct cie, struct eh_cie_fde, struct eh_frame_sec_info): Likewise.
	(struct eh_frame_array_ent, struct eh_frame_hdr_info): Likewise.
	(enum elf_link_info_type): Remove ELF_INFO_TYPE_EH_FRAME_HDR.
	(struct eh_frame_hdr_info): Add "hdr_sec", remove "split".
	(struct elf_link_hash_table): Add eh_info.
	(struct elf_obj_tdata): Change eh_frame_hdr to an asection *.
	(_bfd_elf_discard_section_eh_frame): Update prototype.
	(_bfd_elf_discard_section_eh_frame_hdr): Likewise.
	(_bfd_elf_write_section_eh_frame): Likewise.
	(_bfd_elf_write_section_eh_frame_hdr): Likewise.
	* elf-eh-frame.c (_bfd_elf_discard_section_eh_frame): Remove "ehdrsec"
	param.  Get "hdr_info" from link hash table.
	(_bfd_elf_discard_section_eh_frame_hdr): Remove "sec" param.  Get
	header section from link hash table.  Save header section to elf_tdata.
	(_bfd_elf_maybe_strip_eh_frame_hdr): Remove local "sec".  Use
	header section from link hash table.  Don't alloc hdr_info.  Clear
	hdr_sec instead of setting "strip".
	(_bfd_elf_eh_frame_section_offset): Formatting.
	(_bfd_elf_write_section_eh_frame): Remove "ehdrsec", add "info" param.
	Get header section from link hash table.
	(_bfd_elf_write_section_eh_frame_hdr): Remove "sec", add "info" param.
	Get header section from link hash table.
	* elf.c (map_sections_to_segments): Use cached eh_frame_hdr.
	(get_program_header_size): Likewise.
	(_bfd_elf_section_offset): Formatting.
	* elflink.h (elf_link_create_dynamic_sections): Stash eh frame header
	section pointer in link hash table.
	(elf_bfd_final_link): Adjust _bfd_elf_write_section_eh_frame_hdr
	and _bfd_elf_write_section_eh_frame calls.  Update comment about
	eh_frame entries.
	(elf_bfd_discard_info): Adjust _bfd_elf_discard_section_eh_frame and
	_bfd_elf_discard_section_eh_frame_hdr calls.  Remove "ehdr".

	* po/SRC-POTFILES.in: Regenerate.

	* elf-eh-frame.c (_bfd_elf_discard_section_eh_frame): Don't zero
	relocs for discarded FDEs.  Remove dead code.
	(_bfd_elf_write_section_eh_frame_hdr): Remove dead code.
	* elflink.h (elf_bfd_discard_info): Don't save edited relocs.
	Tidy conditions under which stabs are edited.  Formatting.
	* elf64-sparc.c (sparc64_elf_relocate_section): Ignore overflows
	from discarded relocs.
	* elfxx-ia64.c (elfNN_ia64_install_dyn_reloc): Add reloc output
	section adjustments after testing magic values.

2002-11-12  Thomas Moestl <tmm@FreeBSD.org>

	* elf64-sparc.c (sparc64_elf_adjust_dynamic_symbol): Correct
	references to large plt symbols.

2002-11-12  Klee Dienes  <kdienes@apple.com>

	* mach-o.c (bfd_mach_o_scan_read_thread): Don't re-use 'i' when
	looking for an unused section name.

2002-11-11  Kazu Hirata  <kazu@cs.umass.edu>

	* coff-h8300.c: Fix formatting.
	* elf32-h8300.c: Likewise.
	* reloc16.c: Likewise.

2002-11-09  Jeroen Dobbelaere  <jeroen.dobbelaere@acunia.com>

	* elf32-arm.h (elf32_arm_size_dynamic_sections): Don't strip output
	section when dynamic section unused;  _bfd_strip_section_from_output
	instead.

2002-11-08  Alan Modra  <amodra@bigpond.net.au>

	* targets.c (_bfd_target_vector): Disable pef_vec, pef_xlib_vec
	and sym_vec.

	* dwarf2.c: Revert last change.

2002-11-07  Michal Ludvig  <mludvig@suse.cz>

	* dwarf2.c (read_indirect_string, read_abbrevs, decode_line_info,
	_bfd_dwarf2_find_nearest_line): Use
	bfd_simple_get_relocated_section_contents() instead of
	bfd_get_section_contents().
	* reloc.c (bfd_perform_relocation): Add sanity check.
	* simple.c (simple_get_relocated_section_contents): If the section
	does not have any relocs associated with it, just return the
	unadjusted contents.

2002-11-07  Hans-Peter Nilsson  <hp@axis.com>

	* elf32-cris.c (cris_elf_relocate_section) <case R_CRIS_16_GOT,
	case R_CRIS_32_GOT>: Correct test for filling in constant .got
	contents, enabling for a non-DSO, for symbols defined in the
	program with --export-dynamic.

2002-11-07  Alan Modra  <amodra@bigpond.net.au>

	* elf64-ppc.c: Comment typo fixes.
	(ppc64_elf_merge_private_bfd_data): Allow BFD_ENDIAN_UNKNOWN input.

2002-11-07  Nick Clifton  <nickc@redhat.com>

	* po/da.po: Updated Danish translation.

2002-11-06  Alexandre Oliva  <aoliva@redhat.com>

	* elf64-mips.c (mips_elf64_slurp_one_reloc_table): Generate
	exactly three internal relocs per external reloc.  Set reloc_count
	to the external reloc count.

2002-11-06  Klee Dienes  <kdienes@apple.com>

	 * coff-stgo32.c (stub_bytes): Mark as const.
	 Fix comment formatting.

2002-11-06  Klee Dienes  <kdienes@apple.com>

	* Makefile.am (BFD32_BACKENDS): Add mach-o.lo, pef.lo, and
	xsym.lo.
	(BFD32_BACKENDS_CFILES): Add mach-o.c, pef.c, and xsym.c.
	(SOURCE_HFILES): Add mach-o.h, pef.h, pef-traceback.h, xsym.h
	* archures.c (enum bfd_architecture): Add bfd_arch_m98k.
	* bfd.c (struct bfd): Add private data for mach-o, pef, and sym.
	* targets.c (enum bfd_flavour): Add flavours for mach-o, pef, and
	sym.
	(_bfd_target_vector): Add target vectors for mach-o, pef, and sym.
	* Makefile.in: Regenerate.
	* doc/Makefile.in: Regenerate.
	* bfd-in2.h: Regenerate.
	* xsym.c: New file.  Contains support for the Apple/Metrowerks
	xSYM debugging format.
	* xsym.h: New file.
	* pef.c: New file.  Contains support for the Apple Code Fragment
	Manager Preferred Executable Format
	* pef.h: New file.
	* pef-traceback.h: New file.  Contains support for parsing PowerPC
	traceback tables as used by PEF executables (and perhaps other
	systems as well).
	* mach-o.c: New file.  Contains support for the Mach-O object file
	format.
	* mach-o.h: New file.
	* mach-o-target.c: New file.  Declares the mach-o targets
	themselves.  Included three times by mach-o.c; each time with a
	different set of macros set.

2002-11-06  Graeme Peterson  <gp@qnx.com>

	* Makefile.am: Remove entries for elf32-qnx.[ch].
	* Makefile.in: Regenerate.
	* config.bfd: Change arm-nto to use bfd_elf32_{big|little}arm_vec,
	ppc-nto to use bfd_elf32_powerpc{le}_vec, sh-nto to use
	bfd_elf32_sh{l}_vec, and i386-nto to use bfd_elf32_i386_vec.
	* configure.in: Remove support for bfd_elf32_sh{l}qnx_vec,
	bfd_elf32_powerpc{le}qnx_vec, bfd_elf32_{big|little}armqnx_vec,
	and bfd_elf32_i386qnx_vec, and removed elf32-qnx.lo from other targets.
	bfd_elf32_sh{l}_vec, and i386-nto to use bfd_elf32_i386_vec.
	* configure: Regenerate.
	* elf32-qnx.c: Remove.
	* elf32-qnx.h: Remove.
	* elf.c: Remove calls to QNX specific set_nonloadable_filepos,
	is_contained_by_filepos, and copy_private_bfd_data_p.
	* elf-bfd.h (struct elf_backend_data): Remove set_nonloadable_filepos,
	is_contained_by_filepos, and copy_private_bfd_data_p.
	* elf32-i386.c: Remove QNX extended bfd support.
	* elf32-ppc.c: Remove QNX extended bfd support.
	* elf32-sh.c: Remove QNX extended bfd support.
	* elfarm-nabi.c: Remove QNX extended bfd support.
	* targets.c: Remove qnx vectors.
	* elfxx-target.h (elf_backend_set_nonloadable_filepos): Remove
	(elf_backend_is_contained_by_filepos): Remove.
	(elf_backend_copy_private_bfd_data_p): Remove.
	* po/SRC-POTFILES.in: Regenerate.

2002-11-06  David O'Brien  <obrien@FreeBSD.org>
	    Alan Modra  <amodra@bigpond.net.au>

	* elf64-sparc.c (sparc64_elf_relocate_section): Adjust addend of
	dynamic relocs against section symbols for the output section vma.

2002-11-05  Alan Modra  <amodra@bigpond.net.au>

	* elf32-arm.h (t2a1_push_insn, t2a2_ldr_insn, t2a3_mov_insn,
	t2a4_bx_insn, t2a5_pop_insn, t2a6_bx_insn): Remove.

2002-11-05  Kaz Kojima  <kkojima@rr.iij4u.or.jp>
	    Alan Modra  <amodra@bigpond.net.au>

	* config.bfd (sh-*-linux*): Use bfd_elf*_sh64*lin_vec as sh64
	vectors in target_selvecs.
	(shle-*-netbsdelf*): Use bfd_elf*_sh64*nbsd_vec as sh64 vectors
	in target_selvecs.
	(sh-*-netbsdelf*): Likewise.
	* configure.in (assocvecs): New variable.  Handle assocvecs like
	selvecs.
	* configure: Regenerate.
	* format.c (bfd_check_format_matches): Store bfd_target pointers
	in matching_vector instead of target names.  Select first target
	from bfd_associated_vector that matches a list of ambiguous targets.
	* targets.c (_bfd_associated_vector): New array.
	(bfd_associated_vector): New variable.
	(_bfd_target_vector): Add bfd_elf*_sh64*lin_vec.
	* libbfd-in.h (bfd_associated_vector): Declare.
	* libbfd.h: Regenerate.

2002-11-05  Elias Athanasopoulos  <eathan@otenet.gr>

	* vms-gsd.c (_bfd_vms_write_gsd): Check that symbol->udata.p is
	non-NULL before dereferencing.

2002-11-04  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* vms.c (vms_object_p): Restore the start address when returning
	NULL.

2002-11-04  Alan Modra  <amodra@bigpond.net.au>
	    Hans-Peter Nilsson  <hp@axis.com>

	* elflink.h (struct elf_final_link_info): Add shndxbuf_size.
	(elf_bfd_final_link): Don't bother zeroing symtab_hdr fields.
	Set up a larger symshndxbuf, and write it out.  Free it on
	exit rather than freeing symbuf twice.  Correct section index
	on output section symbol loop.
	(elf_link_output_sym): Accumulate symbol extension section
	indices, reallocating symshndxbuf rather than writing it out.
	(elf_link_flush_output_syms): Don't flush symshndxbuf.
	* elf.c (assign_section_numbers): Init i_shdrp to all zero.
	Use bfd_zalloc to clear i_shdrp[0] too.

2002-11-03  Stephen Clarke <stephen.clarke@earthling.net>

	 * elf32-sh64-com.c (sh64_address_in_cranges): Use
	_raw_size of cranges section if _cooked_size not yet set.

2002-11-03  Hans-Peter Nilsson  <hp@axis.com>

	* elf32-v850.c (v850_elf_relax_delete_bytes): Correct parameters
	for bfd_elf32_swap_symbol_out.

2002-10-31  David O'Brien  <obrien@FreeBSD.org>

	* elf-eh-frame.c (_bfd_elf_discard_section_eh_frame): Don't mix
	signed and unsigned in comparison.

2002-10-30  Daniel Jacobowitz  <drow@mvista.com>

	* coffcode.h: Remove extraneous '\'.

2002-10-28  H.J. Lu <hjl@gnu.org>

	* Makefile.am (targets.lo): Depend on Makefile instead of
	config.status.
	(archures.lo): Likewise.
	* Makefile.in: Regenerated.

2002-10-25  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.bfd (mips*el-*-netbsd*, mips*-*-netbsd*): Add
	bfd_elf64_bigmips_vec and bfd_elf64_littlemips_vec to
	targ_selvecs.

2002-10-25  Jim Wilson  <wilson@redhat.com>

	* elf64-sh64.c (sh_elf64_relocate_section): Call
	_bfd_elf_rela_local_sym.  Handle relocs against STT_SECTION symbol
	of SHF_MERGE section.

